// CEClient.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "Winsock2.h" // WINSOCK
#include "Commctrl.h"
#include <string.h>
#include <stdio.h>
#include "..\Server.h"


#define MAX_LOADSTRING 100


// Global Variables:
HINSTANCE   hInst;							// current instance
char        szTitle[MAX_LOADSTRING];		// The title bar text
char        szWindowClass[MAX_LOADSTRING];	// The title bar text
SOCKET      g_socket = 0;                   // Communication socket
struct      sockaddr_in g_sa;               // Contains IP settings
HWND        hStatus;                        // Handle to status window
EventInfo*  pEvents = 0;                    // Pointer to array of event objects
StatusInfo* pStatus = 0;                    // Pointer to array of status objects
int         nEvents = 0;                    // Number of objects in event array
BYTE        nStatus = 0;                    // Number of objects in status array
HWND        hWndEventListView = 0;          // Handle to event list window
HWND        hWndStatusListView = 0;         // Handle to status list window
WORD        StatusBarHeight = 0;            // Height of status bar
HWND        hMainWnd;                       // Handle to main window

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

LRESULT CALLBACK ConnectDlgProc(HWND, UINT, WPARAM, LPARAM);
void Connect();
void Disconnect();
void StopLogging();
void StartLogging();
void ReceiveFile(char*);
void DeleteAll();
void TransferAll();
VOID CreateDateAndTimeString(PCHAR, SYSTEMTIME*);

// Event vindow
HWND CreateEventListView(HWND);
BOOL InitEventListViewColumns(HWND);
BOOL InitEventListViewContent(HWND);
void GetFileList();

// Status info 
HWND    CreateStatusListView(HWND);
BOOL    InitStatusListViewColumns(HWND);
BOOL    InitStatusListViewContent(HWND);
void    GetStatusInfo();

/**
 * Initializes the headers of the status list view
 */

BOOL InitStatusListViewColumns(HWND hWndListView)
{
	char szHeader[256];
	LVCOLUMN lvc;

	memset(&lvc, 0, sizeof(lvc));

	lvc.mask = LVCF_TEXT | LVCF_SUBITEM | LVCF_WIDTH | LVCF_FMT;
	lvc.pszText = szHeader;
	lvc.fmt = LVCFMT_CENTER;

	// Channel Number
	lvc.cx = 60;
	LoadString (hInst, IDS_LOGICAL_CH_NR, szHeader, sizeof(szHeader));
	if (ListView_InsertColumn(hWndListView, 0, &lvc) == -1) return FALSE;

	// Station code
	lvc.cx = 60;
	LoadString (hInst, IDS_STATION_CODE, szHeader, sizeof(szHeader));
	if (ListView_InsertColumn(hWndListView, 1, &lvc) == -1) return FALSE;

	// Component
	lvc.cx = 60;
	LoadString (hInst, IDS_COMPONENT, szHeader, sizeof(szHeader));
	if (ListView_InsertColumn(hWndListView, 2, &lvc) == -1) return FALSE;

	// InLEDStatus
	lvc.cx = 60;
	LoadString (hInst, IDS_IN_LED_STATUS, szHeader, sizeof(szHeader));
	if (ListView_InsertColumn(hWndListView, 3, &lvc) == -1) return FALSE;

	// DiskLEDStatus
	lvc.cx = 60;
	LoadString (hInst, IDS_DISK_LED_STATUS, szHeader, sizeof(szHeader));
	if (ListView_InsertColumn(hWndListView, 4, &lvc) == -1) return FALSE;

	// TrigLEDStatus
	lvc.cx = 60;
	LoadString (hInst, IDS_TRIG_LED_STATUS, szHeader, sizeof(szHeader));
	if (ListView_InsertColumn(hWndListView, 5, &lvc) == -1) return FALSE;

	// SyncLEDStatus
	lvc.cx = 60;
	LoadString (hInst, IDS_SYNC_LED_STATUS, szHeader, sizeof(szHeader));
	if (ListView_InsertColumn(hWndListView, 6, &lvc) == -1) return FALSE;


	// Time tag
	lvc.cx = 140;
	LoadString (hInst, IDS_TIME_TAG, szHeader, sizeof(szHeader));
	if (ListView_InsertColumn(hWndListView, 7, &lvc) == -1) return FALSE;
	
	// Sample
	lvc.cx = 60;
	LoadString (hInst, IDS_SAMPLE, szHeader, sizeof(szHeader));
	if (ListView_InsertColumn(hWndListView, 8, &lvc) == -1) return FALSE;

	// STA
	lvc.cx = 60;
	LoadString (hInst, IDS_STA, szHeader, sizeof(szHeader));
	if (ListView_InsertColumn(hWndListView, 9, &lvc) == -1) return FALSE;

	// LTA
	lvc.cx = 60;
	LoadString (hInst, IDS_LTA, szHeader, sizeof(szHeader));
	if (ListView_InsertColumn(hWndListView, 10, &lvc) == -1) return FALSE;

	return TRUE;

}

/**
 * Initializes the content of the status list view
 */

BOOL InitStatusListViewContent(HWND hWndListView)
{
	char strTemp[256];
	char* pInCodes[] = {"Inactive", "Receving", "Error"};
	char* pDiskCodes[] = {"Inactive", "Writing", "Error"};
	char* pTrigCodes[] = {"Inactive", "Trigging"};
	char* pSncCodes[] = {"N/A", "Inactive", "OK", "Error"};
	char* strNA = "N/A";

	LVITEM lvI;
	memset(&lvI, 0, sizeof(lvI));

	lvI.mask = LVIF_DI_SETITEM | LVIF_TEXT;
	lvI.state = 0;
	lvI.stateMask = 0;
	lvI.iSubItem = 0;
	lvI.pszText = strTemp;

	for (int k = 0; k < nStatus; k++)
	{
		lvI.iItem = k;

		// Channel number
		lvI.iSubItem = 0;
		lvI.pszText = pStatus[k].ChannelName + 7;
		if (ListView_InsertItem(hWndListView, &lvI) == -1) return FALSE;

		// Station code
		lvI.iSubItem = 1;
		//strcpy(strTemp, pStatus[k].StationCode);
		lvI.pszText =  pStatus[k].StationCode;
		if (ListView_SetItem(hWndListView, &lvI) == -1) return FALSE;

		// Component
		lvI.iSubItem = 2;
		lvI.pszText = pStatus[k].Component;
		if (ListView_SetItem(hWndListView, &lvI) == -1) return FALSE;

		//InLEDStatus
		lvI.iSubItem = 3;
		lvI.pszText = pInCodes[pStatus[k].InLEDStatus];
		if (ListView_SetItem(hWndListView, &lvI) == -1) return FALSE;

		// DiskLEDStatus

		lvI.iSubItem = 4;

		if (pStatus[k].LogToDisk)
		{
			lvI.pszText = pDiskCodes[pStatus[k].DiskLEDStatus];
		}
		else
		{
			lvI.pszText = strNA;
		}
		if (ListView_SetItem(hWndListView, &lvI) == -1) return FALSE;

		// TrigLEDStatus

		lvI.iSubItem = 5;

		if (pStatus[k].UseTrigging)
		{
			
			lvI.pszText = pTrigCodes[pStatus[k].TrigLEDStatus];
		}
		else
		{
			lvI.pszText = strNA;

		}
		if (ListView_SetItem(hWndListView, &lvI) == -1) return FALSE;

		// SyncLEDStatus
		lvI.iSubItem = 6;
		lvI.pszText = pSncCodes[pStatus[k].SyncLEDStatus];
		if (ListView_SetItem(hWndListView, &lvI) == -1) return FALSE;

		// Time tag
		lvI.iSubItem = 7;
        lvI.pszText = pStatus[k].TimeTag;
		if (ListView_SetItem(hWndListView, &lvI) == -1) return FALSE;

		// Sample
		lvI.iSubItem = 8;
        sprintf(strTemp, "%11d", pStatus[k].Sample);
		lvI.pszText = strTemp;
		if (ListView_SetItem(hWndListView, &lvI) == -1) return FALSE;

		// STA
		lvI.iSubItem = 9;
		
		if (pStatus[k].UseTrigging)
		{
			lvI.pszText = strTemp;
			sprintf(strTemp, "%11.1f", pStatus[k].STA);
		}
		else
		{
			lvI.pszText = strNA;
		}

		if (ListView_SetItem(hWndListView, &lvI) == -1) return FALSE;

		// LTA
		lvI.iSubItem = 10;
		
		if (pStatus[k].UseTrigging)
		{

			lvI.pszText = strTemp;
			lvI.pszText = strTemp;
			sprintf(strTemp, "%11.1f", pStatus[k].LTA);

		}
		else
		{
			lvI.pszText = strNA;
		}

		if (ListView_SetItem(hWndListView, &lvI) == -1) return FALSE;

		
	



	}
	return TRUE;
}

/**
 * Creates a list view window for the Seislog status window
 */

HWND CreateStatusListView(HWND hWndParent)
{

	RECT rcl;
	INITCOMMONCONTROLSEX icex;
	HWND hWndListView;

	// Ensure the commmon control DLL is loaded

	icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icex.dwICC  = ICC_LISTVIEW_CLASSES;
	InitCommonControlsEx(&icex);

	// Create the list view window in the report view

	GetClientRect(hWndParent, &rcl);
	hWndListView = CreateWindow(WC_LISTVIEW, "", WS_CHILD | LVS_REPORT,
		0, 0,
		rcl.right - rcl.left, (rcl.bottom - rcl.top - StatusBarHeight) / 2,
		hWndParent, (HMENU) IDC_CECLIENT, hInst, NULL);


	if (NULL == hWndListView)
		return NULL;

	ShowWindow(hWndListView, SW_SHOW);
	UpdateWindow(hWndListView);

	return hWndListView;
}

/**
 * Retrieves status information from the PocketPC
 */

void GetStatusInfo()
{
	if (pStatus != 0)
	{
		delete[] pStatus;
		pStatus = 0;
		nStatus = 0;
	}

	ListView_DeleteAllItems(hWndStatusListView);

	// Send get status message to server
	char szCmdLine[CMD_STRING_LENGTH];
	char szAck[] = ACKNOWLEDGE;
	strcpy(szCmdLine, CMD_GET_STATUS);
	send(g_socket, (char*) szCmdLine, CMD_STRING_LENGTH, 0);

	// Wait for number of channels
	recv(g_socket, (char*) &nStatus, sizeof(nStatus), 0);

	// Send acknowledge
	send(g_socket, szAck, strlen(szAck), 0);

	if (nStatus > 0)
	{
		// Allocate memory for status info

		pStatus = new StatusInfo[nStatus];

		// Receive status info

		recv(g_socket, (char*) pStatus, nStatus*sizeof(StatusInfo), 0);

	}

	//pStatus[0];

	InitStatusListViewContent(hWndStatusListView);
	
}

/**
 * Tells the PocketPC to stop logging (The "File|Start System" command)
 */

void StopLogging()
{
	// Send start message to server
	char szCmdLine[CMD_STRING_LENGTH];
	char szAck[] = ACKNOWLEDGE;

	strcpy(szCmdLine, CMD_STOP_LOGGING);

	// Send start command
	send(g_socket, (char*) szCmdLine, CMD_STRING_LENGTH, 0);

	// Wait for ack
	recv(g_socket, szAck, strlen(szAck), 0);

	Sleep(1000);

}

/**
 * Tells the PocketPC to start logging (The "File|Start System" command)
 */

void StartLogging()
{
	// Send start message to server
	char szCmdLine[CMD_STRING_LENGTH];
	char szAck[] = ACKNOWLEDGE;

	strcpy(szCmdLine, CMD_START_LOGGING);

	// Send start command
	send(g_socket, (char*) szCmdLine, CMD_STRING_LENGTH, 0);

	// Wait for ack
	recv(g_socket, szAck, strlen(szAck), 0);

	Sleep(1000);

}

/**
 * Initializes the headers of the status list view
 */

BOOL InitEventListViewColumns(HWND hWndListView)
{
	char szHeader[256];
	LVCOLUMN lvc;

	memset(&lvc, 0, sizeof(lvc));

	lvc.mask = LVCF_TEXT | LVCF_SUBITEM | LVCF_WIDTH;
	lvc.pszText = szHeader;

	// First column
	lvc.iSubItem = 0;
	lvc.cx = 140;
	LoadString (hInst, IDS_SFILENAME, szHeader, sizeof(szHeader));
	if (ListView_InsertColumn(hWndListView, 0, &lvc) == -1) return FALSE;

	// Second column
	lvc.iSubItem = 1;
	lvc.cx = 240;
	LoadString (hInst, IDS_WAVEFILENAME, szHeader, sizeof(szHeader));
	if (ListView_InsertColumn(hWndListView, 1, &lvc) == -1) return FALSE;
	
	return TRUE;

}

/** 
 * Initializes the content of the event listview
 */

BOOL InitEventListViewContent(HWND hWndListView)
{
	LVITEM lvI;

	lvI.mask = LVIF_DI_SETITEM | LVIF_TEXT;
	lvI.state = 0;
	lvI.stateMask = 0;
	lvI.pszText = LPSTR_TEXTCALLBACK;
	lvI.iSubItem = 0;

	for (int k = 0; k < nEvents; k++)
	{
		lvI.iItem = k;
		if (ListView_InsertItem(hWndListView, &lvI) == -1) return FALSE;

	}
	return TRUE;

}

/**
 * Creates the event listview window
 */

HWND CreateEventListView(HWND hWndParent)
{

	RECT rcl;
	INITCOMMONCONTROLSEX icex;
	HWND hWndListView;

	// Ensure the commmon control DLL is loaded

	icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icex.dwICC  = ICC_LISTVIEW_CLASSES;
	InitCommonControlsEx(&icex);

	// Create the list view window in the report view

	GetClientRect(hWndParent, &rcl);
	hWndListView = CreateWindow(WC_LISTVIEW, "", WS_CHILD | LVS_REPORT,
		0, (rcl.bottom - rcl.top - StatusBarHeight) / 2,
		rcl.right - rcl.left, (rcl.bottom - rcl.top - StatusBarHeight) / 2,
		hWndParent, (HMENU) IDC_CECLIENT, hInst, NULL);

	if (NULL == hWndListView)
		return NULL;

	ShowWindow(hWndListView, SW_SHOW);
	UpdateWindow(hWndListView);

	return hWndListView;
}

/**
 * The program entry
 */

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	int s = sizeof(EventInfo);

	InitCommonControls();

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_CECLIENT, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_CECLIENT);


	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_CECLIENT);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_CECLIENT;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   hInst = hInstance; // Store instance handle in our global variable

   hMainWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hMainWnd)
   {
      return FALSE;
   }

   RECT rect;
   hStatus = CreateStatusWindow(WS_CHILD | WS_VISIBLE, "Not connected", hMainWnd, 45400);
   GetWindowRect(hStatus, &rect);
   StatusBarHeight=(WORD)(rect.bottom-rect.top);

   ShowWindow(hMainWnd, nCmdShow);
   UpdateWindow(hMainWnd);

   return TRUE;
}

/**
 * Receives a file from the global socket
 */

void ReceiveFile(char* szFileName)
{
	HANDLE hFile;
	char*  pBuffer;
	INT    nFileSize, nCnt;

	// Create new file

    hFile = CreateFile(szFileName, GENERIC_WRITE,
						  0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);

	// Allocate receive buffer

	pBuffer = new char[BUFFER_SIZE];


	//Receive file size from server
	recv(g_socket, (char*)&nFileSize, sizeof(nFileSize), 0);

	// Send acknowledge to server
	send(g_socket, ACKNOWLEDGE, strlen(ACKNOWLEDGE), 0);

	while (nFileSize > 0)
	{
		nCnt = min(BUFFER_SIZE, nFileSize);

		// Receive block

		recv(g_socket, pBuffer, nCnt, 0);
		DWORD dwBytesWritten;

		// Write block to file

		WriteFile(hFile, pBuffer, nCnt, &dwBytesWritten, 0);

		// Send acknowledge to server

		send(g_socket, ACKNOWLEDGE, strlen(ACKNOWLEDGE), 0);

		nFileSize -= BUFFER_SIZE;
	}
	// Close file
	delete[] pBuffer;
	CloseHandle(hFile);
}


/**
 * Deletes all events (S-files and wave-file) stored on the PocketPC
 */

void DeleteAll()
{
	HMENU hMenu = GetMenu(hMainWnd);
	EnableMenuItem(hMenu, IDM_TRANSFER_ALL, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_DELETE_ALL, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_CONNECT, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_DISCONNECT, MF_GRAYED);

	char szStatus[] = "Deleting files...";
	SendMessage(hStatus, SB_SETTEXT, 0, (long)szStatus);

	//---------------------

	char szCmdLine[CMD_STRING_LENGTH];
	char szFileToGet[MAX_PATH];

	char pBuffer[3];


	// Get all events;
	for (int i = 0; i < nEvents; i++)
	{
		strcpy(szFileToGet, pEvents[i].szSFileDir); 

		if (strcmp(szFileToGet, "") != 0)
		{
			strcat(szFileToGet, "\\");

		}
		strcat(szFileToGet, pEvents[i].szSFileName);

		strcpy(szCmdLine, "DELS");
		strcat(szCmdLine, " ");
		strcat(szCmdLine, szFileToGet);

		Sleep(200); // ???
		// Send command to server
		send(g_socket, (char*) szCmdLine, CMD_STRING_LENGTH, 0);

		// Receive ACK
		recv(g_socket, pBuffer, 3, 0);

		///////////////////////////////////////////////////////////

		strcpy(szCmdLine, "DELW");
		strcat(szCmdLine, " ");
		strcat(szCmdLine, pEvents[i].szWavFileName);

		Sleep(200); // ???

		send(g_socket, (char*) szCmdLine, CMD_STRING_LENGTH, 0);

		// Receive ACK
		recv(g_socket, pBuffer, 3, 0);
	

	}	
	
	// Update file list

	GetFileList();

	EnableMenuItem(hMenu, IDM_TRANSFER_ALL, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_CONNECT, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_DISCONNECT, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_DELETE_ALL, MF_ENABLED);

	char szStatusAfter[] = "Connected";

	SendMessage(hStatus, SB_SETTEXT, 0, (long)szStatusAfter);


}

/**
 * Transfers all events from PocketPC to Client
 */

void TransferAll()
{
	// Get filelist;

	HMENU hMenu = GetMenu(hMainWnd);
	EnableMenuItem(hMenu, IDM_TRANSFER_ALL, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_DELETE_ALL, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_CONNECT, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_DISCONNECT, MF_GRAYED);

	char szStatus[] = "Transfering files...";
	SendMessage(hStatus, SB_SETTEXT, 0, (long)szStatus);


	char szCmdLine[CMD_STRING_LENGTH];
	char szFileToGet[MAX_PATH];

	// Get all events;
	for (int i = 0; i < nEvents; i++)
	{
		strcpy(szFileToGet, pEvents[i].szSFileDir); 

		if (strcmp(szFileToGet, "") != 0)
		{
			strcat(szFileToGet, "\\");

		}
		strcat(szFileToGet, pEvents[i].szSFileName);

		strcpy(szCmdLine, CMD_GET_S_FILE);
		strcat(szCmdLine, " ");
		strcat(szCmdLine, szFileToGet);

		Sleep(200); // ???
		// Send command to server
		send(g_socket, (char*) szCmdLine, CMD_STRING_LENGTH, 0);

		// Receive S-file
		ReceiveFile(pEvents[i].szSFileName);

		///////////////////////////////////////////////////////////

		strcpy(szCmdLine, CMD_GET_S_FILE);
		strcat(szCmdLine, " ");
		strcat(szCmdLine, pEvents[i].szWavFileName);

		Sleep(200); // ???

		send(g_socket, (char*) szCmdLine, CMD_STRING_LENGTH, 0);

		// Receive S-file
		ReceiveFile(pEvents[i].szWavFileName);



		

	}	

	EnableMenuItem(hMenu, IDM_TRANSFER_ALL, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_CONNECT, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_DISCONNECT, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_DELETE_ALL, MF_ENABLED);

	char szStatusAfter[] = "Connected";

	SendMessage(hStatus, SB_SETTEXT, 0, (long)szStatusAfter);
	

}

/**
 * Retrieves a list of events stored on the PocketPC
 */

void GetFileList()
{
	INT  nFileSize, nCnt;


	if (pEvents != 0)
	{
		delete[] pEvents;
		pEvents = 0;
		nEvents = 0;
	}

	// Delete all items in list view

	ListView_DeleteAllItems(hWndEventListView);

	char szCmdLine[CMD_STRING_LENGTH];
	strcpy(szCmdLine, "LIST");
	send(g_socket, (char*) szCmdLine, CMD_STRING_LENGTH, 0);

	//Receive file size from server

	recv(g_socket, (char*)&nFileSize, sizeof(nFileSize), 0);

	// Allocate storage for EventInfo structures
	
	nEvents = nFileSize/sizeof(EventInfo);

	pEvents = new EventInfo[nEvents];

	char* pBuffer = (char*) pEvents;

	// Send acknowledge to server
	send(g_socket, ACKNOWLEDGE, strlen(ACKNOWLEDGE), 0);

	int nRecvd = 0;

	while (nFileSize > 0)
	{
		nCnt = min(BUFFER_SIZE, nFileSize);

		// Receive block

		nRecvd += recv(g_socket, pBuffer+nRecvd, nCnt, 0);
		
		// Send acknowledge to server

		send(g_socket, ACKNOWLEDGE, strlen(ACKNOWLEDGE), 0);

		nFileSize -= BUFFER_SIZE;
	}

	// Reinit list view

	Sleep(100);

	InitEventListViewContent(hWndEventListView);


}

/**
 * Shuts down connection to the PocketPC
 */


void Disconnect()
{
	// Close down list view

	DestroyWindow(hWndEventListView);
	hWndEventListView = 0;

	DestroyWindow(hWndStatusListView);
	hWndEventListView = 0;


	// Send quit command to server
	char szCmdLine[CMD_STRING_LENGTH];
	strcpy(szCmdLine, "QUIT");
	send(g_socket, (char*) szCmdLine, CMD_STRING_LENGTH, 0);
	closesocket(g_socket);

	g_socket = 0;
	

	// Disable the "Disconnect" menu and enable the "Connect" menu
	HMENU hMenu = GetMenu(hMainWnd);
	EnableMenuItem(hMenu, IDM_DISCONNECT, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_CONNECT, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_DELETE_ALL, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_TRANSFER_ALL, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_START_LOGGING, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_STOP_LOGGING, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_REFRESH_EVENT_LIST, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_GET_STATUS_INFO, MF_GRAYED);
	

	char szStatus[] = "Not connected";
	SendMessage(hStatus, SB_SETTEXT, 0, (long)szStatus);


}

/**
 * Connects to the PocketPC
 */

void Connect()
{
	int iError;
	WSADATA WSAData;

	memset(&WSAData, 0, sizeof(WSADATA));

	memset(&g_socket, 0, sizeof(SOCKET));
	
	if (iError = WSAStartup (MAKEWORD(2,0), &WSAData))
	{
		char szMessage[MAX_MSG_STRING];
		sprintf(szMessage, "Startup error #%i.", iError);
		MessageBox(hMainWnd, szMessage, "Error", MB_OK);
		return;
	}
	g_socket = socket(AF_INET, SOCK_STREAM, 0);

	if (INVALID_SOCKET == g_socket)
	{
		char szMessage[MAX_MSG_STRING];
		sprintf(szMessage, "Socket creation error #%i.", WSAGetLastError());
		MessageBox(hMainWnd, szMessage, "Error", MB_OK);
		WSACleanup();
		return;
	}

	g_sa.sin_family = AF_INET;
/*
	g_sa.sin_port   = htons(9990);
	g_sa.sin_addr.S_un.S_addr = inet_addr("129.177.55.198");
*/

	connect(g_socket, (SOCKADDR *) &g_sa, sizeof(g_sa));

	if (iError = WSAGetLastError() != 0)
	{
		char szMessage[MAX_MSG_STRING];
		sprintf(szMessage, "Connect error #%i.", iError);
		MessageBox(hMainWnd, szMessage, "Error", MB_OK);
		closesocket(g_socket);
		return;
	}

	// Disable the "Connect" menu and enable the "Disconnect" menu

	HMENU hMenu = GetMenu(hMainWnd);
	EnableMenuItem(hMenu, IDM_DISCONNECT, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_CONNECT, MF_GRAYED);
	EnableMenuItem(hMenu, IDM_TRANSFER_ALL, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_DELETE_ALL, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_START_LOGGING, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_STOP_LOGGING, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_GET_STATUS_INFO, MF_ENABLED);
	EnableMenuItem(hMenu, IDM_REFRESH_EVENT_LIST, MF_ENABLED);


	// Create list view;
	hWndEventListView = CreateEventListView(hMainWnd);
	InitEventListViewColumns(hWndEventListView);
	
	hWndStatusListView = CreateStatusListView(hMainWnd);
	InitStatusListViewColumns(hWndStatusListView);

	char szStatus[] = "Connected";
	SendMessage(hStatus, SB_SETTEXT, 0, (long)szStatus);

}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	PAINTSTRUCT ps;
	HDC hdc;

	char szWelcome[MAX_LOADSTRING];
	LoadString(hInst, IDS_WELCOME, szWelcome, MAX_LOADSTRING);

	NMLVDISPINFO* plvdi = (NMLVDISPINFO*)lParam;

	switch (message) 
	{
		case WM_NOTIFY:
		{
			if ( ((LPNMHDR) lParam)->hwndFrom == hWndEventListView)
			{
				switch(((LPNMHDR) lParam)->code)
				{
					case LVN_GETDISPINFO:
					
						switch (((NMLVDISPINFO*) lParam)->item.iSubItem)
						{
							case 0:
								plvdi->item.pszText = pEvents[plvdi->item.iItem].szSFileName;
								break;
							case 1:
								plvdi->item.pszText = pEvents[plvdi->item.iItem].szWavFileName;
								break;
							default:
								break;

						}
						return 0;
				
				}
			}

		}
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{

				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;

				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;

				case IDM_GET_STATUS_INFO:
				
					GetStatusInfo();
					break;
				
				case IDM_START_LOGGING:
				{
					StartLogging();
					Sleep(1000);
					GetStatusInfo();
					break;
				}
				case IDM_STOP_LOGGING:
				{
				
					CHAR MessageText[200];

					strcpy(MessageText, "Are you sure you want to stop the system ?");
		            if (MessageBox(hWnd, MessageText, "Seislog", MB_YESNO|MB_ICONQUESTION)==IDYES)
					{
						StopLogging();
						Sleep(1000);
						GetStatusInfo();
					}
					
					break;
				}
				case IDM_CONNECT:
				{
			   	   int nResult = DialogBox(hInst, (LPCTSTR)IDD_CONNECT, hWnd,
					              (DLGPROC)ConnectDlgProc);
								  
				   if (IDOK == nResult)
				   {
					   Connect();
  					   GetFileList();
					   GetStatusInfo();
				   }
				   return TRUE;
				}
				case IDM_REFRESH_EVENT_LIST:
				   GetFileList();
                   break;
				case IDM_DISCONNECT:
				   Disconnect();
				   break;

				case IDM_TRANSFER_ALL:
				   TransferAll();
				   break;

				case IDM_DELETE_ALL:
				{
					int res = MessageBox(hWnd, "Do you want to delete all events stored on the PocketPC", "Warning", MB_YESNO);
					if (res == IDYES)
					{
						DeleteAll();
					}
					break;
				}
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;

		case WM_PAINT:
		{
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);

			if (0 == g_socket)
			{
				DrawText(hdc, szWelcome, strlen(szWelcome), &rt,
					DT_CENTER | DT_VCENTER | DT_SINGLELINE);
			}
			
			EndPaint(hWnd, &ps);
			
			break;
		}
		case WM_SIZE:
		{
			SendMessage(hStatus, WM_SIZE, wParam, lParam);

			if ((hWndEventListView != 0) && (hWndStatusListView != 0))
			{
				RECT rcl;
				HDWP hdwp;

				GetClientRect(hWnd, &rcl);

				// We will be deferring one windows.
				
				hdwp = BeginDeferWindowPos(2);

				DeferWindowPos(hdwp, hWndStatusListView, NULL,
					    0, 0,
						rcl.right - rcl.left, (rcl.bottom - rcl.top - StatusBarHeight) / 2,
						SWP_NOZORDER );

				DeferWindowPos(hdwp, hWndEventListView, NULL,
					    0, (rcl.bottom - rcl.top - StatusBarHeight) / 2,
						rcl.right - rcl.left, (rcl.bottom - rcl.top - StatusBarHeight) / 2,
						SWP_NOZORDER );



				EndDeferWindowPos(hdwp);	
			}
			break;		
		}
		

		case WM_DESTROY:
		{
			if (0 != g_socket)
			{
				Disconnect();
			}
			PostQuitMessage(0);
			break;
		}
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

/**
 * Mesage handler for about box.
 */

LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}

/**
 * Dialog procedure for the Connect dialog box
 */

LRESULT CALLBACK ConnectDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
		
			SetDlgItemText(hDlg, IDC_PORT, "80");
			SetDlgItemText(hDlg, IDC_IPADDRESS, "129.177.55.198");
			return TRUE;
		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK)
			{
				memset(&g_sa, 0, sizeof(sockaddr_in));

				// Get port number
				char szPort[7];
				GetDlgItemText(hDlg, IDC_PORT, szPort, 6);
				g_sa.sin_port   = htons(atoi(szPort));

				char szIPAddress[21];
				GetDlgItemText(hDlg, IDC_IPADDRESS, szIPAddress, 21);
				g_sa.sin_addr.S_un.S_addr = inet_addr(szIPAddress);

				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			if (LOWORD(wParam) == IDCANCEL)
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
