#define MAX_MSG_STRING     100
#define MAX_SFILENAME       29
#define MAX_WFILENAME       20
#define CMD_LENGTH           4
#define CMD_STRING_LENGTH  200
#define BUFFER_SIZE       2048

// All commands must be 4 letters

#define CMD_START_LOGGING     "STRT"
#define CMD_STOP_LOGGING      "STOP"
#define CMD_GET_S_FILE        "GETS"
#define CMD_GET_W_FILE        "GETW"
#define CMD_DEL_S_FILE        "DELS"
#define CMD_DEL_W_FILE        "DELW"
#define CMD_QUIT              "QUIT"
#define CMD_GET_FILE_LIST     "LIST"
#define CMD_GET_STATUS        "STAT"

#define ACKNOWLEDGE           "ACK"


struct EventInfo
{
	char szSFileName[21];   // Name of S file
	char szSFileDir[9];     // Directory of S-file
	char szWavFileName[32]; // Name of waveform file
	char cEventType;        // M = Manual T = Trigged  -- currently not used
};

//The StatusInfo struct contains members from the CHAN_PROP and CHANNEL_INFO_EX structs

struct StatusInfo
{
	// From CHANNEL_INFO_EX
	char ChannelName[10];
	char StationCode[5+1];
	char Component[4+1];
	BOOL LogToDisk;
	BOOL UseTrigging;

	// FROM_CHAN_PROP
	char TimeTag[24];
	signed long Sample;
	BYTE InLEDStatus;
	BYTE DiskLEDStatus;
	BYTE TrigLEDStatus;
	BYTE SyncLEDStatus;
	double STA;
	double LTA;
};





