#include "stdafx.h"
//#define STRICT
#define MSG_LIST_SIZE 20 //500
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include "process.h" //#include <process.h>
#include "seislog.h"
#include "eventlog.h"
#include "library.h"
#include "resource.h"

#define WINCE

//
// Author: yvind Natvik 1998.
//
//
//

//
// Prototype declarations.
//
LRESULT CALLBACK EventLogWndProc(HWND, UINT, WPARAM, LPARAM);
VOID GetDateAndTime(PTCHAR);


//
// Theese are global variables used by functions in this file
//
extern HINSTANCE hInst;
extern HWND hWndFrame;
extern HWND hWndMDIClient;
extern HWND hWndEventLog;
extern TCHAR ProgDir[];


struct LOGMSG {
   TCHAR msg[300];
   WORD MsgLength;
   CHAR Severity;
};


/*********************************************************************************/
/* EventLog window procedure.                                                    */
/*********************************************************************************/
LRESULT CALLBACK EventLogWndProc(HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
   HDC               hdc;
   RECT              rect;
   PAINTSTRUCT       ps;
   WORD              Index, Count;
   DWORD             BytesWrittten;
   HFONT             hOldFont;
   TCHAR             MessageText[100];
   static LOGMSG     MsgList[MSG_LIST_SIZE];
   static int        CharHeight, LogicalWndSizeX, LogicalWndSizeY;
   static int        ClientSizeX, ClientSizeY, OffsetX, OffsetY;
   static int        OldClntSizeX, OldClntSizeY;
   static int        InsertPos, VscrollMax, HscrollMax, yPos;
   static HFONT      hFont;
   static WORD       NumOfMsgInList;
   static TCHAR      LogFile[MAX_PATH+1];
   static HANDLE     hLogFile;
   static TCHAR      LogMsg[301];
   static char       ANSILogMsg[301];
   size_t            wcslength, MsgLength;
   TEXTMETRIC        tm;
#ifndef WINCE
   HWND              hWndChildAct, hWndChildDeact;
   WINDOWPLACEMENT   WndPlacement;   
   TCHAR             WindowFile[MAX_PATH+1];
#endif

   BOOL              bVRedraw, bHRedraw;

#ifdef WINCE
   RECT              rectTxt; // [PocketPC] Used for text
   LOGFONT			 lf;	  // [PocketPC] Struct used for creating a font.
#endif

   // In a MDI child window function, the following messages MUST be
   // handled by DefMDIChildProc, whether the child handles them 
   // or not:
   //
   //    WM_CHILDACTIVATE, WM_GETMINMAXINFO, WM_MENUTCHAR,
   //    WM_MOVE, WM_SETFOCUS, WM_SIZE, WM_SYSCOMMAND.
   //
   
   // Process messages.
   switch (Message) {
      case WM_CREATE:
      //
      // Create/Open the eventfile.
      //
      AddPathAndFilename(LogFile, ProgDir, TEXT("Seislog.log"));
      hLogFile=CreateFile(LogFile, GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ,
                 NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, (HANDLE)NULL);
      
      // Move to the end of file.
      SetFilePointer(hLogFile, 0L, NULL, FILE_END);

#ifdef WINCE
		// Create a font

	  lf.lfHeight = 12;  //-8
	  lf.lfWidth = 0; 
	  lf.lfEscapement = 0; 
	  lf.lfOrientation = 0; 
	  lf.lfWeight = FW_NORMAL; //FW_DONTCARE; 
	  lf.lfItalic = 0; 
	  lf.lfUnderline = 0; 
	  lf.lfStrikeOut = 0; 
	  lf.lfCharSet = DEFAULT_CHARSET; 
	  lf.lfOutPrecision =OUT_DEFAULT_PRECIS;		//old: OUT_CHARACTER_PRECIS; 
	  lf.lfClipPrecision = CLIP_DEFAULT_PRECIS ; 
	  lf.lfQuality = DRAFT_QUALITY ; 
	  lf.lfPitchAndFamily = VARIABLE_PITCH |FF_DONTCARE ; 
	  //lf.lfFaceName[LF_FACESIZE] = TEXT("Terminal") ;

	  hFont=CreateFontIndirect(&lf);
#else
      // Create the font used in the window.
      hFont=CreateFont(11, 0, 0, 0, FW_NORMAL, 0, 0, 0, ANSI_CHARSET, OUT_DEVICE_PRECIS,
                       CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_SWISS, TEXT("MS Sans Serif"));
#endif
      // Get the character height of the created font.
      hdc=GetDC(hWnd);
      SelectObject(hdc, hFont);
      GetTextMetrics(hdc, &tm);
      CharHeight=tm.tmHeight+tm.tmExternalLeading;
      ReleaseDC(hWnd, hdc);

      // Initialize some variables.
      NumOfMsgInList=0; // There are currently no message in the list.
      InsertPos=0;      // Posistion in list where next message is going to be inserted.

      // Get the size of the window client area.
      GetClientRect(hWnd, &rect);
      ClientSizeX=rect.right+1;
      ClientSizeY=rect.bottom+1;

      OffsetX=OffsetY=0;
      return 0;

      
      case WM_WRITE_LOG:
      //
      // This message is sendt from a thread/window that
      // wants to log a message in the program log.
      // Messages longer than 280 characters are truncated.
      // The lParam parameter must contain a pointer
      // to an allocated memory block, containing
      // the message. This block must bee freed.
      
      //
      // (PTCHAR)lParam - Message to log.
      // (DWORD)wParam - Message severity.

      // Find length of message string.   
      MsgLength=wcslen((PTCHAR)lParam);  

      // Truncate message to 280 characters.
      if (MsgLength>280) MsgLength=280; 

      // Insert date and time into message string.
      GetDateAndTime(LogMsg);

      // Add message to message string.
      wcsncat(LogMsg, (PTCHAR)lParam, MsgLength);

      // Free memory accosiated with the message.
      LocalFree((HANDLE)(PTCHAR)lParam);

      // Calculate length of string.
      wcslength=wcslen(LogMsg);

      // Insert message into the message list.
      wcscpy(MsgList[InsertPos].msg, LogMsg);
      MsgList[InsertPos].MsgLength=(WORD)wcslength;
      MsgList[InsertPos].Severity=(char)wParam;
      
      // Next message goes into next position.
      InsertPos++;
      if (InsertPos==MSG_LIST_SIZE) InsertPos=0;

      // Increase number of message in list.
      if (NumOfMsgInList<MSG_LIST_SIZE) NumOfMsgInList++;


	  // Convert UNICODE string to ANSI
      // and write message to the log file.
	  wcstombs(ANSILogMsg, LogMsg, 301);
      strcat(ANSILogMsg, "\r\n");
      WriteFile(hLogFile, ANSILogMsg, (DWORD) wcslength+2, &BytesWrittten, NULL);

      // Recalculate logical window size.
      LogicalWndSizeX=1024;
      LogicalWndSizeY=NumOfMsgInList*CharHeight+1;

      // Calculate the maximum offset the window can be scrolled.
      VscrollMax=max(0, LogicalWndSizeY-ClientSizeY);
      HscrollMax=max(0, LogicalWndSizeX-ClientSizeX);

      // Scroll down to the last message.
      if (LogicalWndSizeY>ClientSizeY) OffsetY=VscrollMax;

      // Update scrollbars
      SetScrollRange(hWnd, SB_VERT, 0, VscrollMax, FALSE);
      SetScrollPos(hWnd, SB_VERT, OffsetY, TRUE);
      SetScrollRange(hWnd, SB_HORZ, 0, HscrollMax, FALSE);
      SetScrollPos(hWnd, SB_HORZ, OffsetX, TRUE);

      // If this is an error message, sound the bell.
      if (wParam==3) MessageBeep(MB_ICONASTERISK);

      // Redraw window.
      InvalidateRect(hWnd, (RECT*)NULL, TRUE); 
      UpdateWindow(hWnd);
      return 0L;


      case WM_SIZE:
      // Save old window size.
      OldClntSizeX=ClientSizeX;
      OldClntSizeY=ClientSizeY;

      // Get new window size. 
      ClientSizeX=LOWORD(lParam);
      ClientSizeY=HIWORD(lParam);

      // Handle vertical size.
      bVRedraw=FALSE;
      if (OldClntSizeY<ClientSizeY) {
         if (ClientSizeY>(LogicalWndSizeY-OffsetY)) {
            OffsetY=LogicalWndSizeY-ClientSizeY;
            if (OffsetY<0) OffsetY=0; 
            bVRedraw=TRUE;
         }
         if (ClientSizeY>LogicalWndSizeY) bVRedraw=FALSE;
      }

      // Handle horizontal size.
      bHRedraw=FALSE;
      if (OldClntSizeX<ClientSizeX) {
         bHRedraw=TRUE;
         if (ClientSizeX>(LogicalWndSizeX-OffsetX)) {
            OffsetX=LogicalWndSizeX-ClientSizeX;
            if (OffsetX<0) OffsetX=0; 
         }
      }

      // Update scrollbars.
      VscrollMax=max(0, LogicalWndSizeY-ClientSizeY);
      HscrollMax=max(0, LogicalWndSizeX-ClientSizeX);
      SetScrollRange(hWnd, SB_VERT, 0, VscrollMax, FALSE);
      SetScrollPos(hWnd, SB_VERT, OffsetY, TRUE);
      SetScrollRange(hWnd, SB_HORZ, 0, HscrollMax, FALSE);
      SetScrollPos(hWnd, SB_HORZ, OffsetX, TRUE);

      // Redraw window.
      if (bVRedraw || bHRedraw) {
         InvalidateRect(hWnd, NULL, TRUE);
         UpdateWindow(hWnd);
      }
      break;

#ifdef WINCE

	  case WM_CLEAR_WINDOW:
         // Cear the log window.
         NumOfMsgInList=0;
         InsertPos=0;
         OffsetX=OffsetY=0;
         SetScrollPos(hWnd, SB_VERT, 0, TRUE);

         //ShowScrollBar(hWnd, SB_VERT, FALSE); 

		 //[PocketPC]
/*
		 SCROLLINFO si;
		 si.cbSize    = sizeof(SCROLLINFO); 
		 si.fMask     = SIF_DISABLENOSCROLL | SIF_TRACKPOS; 
		 si.nMin      = 0; 
		 si.nMax      = 0; 
		 si.nPage     = 0; 
		 si.nPos      = 0;
		 si.nTrackPos = 0; 
	 
		 SetScrollInfo(hWnd, SB_VERT, &si, TRUE); 
*/
         SetScrollPos(hWnd, SB_HORZ, 0, TRUE);
         InvalidateRect(hWnd, NULL, TRUE);
         UpdateWindow(hWnd);
         break;

	  case WM_VIEW_FILE:
         // Open the log file for viewing in notepad.
		 //	_wspawnlp(_P_NOWAIT, TEXT("notepad"), TEXT("notepad"), LogFile, NULL);

         break;

      case WM_CLEAR_FILE:
         // Cear the log file.
         wcscpy(MessageText, TEXT("Are you sure you want to clear the log file ?"));
         if (MessageBox(hWnd, MessageText, TEXT("Seislog"), MB_YESNO|MB_ICONQUESTION)==IDYES) {
            SetFilePointer(hLogFile, 0L, NULL, FILE_BEGIN); // Move to the start of file.
            SetEndOfFile(hLogFile);                         // Truncate file.
         }
         break;

#else
		 
      case WM_SYSCOMMAND: 
      case WM_COMMAND:
      //
      // The WM_SYSCOMMAND message is sendt from the system menu.
      // The WM_COMMAND is sendt from the main menu if MDI child is maximized.
      //
      switch(wParam) {
         case SC_CLEAR_WINDOW:
         // Cear the log window.
         NumOfMsgInList=0;
         InsertPos=0;
         OffsetX=OffsetY=0;
         SetScrollPos(hWnd, SB_VERT, 0, TRUE);
         ShowScrollBar(hWnd, SB_VERT, FALSE); 
         SetScrollPos(hWnd, SB_HORZ, 0, TRUE);
         InvalidateRect(hWnd, NULL, TRUE);
         UpdateWindow(hWnd);
         break;

			case SC_VIEW_FILE:
         // Open the log file for viewing in notepad.
			_spawnlp(_P_NOWAIT, "notepad", "notepad", LogFile, NULL);
         break;

         case SC_CLEAR_FILE:
         // Cear the log file.
         strcpy(MessageText, "Are you sure you want to clear the log file ?");
         if (MessageBox(hWnd, MessageText, "Seislog", MB_YESNO|MB_ICONQUESTION)==IDYES) {
            SetFilePointer(hLogFile, 0L, NULL, FILE_BEGIN); // Move to the start of file.
            SetEndOfFile(hLogFile);                         // Truncate file.
         }
         break;

      }
      break;

#endif

      case WM_VSCROLL:
         switch (LOWORD(wParam)) {
         case SB_TOP:
            if (OffsetY>0) {
               OffsetY=0;
               InvalidateRect(hWnd, NULL, TRUE);
               UpdateWindow(hWnd);
            }
            break;
         case SB_BOTTOM:
            VscrollMax=max(0, LogicalWndSizeY-ClientSizeY);
            if (OffsetY<VscrollMax) {
               OffsetY=VscrollMax;
               InvalidateRect(hWnd, NULL, TRUE);
               UpdateWindow(hWnd);
            }
            break;
         case SB_LINEDOWN:
            VscrollMax=max(0, LogicalWndSizeY-ClientSizeY);
            if (OffsetY<VscrollMax) {
               OffsetY=OffsetY+CharHeight;
               if (OffsetY>VscrollMax) OffsetY=VscrollMax; 
               InvalidateRect(hWnd, NULL, TRUE);
               UpdateWindow(hWnd);
            }
            break;
         case SB_LINEUP:
            if (OffsetY>0) {
               OffsetY=OffsetY-CharHeight;
               if (OffsetY<0) OffsetY=0;
               InvalidateRect(hWnd, NULL, TRUE);
               UpdateWindow(hWnd);
            }
            break;
         case SB_THUMBTRACK:
            OffsetY=HIWORD(wParam);
            InvalidateRect(hWnd, NULL, TRUE);
            UpdateWindow(hWnd);
            break;
         case SB_PAGEUP:
            if (OffsetY>0) {
               OffsetY=OffsetY-ClientSizeY;
               if (OffsetY<0) OffsetY=0;
               InvalidateRect(hWnd, NULL, TRUE);
               UpdateWindow(hWnd);
            }
            break;
         case SB_PAGEDOWN:
            VscrollMax=max(0, LogicalWndSizeY-ClientSizeY);
            if (OffsetY<VscrollMax) {
               OffsetY=OffsetY+ClientSizeY;
               if (OffsetY>VscrollMax) OffsetY=VscrollMax; 
               InvalidateRect(hWnd, NULL, TRUE);
               UpdateWindow(hWnd);
            }
            break;
         }
         
         // Set position of scrollbar.
         SetScrollPos(hWnd, SB_VERT, OffsetY, TRUE);
      return 0L;


      case WM_HSCROLL:
         switch (LOWORD(wParam)) {
         case SB_TOP:
            if (OffsetX>0) {
               OffsetX=0;
               InvalidateRect(hWnd, NULL, TRUE);
               UpdateWindow(hWnd);
            }
            break;
         case SB_BOTTOM:
            if (OffsetX<HscrollMax) {
               OffsetX=HscrollMax;
               InvalidateRect(hWnd, NULL, TRUE);
               UpdateWindow(hWnd);
            }
            break;
         case SB_LINERIGHT:
            if (OffsetX<HscrollMax) {
               OffsetX=OffsetX+10;
               if (OffsetX>HscrollMax) OffsetX=HscrollMax; 
               InvalidateRect(hWnd, NULL, TRUE);
               UpdateWindow(hWnd);
            }
            break;
         case SB_LINELEFT:
            if (OffsetX>0) {
               OffsetX=OffsetX-10;
               if (OffsetX<0) OffsetX=0;
               InvalidateRect(hWnd, NULL, TRUE);
               UpdateWindow(hWnd);
            }
            break;
         case SB_THUMBTRACK:
            OffsetX=HIWORD(wParam);
            InvalidateRect(hWnd, NULL, TRUE);
            UpdateWindow(hWnd);
            break;
         case SB_PAGELEFT:
            if (OffsetX>0) {
               OffsetX=OffsetX-ClientSizeX/2;
               if (OffsetX<0) OffsetX=0;
               InvalidateRect(hWnd, NULL, TRUE);
               UpdateWindow(hWnd);
            }
            break;
         case SB_PAGERIGHT:
            if (OffsetX<HscrollMax) {
               OffsetX=OffsetX+ClientSizeX/2;
               if (OffsetX>HscrollMax) OffsetX=HscrollMax; 
               InvalidateRect(hWnd, NULL, TRUE);
               UpdateWindow(hWnd);
            }
            break;
         }

         // Set position of scrollbar.
         SetScrollPos(hWnd, SB_HORZ, OffsetX, TRUE);
      return 0L;


      case WM_PAINT:
      hdc=BeginPaint(hWnd, &ps);
      GetClientRect(hWnd, (RECT FAR*)&rect);

      // Select font.
      hOldFont=(HFONT)SelectObject(hdc, hFont);

      // Find index of first message in list.
      if (NumOfMsgInList<MSG_LIST_SIZE) {
         Index=0;
      } else {
         Index=(WORD)InsertPos;  
      }

      // Start writing in the top of the window.
      yPos=0;

#ifdef WINCE
	  rectTxt.right  = 240;
	  rectTxt.left   = 3-OffsetX;
#endif

      // Update window.
      for (Count=1;Count<=NumOfMsgInList;Count++) {
         // Set font color.
         if (MsgList[Index].Severity==1) SetTextColor(hdc,  RGB(0,0,0));
         if (MsgList[Index].Severity==2) SetTextColor(hdc,  RGB(0,51,153));
         if (MsgList[Index].Severity==3) SetTextColor(hdc,  RGB(153,0,0));

         // Draw text.

#ifdef WINCE
		 rectTxt.top    = yPos-OffsetY;
		 rectTxt.bottom = yPos-OffsetY+CharHeight;
		 DrawText(hdc, MsgList[Index].msg, MsgList[Index].MsgLength, &rectTxt, DT_LEFT | DT_TOP);
#else
         TextOut(hdc, -OffsetX, yPos-OffsetY, MsgList[Index].msg, MsgList[Index].MsgLength);       
#endif

         // Increase vertical draw position
         yPos=yPos+CharHeight;

         // Increase index into 'MsgList' table.
         Index++; 
         if (Index==MSG_LIST_SIZE) Index=0;
      }

      // Restore old font.
      SelectObject(hdc, hOldFont);

      EndPaint(hWnd, &ps);
      return 0L;

#ifndef WINCE
      
      case WM_CHILDACTIVATE:
      // This window is being activated.
      break;

      
      case WM_MDIACTIVATE:
      // An application sends the WM_MDIACTIVATE message to a 
      // multiple document interface (MDI) client window to 
      // instruct the client window to activate a different MDI child window. 
      hWndChildDeact=(HWND)wParam;  // Child being deactivated. 
      hWndChildAct=(HWND)lParam;    // Child being activated. 
      return 0;
#endif

      case WM_DESTROY:
      //
      // The MDI client is about to destroy the window.
      //

      // Close the log file.
      CloseHandle(hLogFile);

      // Destroy the font.
      DeleteObject(hFont);
#ifndef WINCE
      //
      // Save current window-placement to config file.
      // 
      AddPathAndFilename(WindowFile, ProgDir, TEXT("EventLog.wnd"));
      WndPlacement.length=sizeof(WINDOWPLACEMENT);
      GetWindowPlacement(hWnd, &WndPlacement); 
      WriteFileFromMemory(WindowFile, (PVOID)&WndPlacement, (DWORD)sizeof(WINDOWPLACEMENT));
      return 0L;
#endif
   }

   // Pass unprocessed messages to the 'DefMDIChildProc' function.
#ifdef WINCE
   return DefWindowProc(hWnd, Message, wParam, lParam);
#else
  return DefMDIChildProc(hWnd, Message, wParam, lParam);
#endif
}


/*****************************************************/
/* Inserts date and time into the string.            */
/*****************************************************/
VOID GetDateAndTime(PTCHAR String)
{
   TCHAR str4[5];
   SYSTEMTIME LocalTime;

   // Add time and date to string.
   GetLocalTime(&LocalTime);
   swprintf(str4, TEXT("%02u"), LocalTime.wDay);
   wcscpy(String, str4);
   wcscat(String, TEXT("."));
   swprintf(str4, TEXT("%02u"), LocalTime.wMonth);
   wcscat(String, str4);
   wcscat(String, TEXT("."));
   swprintf(str4, TEXT("%04u"), LocalTime.wYear);
   wcscat(String, str4);
   wcscat(String, TEXT(","));
   swprintf(str4, TEXT("%02u"), LocalTime.wHour);
   wcscat(String, str4);
   wcscat(String, TEXT("."));
   swprintf(str4, TEXT("%02u"), LocalTime.wMinute);
   wcscat(String, str4);
   wcscat(String, TEXT("."));
   swprintf(str4, TEXT("%02u"), LocalTime.wSecond);
   wcscat(String, str4);
   wcscat(String, TEXT(" "));
  
}




/*****************************************************/
/* Writes a message to the system log.               */
/* This function will not hang the calling thread.   */  
/*****************************************************/
VOID WriteSystemLog(PTCHAR Message, TCHAR Severity)
{

   //
   // Severity codes:
   //
   // 1 - Information.
   // 2 - Warning.
   // 3 - Error.
   //

   extern HWND hWndEventLog;
   PTCHAR pMessage;

   // Allocate memory to hold message.
   pMessage=(PTCHAR)LocalAlloc(LMEM_FIXED, (UINT)(wcslen(Message)+1)*sizeof(TCHAR));

   // Copy message to memory.
   wcscpy(pMessage, Message);

   // Post message with pointer to EventLog window.   
   // The eventlog window function will free the memory.
   PostMessage(hWndEventLog, WM_WRITE_LOG, (WPARAM)Severity, (LPARAM)pMessage);
}
