#define WINCE

//
// This structure is used to pass startup
// information to a monitor-window thread.
//
struct STARTINFO_MONITOR {
	BYTE LogicalChannelNr;			// Logical channel nr of channel to monitor.
	DWORD ChThreadID;					// ThreadID of the channel thread.
#ifdef WINCE
	HWND  hParent;              // [In] Handle to the parent window (the dialog)
#endif
};


//
// This structure is read from the 'Monitor.wnd' file when
// this thread is started, and written when it is stopped.
// The file is located in the channel directory.
//
struct MON_WND_CNF {
   BOOL AutoScaling;             // TRUE if autoscaling is enabled.
   LONG UserScale;               // User-choosen scale.
   BOOL AutoOpen;                // If this variable is TRUE in the 'Monitor.wnd' file when the
                                 // system is started, Seislog will open this window automatically.
   BOOL SmplReduction;           // TRUE if sample reduction is enabled.
	BOOL OneSmplPrBlock;				// If true, then samples will be reduced to 1 pr. block.
   BYTE Reduction;               // User-choosen reduction in percent.
   HWND hWnd;                    // Handle to parent Window.
   LONG *SmplBuff;               // Pointer to extra sample buffer used with sample reduction.
//   WINDOWPLACEMENT WndPlacement; // The window's last status, size and position.
};
