#define WINCE

//
// Copyright 1998-2000 Institute of Solid Earth Physics.
// Any use of this software implies agreement with the
// terms given in the accompanying file 'Copyrights.txt'.
//
//
//
// NOTE: Seislog must be compiled with the /Zp1 switch
//       in the Windows 9X/NT/200 version (NOT in CE).
//       This is neccesarry to get all structure members
//       byte aligned in memory.
//


// Seislog.cpp : Defines the entry point for the application.
//


#include "stdafx.h"
#include "Seislog.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>


//#define  STRICT
//#include <windows.h>
//#include <stdlib.h>
//#include <string.h>
#include <stdio.h>
#include <commctrl.h>
//#include <errno.h>
#include "resource.h"
#include "seislog.h"
#include "process.h"
#include "ringbuffer.h"
#include "library.h"
#include "devices.h"
#include "channel.h"
#include "eventlog.h"
#include "monitor.h"
#include "trigger.h"
#include "dlgprocs.h"
#include "Server.h"
 
//
//               Global variables.
//
TCHAR           ProgVer[7]=TEXT("0.9.96");              // Current program version.
TCHAR           RegVersion[7];						  // The version found in the registry.	
BYTE            DebugLevel=0;                     // To run the program in debug mode, set to 1 or 2.
HINSTANCE       hInst;                            // Handle to program instance.
#ifndef WINCE
HMENU           hMainMenu;                        // Handle to the program's menu.
HMENU           hMenuDocList;                     // Handle to document-list sub menu.
#endif
HWND            hWndFrame;                        // Handle to program's main window.
HWND            hWndStatus;                       // Handle to program's main window status bar.
HWND            hWndMDIClient;                    // Handle to the MDI client window.
HWND            hWndEventLog;                     // Handle to eventlog window.
HWND            hWndMainMon;                      // Handle to the main-monitor window.
DWORD           MainThreadID;                     // Thread id of main program.
DWORD           ServerThreadID = 0;
DWORD           ProcKeeperThreadID;               // ThreadID for the ProcessKeeper thread.
DWORD           MainMonThreadID;                  // ThreadID for the Main monitor window thread.
HANDLE          hTickerThread;                    // Handle to the one-second ticker thread.
DWORD           TickerThreadID;                   // ThreadID for the one-second ticker thread.
BOOL            GPSThreadRunning;                 // If TRUE, then the GPS system time syncronisation thread is currently running.
BOOL            StartGPSThread=FALSE;             // If TRUE, the GPS system time syncronisation thread is started when program starts.
HANDLE          hSysClkSyncThread;                // Handle to the SysClkSyncThrd thread (if this thread is running).
DWORD           SysClkSyncThreadID=0;             // Thread id of PC-Clock sync thread.
HANDLE          hProcKeeperThread;                // Handle to the ProcessKeeper thread.
TCHAR           ProgDir[MAX_PATH+1];              // Directory where program is installed.
TCHAR           RngBufDir[MAX_PATH+1];            // Directory for the ring-buffers.
TCHAR           DeviceDir[MAX_PATH+1];            // Directory for device configurations.
TCHAR           ChannelDir[MAX_PATH+1];           // Directory for channel configurations.
TCHAR           TriggerDir[MAX_PATH+1];           // Directory for trigger set configuration files.
TCHAR           EventFileDir[MAX_PATH+1];         // Directory for event files.
TCHAR           SFileDir[MAX_PATH+1];             // Directory for S-files.
BOOL            AppendSeisanSubdirs=TRUE;         // If TRUE, then Seisan \yyyy\mm\ sudirs will be added to 'SFileDir' before it is used.
DEVICE_INFO     Devices[MAX_NUM_OF_DEVICES];      // This is an array holding information on all registered devices.
CHANNEL_INFO    Channels[MAX_NUM_OF_CHANNELS];    // This is an array holding information on all registered channels.
TRIGGERSET_INFO Triggers[MAX_NUM_OF_TRIGGERSETS]; // This is an array holding information on all registered triggersets.
CHAR            NumRegisteredDevices;             // Number of devices registered in 'Devices' array.
BYTE            NumRegisteredChannels;            // The number of channels currently defined.
BYTE            NumRegisteredTriggersets;         // The number of trigger sets currently defined.
TCHAR           NetworkCode[6];                   // Short network name (3-5 letter code).
TCHAR           NetworkName[30];                  // Long network name (up to 29 letters long).
TCHAR           WindowFile[MAX_PATH+1];
TCHAR           StatusBarText[100];               // Status bar text string.
BOOL            TriggerDebug=FALSE;               // If set to TRUE, trigger thread will output additional information.
BYTE            GPSDebug=0;                       // If greater then 0, GPS reader thread will output additional debug information.
BOOL            AutoStart=FALSE;                  // If TRUE, the system will start automatically when the program is started.
TCHAR           SerialPortGPS[6]=TEXT("COM1");          // Name of serial port which GPS is connected to.
DOUBLE          MeanTimeBeforeGPRMC=0.4;          // Mean time for period between GPS second puls and start sending $GPRMC message.

#ifdef WINCE
//
//      Global variables new in PocketPC version
//

HWND		 	        hwndCB;					  // The command bar handle. New in PocketPC version
static SHACTIVATEINFO   s_sai;                    // Help manage Input Panel

#endif


//
//      Prototyping for window procedures.
//

LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK EventLogWndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK MonitorWndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK MainMonWndProc(HWND, UINT, WPARAM, LPARAM);


//
//      Prototyping for thread functions.
//

DWORD WINAPI ProcKeeperThrd(PVOID); 
DWORD WINAPI SysClkSyncThrd(PVOID);


//
// Function prototyping
// 

VOID StartSystem(VOID); 
VOID StopSystem(BOOL); 
BOOL ReadProgramRegistrySettings(VOID);
BOOL WriteProgramRegistrySettings(VOID);


HWND CreateRpCommandBar(HWND);


int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable; // New in PocketPC version
	INT Status;
	TCHAR Message[350];
	HANDLE hMutex;
#ifdef WINCE
	WNDCLASS	wc;
#else
	WNDCLASSEX wc; 
	WINDOWPLACEMENT WndPlacement;
	BOOL bStatus;
#endif
    UNREFERENCED_PARAMETER(lpCmdLine); 
	BOOL StartupOK=TRUE, RegistryOK;

	BOOL bFocused = FALSE;

	HWND hWndOtherInst;
	BOOL bForeground = FALSE;

  // Save instance handle 
   hInst=hInstance;  

   // Check if program is already running. To do this we try to create
   // a named mutex called "WINSEISLOG". If mutex already exist, then 
   // we assume another copy is running. The mutex will be released when
   // the program ends.

   hMutex=CreateMutex(NULL, TRUE, TEXT("WINSEISLOG"));

   if (GetLastError()==ERROR_ALREADY_EXISTS) {


      // Another copy of Seislog is running.
	  // Try to get a handle to the main window of the other copy

	  hWndOtherInst = FindWindow(TEXT("SeislogFrameClass"), TEXT("Seislog for PocketPC"));

	  if (hWndOtherInst)
	  {
		  // Try to bring the Window to the foreground
		  bForeground = SetForegroundWindow(hWndOtherInst);

	  }

	  // If we could not locate the other window, 
	  // write error message and exit.
	  if(!hWndOtherInst || !bForeground)
	  {	  		  
		  wcscpy(Message, TEXT("Seislog is already running.\n"));
		  wcscat(Message, TEXT("You can not run more than one copy.  "));
		  MessageBox(NULL, Message, TEXT("Seislog message"), MB_OK|MB_ICONSTOP);

		  // Exit the program.

	  }
      return 1; 

   }


	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_SEISLOG);
	
	// Show input panel
	SIPINFO sip;
    SHSipInfo(SPI_GETSIPINFO, 0, &sip,0); // Get Input panel info
    sip.fdwFlags = SIPF_ON;               // Change
    SHSipInfo(SPI_SETSIPINFO, 0, &sip,0); // Set Input Panel info

	
	Start:

    // Initialize default values for directories.
	wcscpy(ProgDir, TEXT("\\Seislog"));
	wcscpy(RngBufDir, TEXT("\\Seislog\\Ringbuffers"));
	wcscpy(EventFileDir, TEXT("\\Seislog\\Events"));
	wcscpy(SFileDir, TEXT("\\Seislog\\Events"));

	// Load program's registry settings.
	RegistryOK=ReadProgramRegistrySettings();

	// Do some preflight checking.
	if (RegistryOK) {
	   // Create path to program directories not read from the registry.
		// Theese directoris are subdirectories of the program directory.
	   StripBackslashFromPath(ProgDir);
	   wcscpy(DeviceDir, ProgDir); wcscat(DeviceDir, TEXT("\\Devices"));
	   wcscpy(ChannelDir, ProgDir); wcscat(ChannelDir, TEXT("\\Channels"));
	   wcscpy(TriggerDir, ProgDir); wcscat(TriggerDir, TEXT("\\Triggersets"));

		// Check startup parameters/directories.
		// Also create some directories if missing.
		if (wcslen(NetworkCode)<3) StartupOK=FALSE;
		if (wcslen(NetworkName)==0) StartupOK=FALSE;
		if (!ExistDirectory(ProgDir)) {
			StartupOK=FALSE;
		} else {
			if (!ExistDirectory(RngBufDir)) StartupOK=FALSE;
			if (!ExistDirectory(DeviceDir)) CreateMultiLevelDir(DeviceDir);
			if (!ExistDirectory(DeviceDir)) StartupOK=FALSE;
			if (!ExistDirectory(ChannelDir)) CreateMultiLevelDir(ChannelDir);
			if (!ExistDirectory(ChannelDir)) StartupOK=FALSE;
			if (!ExistDirectory(TriggerDir)) CreateMultiLevelDir(TriggerDir);
			if (!ExistDirectory(TriggerDir)) StartupOK=FALSE;
			if (!ExistDirectory(EventFileDir)) StartupOK=FALSE;
			if (!ExistDirectory(SFileDir)) StartupOK=FALSE;
		}
	} else {
		StartupOK=FALSE;
	}

  
   //
   // If something failed, then bring up the 'Program settings'
   // dialog box, and let the user change the config settings.
   if (!StartupOK) {
      wcscpy(Message, TEXT("Seislog has detected that configuration settings in the Windows registry is missing or incorrect.\n\n"));
      wcscat(Message, TEXT("Press 'OK' to modify the information, or press 'Cancel' to exit Seislog."));
      Status=MessageBox(NULL, Message, TEXT("Seislog: Startup check failed"), MB_OKCANCEL|MB_ICONSTOP);
      if (Status==IDCANCEL) return 1; // If user pressed 'Cancel', then exit.

      // Bring up the  'Program settings' dialog box.
#ifdef WINCE
	  ProgramSettingsDialogBox(NULL);
#else
		Status=DialogBox(hInst, MAKEINTRESOURCE(IDD_PROGRAM_SETTINGS), NULL, (DLGPROC)ProgramSettingsDlgProc);
      if (!Status) return 1; // If user pressed 'Cancel', then exit.
#endif

      // Update Windows registry.
      WriteProgramRegistrySettings();

      // Reset StartupOK flag and jump back to the 'Start' label.
		StartupOK=TRUE; goto Start;
   }


   // Initialize common controls.
   InitCommonControls(); 


   // Set priority for this application.
   //SetPriorityClass(GetCurrentProcess() ,HIGH_PRIORITY_CLASS);
   
   
   // Get the thread-id of main thread.
   MainThreadID=GetCurrentThreadId();

#ifdef WINCE
   // Register the window class for the frame window. 
	ZeroMemory(&wc, sizeof(wc));     // Initialize all members in the structure to 0 (zero);
   	wc.style			= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc		= (WNDPROC) MainWndProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= 0;
	wc.hInstance		= hInstance;
	wc.hIcon			= LoadIcon(hInstance, TEXT("APPICON"));
	wc.hCursor			= 0;
	wc.hbrBackground	= (HBRUSH) GetStockObject(LTGRAY_BRUSH);
	wc.lpszMenuName		= 0;
	wc.lpszClassName	= TEXT("SeislogFrameClass");

	if (!RegisterClass(&wc)) return 0; 

   // Register the eventlog child window. 
   ZeroMemory(&wc, sizeof(wc));
   wc.style=CS_NOCLOSE | CS_HREDRAW | CS_VREDRAW; 
   wc.lpfnWndProc=(WNDPROC)EventLogWndProc; 
   wc.cbWndExtra=sizeof(HANDLE);
   wc.hInstance=hInstance; 
   wc.hIcon=LoadIcon(hInstance, TEXT("APPICON")); 
   wc.hCursor=LoadCursor(NULL, IDC_ARROW); 
   wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH); 
   wc.lpszMenuName=(LPCTSTR)NULL; 
   wc.lpszClassName=TEXT("SeislogEventlogClass"); 
   if (!RegisterClass(&wc)) return 0; 

    // Register the window class for the monitor window.
	ZeroMemory(&wc, sizeof(wc));
	wc.style				= 0;
	wc.lpfnWndProc		= (WNDPROC) MonitorWndProc;
	wc.hInstance		= hInstance;
	wc.hCursor			= LoadCursor((HINSTANCE)NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszClassName	= TEXT("SeislogMonitorClass");
	wc.hIcon=LoadIcon(hInstance, TEXT("MONITORICON"));
	if (!RegisterClass(&wc)) return 0;

   // Register the window class for the main-monitor window.   
   ZeroMemory(&wc, sizeof(wc));
   wc.style=CS_NOCLOSE | CS_HREDRAW | CS_VREDRAW; 
   wc.lpfnWndProc=(WNDPROC)MainMonWndProc;  
   wc.cbWndExtra=sizeof(HANDLE);
   wc.hInstance=hInstance; 
   wc.hIcon=LoadIcon(hInstance, TEXT("APPICON")); 
   wc.hCursor=LoadCursor(NULL, IDC_ARROW); 
   wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH); 
   wc.lpszMenuName=(LPCTSTR)NULL; 
   wc.lpszClassName=TEXT("SeislogMainMonClass"); 
   if (!RegisterClass(&wc)) return 0; 

	RECT	rect;
	GetClientRect(hWndFrame, &rect);
	
	hWndFrame = CreateWindow(TEXT("SeislogFrameClass"), TEXT("Seislog for PocketPC"), WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);


#else
   
   // Register the window class for the frame window. 
   ZeroMemory(&wc, sizeof(wc));     // Initialize all members in the structure to 0 (zero);
   wc.cbSize=sizeof(wc);            // Set the size of the WNDCLASSEX structure. 
   wc.lpfnWndProc=(WNDPROC)MainWndProc; 
   wc.hInstance=hInstance; 
   wc.hIcon=LoadIcon(hInstance, TEXT("APPICON")); 
   wc.hCursor=LoadCursor(NULL, IDC_ARROW); 
   wc.hbrBackground=(HBRUSH)(COLOR_APPWORKSPACE+1); 
   wc.lpszClassName=TEXT("SeislogFrameClass"); 
   wc.hIconSm=LoadIcon(hInstance, TEXT("APPICON"));
   if (!RegisterClassEx(&wc)) return 0; 

   // Register the eventlog child window. 
   ZeroMemory(&wc, sizeof(wc));
   wc.cbSize=sizeof(wc); 
   wc.style=CS_NOCLOSE; 
   wc.lpfnWndProc=(WNDPROC)EventLogWndProc; 
   wc.cbWndExtra=sizeof(HANDLE);
   wc.hInstance=hInstance; 
   wc.hIcon=LoadIcon(hInstance, TEXT("APPICON")); 
   wc.hCursor=LoadCursor(NULL, IDC_ARROW); 
   wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH); 
   wc.lpszMenuName=(LPCTSTR)NULL; 
   wc.lpszClassName=TEXT("SeislogEventlogClass"); 
   wc.hIconSm=LoadIcon(hInstance, TEXT("EVENTLOGICON"));
   if (!RegisterClassEx(&wc)) return 0; 

   // Register the window class for the monitor window. 
   ZeroMemory(&wc, sizeof(wc));
   wc.cbSize=sizeof(wc); 
   wc.style=0; 
   wc.lpfnWndProc=(WNDPROC)MonitorWndProc; 
   wc.hInstance=hInstance; 
   wc.hCursor=LoadCursor((HINSTANCE)NULL, IDC_ARROW); 
   wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);  
   wc.lpszClassName=TEXT("SeislogMonitorClass");
   wc.hIconSm=LoadIcon(hInstance, TEXT("MONITORICON"));
   if (!RegisterClassEx(&wc)) return 0; 

   // Register the window class for the main-monitor window.   
   ZeroMemory(&wc, sizeof(wc));
   wc.cbSize=sizeof(wc); 
   wc.style=CS_NOCLOSE; 
   wc.lpfnWndProc=(WNDPROC)MainMonWndProc; 
   wc.cbWndExtra=sizeof(HANDLE);
   wc.hInstance=hInstance; 
   wc.hIcon=LoadIcon(hInstance, TEXT("APPICON")); 
   wc.hCursor=LoadCursor(NULL, IDC_ARROW); 
   wc.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH); 
   wc.lpszMenuName=(LPCTSTR)NULL; 
   wc.lpszClassName=TEXT("SeislogMainMonClass"); 
   wc.hIconSm=LoadIcon(hInstance, TEXT("MAINMONITORICON"));
   if (!RegisterClassEx(&wc)) return 0; 

   //
   // Create the frame window (This is an MDI based application).  
   //
   hMainMenu=LoadMenu(hInst,TEXT("MAINMENU")); // Load the main menu.
   hWndFrame=CreateWindowEx(WS_EX_STATICEDGE, TEXT("SeislogFrameClass"), TEXT("Seislog for Windows"), 
                            WS_OVERLAPPEDWINDOW|WS_CLIPCHILDREN, CW_USEDEFAULT, 
                            CW_USEDEFAULT, 612, 450, NULL, hMainMenu, hInst, NULL); 

#endif


	if (!hWndFrame)
	{	
		return FALSE;
	}

#ifdef WINCE

	//When the main window is created using CW_USEDEFAULT the height of the menubar (if one
	// is created is not taken into account). So we resize the window after creating it
	// if a menubar is present
	{
		RECT rc;
		GetWindowRect(hWndFrame, &rc);
		rc.bottom -= MENU_HEIGHT;
		if (hwndCB)
			MoveWindow(hWndFrame, rc.left, rc.top, rc.right, rc.bottom, FALSE);
	}

#else

   // Set the window size/placement.
   AddPathAndFilename(WindowFile, ProgDir, TEXT("Seislog.wnd"));
   if (ExistFile(ProgDir, TEXT("Seislog.wnd"))) {
      bStatus=ReadFileToMemory(WindowFile, (PVOID)&WndPlacement, (DWORD)sizeof(WINDOWPLACEMENT));
      if (bStatus) SetWindowPlacement(hWndFrame, &WndPlacement);
   } 

#endif

   // Show the window.
   ShowWindow(hWndFrame, nCmdShow);

   //
   // Start the program.
   //
   SendMessage(hWndFrame, WM_STARTUP, 0, 0);


	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

   // Update Windows registry.
   WriteProgramRegistrySettings();

   // Clean up before exiting from the application.
   UnregisterClass(TEXT("SeislogFrameClass"), hInstance);
   UnregisterClass(TEXT("SeislogEventlogClass"), hInstance);
   UnregisterClass(TEXT("SeislogMonitorClass"), hInstance);
   UnregisterClass(TEXT("SeislogMainMonClass"), hInstance);


   ReleaseMutex(hMutex);
	return msg.wParam;
}


LRESULT CALLBACK MainWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	


	int wmId, wmEvent; 
	TCHAR MessageText[200];
#ifndef WINCE
	HMENU hSysMenu;
	WINDOWPLACEMENT WndPlacement;
	CLIENTCREATESTRUCT ClientCreate;
	BOOL bStatus;
#endif
	static HWND hWndChild;
	static WORD StatusBarHeight;




	switch (message) 
	{
		case WM_HIBERNATE:

		return 0;

		case WM_STARTUP:

      //
      // Inititialize the program and start all processes.
      //

      
#ifdef WINCE
      // [PocketPC] Create and size/position the event-log child window.
	  hWndEventLog = CreateWindow(TEXT("SeislogEventlogClass"),
		                             TEXT("Log"),
									 WS_HSCROLL | WS_VSCROLL | WS_VISIBLE | WS_CHILD | WS_BORDER/*| WS_OVERLAPPED*/,
									 0,
									 139,
									 241,
									 108,
									 hWndFrame,
									 NULL,
									 hInst,
									 NULL);


#else
      // Create and size/position the event-log MDI child window.
      GetClientRect(hWnd, &rect);
      hWndEventLog=CreateMDIWindow(TEXT("SeislogEventlogClass"), TEXT(" Log"), WS_HSCROLL|WS_VSCROLL, 
                         0, rect.bottom-120, rect.right, 100, hWndMDIClient, hInst, NULL);
      // Set the window's size/placement.
      AddPathAndFilename(WindowFile, ProgDir, TEXT("EventLog.wnd"));
      if (ExistFile(ProgDir, TEXT("EventLog.wnd"))) {
         bStatus=ReadFileToMemory(WindowFile, (PVOID)&WndPlacement, (DWORD)sizeof(WINDOWPLACEMENT));
         if (bStatus) SetWindowPlacement(hWndEventLog, &WndPlacement);
      } 

      //
      // Add 'Clear log window' and 'Clear log window'
      // menues to the system menu of the event window.
      //
      hSysMenu=GetSystemMenu(hWndEventLog, FALSE);
      AppendMenu(hSysMenu, MF_SEPARATOR, 0, NULL);
		AppendMenu(hSysMenu, MF_STRING, SC_VIEW_FILE, TEXT("&View log file"));
      AppendMenu(hSysMenu, MF_STRING, SC_CLEAR_FILE, TEXT("Clear log &file"));
      AppendMenu(hSysMenu, MF_STRING, SC_CLEAR_WINDOW, TEXT("Clear log &window"));
#endif

      // Start the GPS system-clock syncronization thread.
      GPSThreadRunning=FALSE;
      if (StartGPSThread) {
         GPSThreadRunning=TRUE;
         hSysClkSyncThread=CreateThread(NULL, 0, SysClkSyncThrd, NULL, 0, &SysClkSyncThreadID);
      }

      // Start the process-keeper thread.
      hProcKeeperThread=CreateThread(NULL, 0, ProcKeeperThrd, NULL, 0, &ProcKeeperThreadID);
      while (!PostThreadMessage(ProcKeeperThreadID, TM_DUMMY, 0, 0)) Sleep(100); // Wait for the thread to start.

      // Register all defined devices into the 'Devices' array.
      RegisterDevices();

      // Register all defined channels into the 'Channels' array.
      RegisterChannels();

      // Write a startup message in the event log window.
      wcscpy(MessageText, TEXT("Seislog for Windows version "));
      wcscat(MessageText,ProgVer);
      wcscat(MessageText, TEXT(" started"));
      if (DebugLevel) wcscat(MessageText, TEXT(" in debug mode."));
      if (!DebugLevel) wcscat(MessageText, TEXT("."));
      WriteSystemLog(MessageText, 1);

      // Start the system if AutoStart has been requested in the ini file.
      if (AutoStart) {
         WriteSystemLog(TEXT("Seislog: Autostarting system..."), 1);
         StartSystem();
      }

	  return 0L;


		case WM_COMMAND:
			
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam);
			
			// Parse the menu selections:
			switch (wmId)
			{
				case ID_FILE_START_SERVER:
				{
					if (ServerThreadID != 0)
					{
						MessageBox(hWnd, TEXT("Server is already running"),
							TEXT("Error"), MB_OK);
					}
					else
					{
						DialogBox(hInst, (LPCTSTR)IDD_SERVE, hWnd, (DLGPROC)ServeDlgProc);
					}

					break;
				}
				case ID_FILE_STOP_SERVER:
				{
					//ServerThreadID = 0;

					break;
				}
				case ID_FILE_STARTSYSTEM:
				 //
				 // The user has selected the 'File|Start system' command.
				 //
				 if (!IsSystemRunning()) {
					// Show the 'wait' cursor.
					SetCursor(LoadCursor(NULL, IDC_WAIT));    

					// Start the GPS system-clock syncronization thread if needed.
					if (StartGPSThread && !GPSThreadRunning) {
					   GPSThreadRunning=TRUE;
					   hSysClkSyncThread=CreateThread(NULL, 0, SysClkSyncThrd, NULL, 0, &SysClkSyncThreadID);
					}

					// Start the system.
					StartSystem();
            
					// Play a sound to indicate that system is started.
					MessageBeep(MB_ICONINFORMATION);

					// Show the normal 'arrow' cursor.
					SetCursor(LoadCursor(NULL, IDC_ARROW));   
				 } else {
					wcscpy(MessageText, TEXT("The system is already running."));
					MessageBox(hWnd, MessageText, TEXT("Seislog"), MB_OK|MB_ICONERROR);
				 }
				 return 0;


				case ID_FILE_STOPSYSTEM:
				 //
				 // The user has selected the 'File|Stop system' command.
				 //
				 if (IsSystemRunning()) {
					wcscpy(MessageText, TEXT("Are you sure you want to stop the system ?"));
					if (MessageBox(hWnd, MessageText, TEXT("Seislog"), MB_YESNO|MB_ICONQUESTION)==IDYES) {
					   // Show the 'wait' cursor.
					   SetCursor(LoadCursor(NULL, IDC_WAIT));    
               
					   // Stop the system.
					   StopSystem(FALSE);

					   // Stop the GPS system-clock syncronization thread if needed.
					   if (!StartGPSThread && GPSThreadRunning) {
						  GPSThreadRunning=FALSE;
						  PostThreadMessage(SysClkSyncThreadID, TM_EXIT, 0, 0);
						  WaitForSingleObject(hSysClkSyncThread , INFINITE);
						  SysClkSyncThreadID=0;
					   }

					   // Play a sound to indicate that system is stopped.
					   MessageBeep(MB_ICONINFORMATION);

					   // Show the normal 'arrow' cursor.
					   SetCursor(LoadCursor(NULL, IDC_ARROW));   
					}

				 } else {
					wcscpy(MessageText, TEXT("The system is not running."));
					MessageBox(hWnd, MessageText, TEXT("Seislog"), MB_OK|MB_ICONERROR);
				 }
				 return 0;


				case ID_CONFIGURE_SETTINGS:

					// Start the 'Settings' dialog box.
					
#ifdef WINCE
					ProgramSettingsDialogBox(hWnd);
#else
					DialogBox(hInst, MAKEINTRESOURCE(IDD_PROGRAM_SETTINGS), hWndFrame, (DLGPROC)ProgramSettingsDlgProc);
#endif
					return 0;

				case ID_CONFIGURE_ADMINISTERCHANNELS:
					// Start the 'Administer Channels' dialog box.
					// This procedure will handle all operations concerning channel administration.
					DialogBox(hInst, MAKEINTRESOURCE(IDD_ADMINISTER_CHANNELS), hWndFrame, (DLGPROC)AdministerChannelsDlgProc);
					return 0;

				case ID_CONFIGURE_ADMINISTERDEVICES:
					// Start the 'Administer Devices' dialog box.
					// This procedure will handle all operations concerning device administration.
					DialogBox(hInst, MAKEINTRESOURCE(IDD_ADMINISTER_DEVICES), hWndFrame, (DLGPROC)AdministerDevicesDlgProc);
					return 0;
				case IDM_VIEW_MONITORCHANNEL:
					// Start the 'Monitor channels' dialog box.
					if (IsSystemRunning()) {
						DialogBox(hInst, MAKEINTRESOURCE(IDD_MONITOR_CHANNEL), hWndFrame, (DLGPROC)MonitorChannelsDlgProc);
					} else {
						wcscpy(MessageText, TEXT("The system is not running."));
						MessageBox(hWnd, MessageText, TEXT("Seislog"), MB_OK|MB_ICONERROR);
					}
					return 0;

				case ID_CONFIGURE_EXT_GPS:
				// Start the 'Configure external GPS' dialog box.
				if (!IsSystemRunning()) {
					// Bring up the dialog box.
					DialogBox(hInst, MAKEINTRESOURCE(IDD_CNF_EXT_GPS), hWndFrame, (DLGPROC)ConfigureExternalGPSDlgProc);
					// Start/Stop GPS reader thread as neccesary.
					if (!StartGPSThread) {
					   if (GPSThreadRunning) {
						  // User would like to stop the GPS therad.
						  SetCursor(LoadCursor(NULL, IDC_WAIT));
						  PostThreadMessage(SysClkSyncThreadID, TM_EXIT, 0, 0);
						  WaitForSingleObject(hSysClkSyncThread , INFINITE);
						  GPSThreadRunning=FALSE;
						  hSysClkSyncThread=NULL;
						  SysClkSyncThreadID=0;   
						  SetCursor(LoadCursor(NULL, IDC_ARROW));
					   }
					} else {
					   if (!GPSThreadRunning) {
						  // User would like to start the GPS therad.
						  GPSThreadRunning=TRUE;
						  hSysClkSyncThread=CreateThread(NULL, 0, SysClkSyncThrd, NULL, 0, &SysClkSyncThreadID);
					   } else {
						  // Restart GPS reader thread in case the
						  // user have changed the configuration.
						  SetCursor(LoadCursor(NULL, IDC_WAIT));
						  PostThreadMessage(SysClkSyncThreadID, TM_EXIT, 0, 0); // Send exit command to the GPS thread.
						  WaitForSingleObject(hSysClkSyncThread , INFINITE);    // Wait for the thread to stop.
						  hSysClkSyncThread=CreateThread(NULL, 0, SysClkSyncThrd, NULL, 0, &SysClkSyncThreadID);
						  SetCursor(LoadCursor(NULL, IDC_ARROW));
					   }
					}
				} else {
					wcscpy(MessageText, TEXT("Can not perform this operation while the system is running."));
					MessageBox(hWnd, MessageText, TEXT("Seislog"), MB_OK|MB_ICONASTERISK);
				}
				return 0;


				case ID_FILE_EXIT:
         			// The user has selected 'Exit' from the 'File' menu.
					// The program will therefore be closed after confirmation.
					if (IsSystemRunning()) {
						wcscpy(MessageText, TEXT("Stop the system and close Seislog?"));
						if (MessageBox(hWnd, MessageText, TEXT("Seislog"), MB_YESNO|MB_ICONQUESTION)==IDYES) {
							PostMessage(hWnd, WM_CLOSE, 0, 0);
						}
					} else {
						PostMessage(hWnd, WM_CLOSE, 0, 0);
					}
					return 0;

				case ID_TRIG_CONFIGUREPARAMETERSETS:
					// Start the 'Configure Trigger Parameters' dialog box.
					DialogBox(hInst, MAKEINTRESOURCE(IDD_ADMINISTER_TRIGGERSETS), hWndFrame, (DLGPROC)AdministerTriggerSetsDlgProc);  
					return 0;

				case ID_TRIG_SIMULATEEVENT:
					if (IsSystemRunning()) {
						// Start the 'Simulate event' dialog box.
						DialogBox(hInst, MAKEINTRESOURCE(IDD_SIMULATEEVENT), hWndFrame, (DLGPROC)SimulateEventDlgProc);
					} else {
						wcscpy(MessageText, TEXT("The system is not running."));
						MessageBox(hWnd, MessageText, TEXT("Seislog"), MB_OK|MB_ICONERROR);
					}
					return 0;

				case ID_VIEW_FILE:
					PostMessage(hWndEventLog, WM_VIEW_FILE, 0, 0); 
					return 0;

				case ID_CLEAR_FILE:
					PostMessage(hWndEventLog, WM_CLEAR_FILE, 0, 0);
					return 0;

				case ID_CLEAR_WINDOW:
					PostMessage(hWndEventLog, WM_CLEAR_WINDOW, 0, 0);
					return 0;

				case IDM_HELP_ABOUT:
					// The user has selecetd 'About' from the 'Help' menu.
					// Start the 'About Seislog' dialog box.
					DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUT), hWndFrame, (DLGPROC)AboutDlgProc);  
					return 0;

				default:
					return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;

		case WM_CREATE:

#ifdef WINCE
			// [PocketPC] Create command bar
			hwndCB = CreateRpCommandBar(hWnd);

			//
			// Create the status window. This window
			// is a child window of the frame window.

			hWndStatus=CreateStatusWindow(WS_CHILD | WS_VISIBLE, TEXT("Ready"), hWnd, 40200);

			
			SetForegroundWindow(hWnd);
#else
		    //
		    // Create the status window. This window
		    // is a child window of the frame window.
		    // Also find and save height of status bar.
		    //
		    hWndStatus=CreateStatusWindow(WS_CHILD|WS_VISIBLE, TEXT("Ready"), hWnd, 40200);
		    SendMessage(hWndStatus, SB_SIMPLE, (WPARAM)TRUE, 0);
		    GetWindowRect(hWndStatus, &rect);
		    StatusBarHeight=(WORD)(rect.bottom-rect.top);


		    //
		    // Create the MDI client window.
		    //
		    ClientCreate.hWindowMenu=GetSubMenu(hMainMenu, 4);
		    ClientCreate.idFirstChild=40100;


		    hWndMDIClient=CreateWindow(TEXT("MDICLIENT"), (LPCTSTR)NULL, 
									 WS_CHILD|WS_CLIPCHILDREN|WS_VISIBLE, 0, 0, 0, 0, 
									 hWnd, (HMENU)1, hInst, (LPSTR)&ClientCreate);

#endif

			return 0L;
#ifdef WINCE
		case WM_DESTROY:
            // [PocketPC] Destroy the Command Bar
			CommandBar_Destroy(hwndCB);
			break;

		case WM_SETTINGCHANGE:
			// Notify Command Bar
			SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
     		break;
#else
		case WM_SYSCOMMAND:
		  switch(wParam) {
			 case SC_CLOSE:
			 // The user ha selected 'Close' from the system menu,
			 // or the 'x' button has been pressed.
			 PostMessage(hWnd, WM_COMMAND, ID_FILE_EXIT, 0);
			 return 0;
		  }
		  break;


		case WM_POWERBROADCAST:
			//
			// The WM_POWERBROADCAST message is sent to an 
			//	application to notify it of power-management
			//	events. 
			//
			switch((DWORD)wParam) {
			   case PBT_APMBATTERYLOW:
				// Battery power is low.
				// Stop the system if it is running.
				if (IsSystemRunning()) {
					WriteSystemLog(TEXT("Seislog: Stopping the system (Battery is running low)."), 2);
					StopSystem(FALSE);
				}
				return TRUE;

		case PBT_APMQUERYSUSPEND:
				//	Request for permission to suspend.
				// If system is running then deny request.
					if (IsSystemRunning()) {
						WriteSystemLog(TEXT("Seislog: Denying suspend request (System is running)."), 1);
						return BROADCAST_QUERY_DENY;
					}
				return TRUE;

		case PBT_APMSUSPEND:
				// The system is suspending.
				// The system must be stopped.
				if (IsSystemRunning()) {
					WriteSystemLog(TEXT("Seislog: Stopping the system (Windows is suspending operation)."), 2);
					StopSystem(FALSE);
					// Give the system time to stop.
					Sleep(10000);
				}
				return TRUE;
			}
 		    return FALSE;


		  case WM_QUERYENDSESSION:
			//
		  // The WM_QUERYENDSESSION message is sent when the user 
			//	chooses to end the session, or when an application 
			//	calls the ExitWindows function. 
		  // Returning TRUE, means it is OK to shutdown.
		  // Returning FALSE, means it is not OK to shutdown.
		  //
		  if (IsSystemRunning()) {
			 // Since the system is running, let the user confirm 
			 // that it is OK to stop Seislog (and shutdown Windows).
			 TCHAR MsgText[150];
			 wcscpy(MsgText, TEXT("Seislog is still running.\n"));
			 wcscat(MsgText, TEXT("Press OK to stop Seislog now, and shutdown Windows.\n"));
			 wcscat(MsgText, TEXT("Press Cancel to abort shutdown, and continue running Seislog."));
			 int stat=MessageBox(hWnd, MsgText, TEXT("Seislog: Windows shutdown detected"), MB_OKCANCEL|MB_ICONWARNING);
			 if (stat==IDCANCEL) return FALSE;  // User rejected shutdown. Windows will NOT go down.
		  }
		  return TRUE;


		  case WM_ENDSESSION:
		  //
		  // Windows indicates if it is actually going down. 
			// If so then Seislog must be closed.
		  //
		  if ((BOOL)wParam==TRUE) {
			 // Windows is shutting down.
				// SendMessage will not return until WM_CLOSE has been processed.
			 SendMessage(hWnd, WM_CLOSE, 0, 0); 
		  }
		  return 0;


#endif
		case WM_SIZE:
			SendMessage(hWndStatus, WM_SIZE, lParam, wParam);
			break;

      case TM_WRITE_STATUSBAR:
		    SendMessage(hWndStatus, SB_SETTEXT, 255, lParam);
		    return 0L;

	  case WM_CLOSE:
			//
			// The user is closing this program, or Windows.
			// The code below should stop the program properly.
			//
			// Stop the system if it is running. This may take a few seconds.
			if (IsSystemRunning()) {
				// Start the shutdown thread.
				// This thread will send a new WM_CLOSE message when done.

				StopSystem(TRUE); 

			} else {
				// Stop the process-keeper thread.
				PostThreadMessage(ProcKeeperThreadID, TM_EXIT, 0, 0); // Send exit command to the thread.
				WaitForSingleObject(hProcKeeperThread , INFINITE);    // Wait for the thread to stop
				CloseHandle(hProcKeeperThread);

				// Stop the time syncronization thread.
				if (StartGPSThread) {
					PostThreadMessage(SysClkSyncThreadID, TM_EXIT, 0, 0); // Send exit command to the thread.
					WaitForSingleObject(hSysClkSyncThread , INFINITE);    // Wait for the thread to stop
				}
#ifndef WINCE
				// Destroy windows.
				DestroyWindow(hWndMDIClient);
#endif
				// End this thread's message loop.
				PostQuitMessage(0);
				}
				return 0;

		default:
#ifdef WINCE			
			return DefWindowProc(hWnd, message, wParam, lParam);
#else
            return DefFrameProc(hWnd, hWndMDIClient, Message, wParam, lParam);
#endif

   }
   return 0;
}


#ifdef WINCE

/*********************************************************************************/
/* Creates a Command Bar. New in PocketPC version                                 */
/*********************************************************************************/

HWND CreateRpCommandBar(HWND hwnd)
{
	SHMENUBARINFO mbi;

	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = MAINMENU;
	mbi.hInstRes   = hInst;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;

	if (!SHCreateMenuBar(&mbi)) 
		return NULL;

	return mbi.hwndMB;
}



/*****************************************************/
/* Disable the Command Bar.                          */
/*****************************************************/

VOID DisableCommandBar() 
{

	CommandBar_Show(hwndCB, FALSE); 

}



/******************************************************/
/* Enable the Command Bar.                            */
/******************************************************/

VOID EnableCommandBar() 
{
	CommandBar_Show(hwndCB, TRUE); 

}



#endif

/*********************************************************************************/
/* Load program settings from Windows registry.                                  */
/*********************************************************************************/
BOOL ReadProgramRegistrySettings(VOID) 
{
	TCHAR str10[11];
	HKEY hKey;
	DWORD DataSize, RegData;
	LONG RegStatus;
	BOOL RegistryOK;

	// Read registry settings. 
	RegistryOK=TRUE;
	RegStatus=RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("Software\\IFJF\\Seislog"), 0, KEY_READ, &hKey);
   if (RegStatus==ERROR_SUCCESS) {

		// Get the program version.
		DataSize=sizeof(RegVersion);
      RegStatus=RegQueryValueEx(hKey, TEXT("Version"), NULL, NULL, (PBYTE)RegVersion, &DataSize);

		// Get the program directory (Required value).
		DataSize=sizeof(ProgDir);
      RegStatus=RegQueryValueEx(hKey, TEXT("ProgDir"), NULL, NULL, (PBYTE)ProgDir, &DataSize);
		if (RegStatus!=ERROR_SUCCESS) RegistryOK=FALSE;

		// Get the ringbuffer directory (Required value).
		DataSize=sizeof(RngBufDir);
      RegStatus=RegQueryValueEx(hKey, TEXT("RngBufDir"), NULL, NULL, (PBYTE)RngBufDir, &DataSize);
		if (RegStatus!=ERROR_SUCCESS) RegistryOK=FALSE;

		// Get the event file directory (Required value).
		DataSize=sizeof(EventFileDir);
      RegStatus=RegQueryValueEx(hKey, TEXT("EventFileDir"), NULL, NULL, (PBYTE)EventFileDir, &DataSize);
		if (RegStatus!=ERROR_SUCCESS) RegistryOK=FALSE;

		// Get the S-file directory (Required value).
		DataSize=sizeof(SFileDir);
      RegStatus=RegQueryValueEx(hKey, TEXT("SFileDir"), NULL, NULL, (PBYTE)SFileDir, &DataSize);
		if (RegStatus!=ERROR_SUCCESS) RegistryOK=FALSE;

		// Get the Seisan network code (Required value).
		DataSize=sizeof(NetworkCode);
      RegStatus=RegQueryValueEx(hKey, TEXT("NetworkCode"), NULL, NULL, (PBYTE)NetworkCode, &DataSize);
		if (RegStatus!=ERROR_SUCCESS) RegistryOK=FALSE;

		// Get the Seisan network name (Required value).
		DataSize=sizeof(NetworkName);
      RegStatus=RegQueryValueEx(hKey, TEXT("NetworkName"), NULL, NULL, (PBYTE)NetworkName, &DataSize);
		if (RegStatus!=ERROR_SUCCESS) RegistryOK=FALSE;

		// Get the GPS serial port.
		DataSize=sizeof(SerialPortGPS);
      RegStatus=RegQueryValueEx(hKey, TEXT("GPSSerialPort"), NULL, NULL, (PBYTE)SerialPortGPS, &DataSize);

		// Get the GPS mean time delay before $GPRMC.
		DataSize=10;
      RegStatus=RegQueryValueEx(hKey, TEXT("GPSMeanTimeBeforeGPRMC"), NULL, NULL, (PBYTE)str10, &DataSize);

	 //!OJ
	 char strTemp10[11];
	 wcstombs(strTemp10, str10, 11);
	 MeanTimeBeforeGPRMC=atof(strTemp10);
	 //MeanTimeBeforeGPRMC=atof(str10);
	 //OJ	  
 

		// Get status for automatic creation of S-file subdirs.
		DataSize=sizeof(RegData);
      RegStatus=RegQueryValueEx(hKey, TEXT("CreateSFileSubDirs"), NULL, NULL, (PBYTE)&RegData, &DataSize);
		AppendSeisanSubdirs=(BOOL)RegData;

		// Get status of GPS syncronization.
		DataSize=sizeof(RegData);
      RegStatus=RegQueryValueEx(hKey, TEXT("GPSSyncronization"), NULL, NULL, (PBYTE)&RegData, &DataSize);
		StartGPSThread=(BOOL)RegData;

		// Get GPS debug switch.
		DataSize=sizeof(RegData);
      RegStatus=RegQueryValueEx(hKey, TEXT("GPSDebug"), NULL, NULL, (PBYTE)&RegData, &DataSize);
		GPSDebug=(BOOL)RegData;

		// Get AutoStart setting.
		DataSize=sizeof(RegData);
      RegStatus=RegQueryValueEx(hKey, TEXT("AutoStart"), NULL, NULL, (PBYTE)&RegData, &DataSize);
		AutoStart=(BOOL)RegData;

		// Get debug level.
		DataSize=sizeof(RegData);
      RegStatus=RegQueryValueEx(hKey, TEXT("DebugLevel"), NULL, NULL, (PBYTE)&RegData, &DataSize);
		DebugLevel=(BYTE)RegData;

		// Get trigger debug switch.
		DataSize=sizeof(RegData);
      RegStatus=RegQueryValueEx(hKey, TEXT("TriggerDebug"), NULL, NULL, (PBYTE)&RegData, &DataSize);
		TriggerDebug=(BOOL)RegData;

	} else {
		RegistryOK=FALSE;
	}

	// Close the Seislog registry key.
	RegCloseKey(hKey); 

	return RegistryOK;
}



/*********************************************************************************/
/* Saves program settings to Windows registry.                                   */
/*********************************************************************************/
BOOL WriteProgramRegistrySettings(VOID) 
{
	TCHAR str10[11];
	HKEY hKey;
	DWORD RegData, Disp;
	LONG RegStatus;

	// Get handle to Seislog key. 
	// Key is created as needed. 
	RegStatus=RegCreateKeyEx(HKEY_LOCAL_MACHINE, TEXT("Software\\IFJF\\Seislog"), 0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE , NULL, &hKey, &Disp);
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Set the program version.
   RegStatus=RegSetValueEx(hKey, TEXT("Version"), 0, REG_SZ, (PBYTE)ProgVer, (DWORD)((wcslen(ProgVer)+1)*sizeof(TCHAR)) );
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Set the program directory.
   RegStatus=RegSetValueEx(hKey, TEXT("ProgDir"), 0, REG_SZ, (PBYTE)ProgDir, (DWORD)((wcslen(ProgDir)+1)*sizeof(TCHAR)));
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Set the ringbuffer directory.
   RegStatus=RegSetValueEx(hKey, TEXT("RngBufDir"), 0, REG_SZ, (PBYTE)RngBufDir, (DWORD)((wcslen(RngBufDir)+1)*sizeof(TCHAR)));
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Set the event file directory.
   RegStatus=RegSetValueEx(hKey, TEXT("EventFileDir"), 0, REG_SZ, (PBYTE)EventFileDir, ((DWORD)(wcslen(EventFileDir)+1)*sizeof(TCHAR)));
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Get the S-file directory.
   RegStatus=RegSetValueEx(hKey, TEXT("SFileDir"), 0, REG_SZ, (PBYTE)SFileDir, (DWORD)((wcslen(SFileDir)+1)*sizeof(TCHAR)));
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Get the Seisan network code.
   RegStatus=RegSetValueEx(hKey, TEXT("NetworkCode"), 0, REG_SZ, (PBYTE)NetworkCode, (DWORD)((wcslen(NetworkCode)+1)*sizeof(TCHAR)));
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Get the Seisan network name.
   RegStatus=RegSetValueEx(hKey, TEXT("NetworkName"), 0, REG_SZ, (PBYTE)NetworkName, (DWORD)((wcslen(NetworkName)+1)*sizeof(TCHAR)));
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Get the GPS serial port.
   RegStatus=RegSetValueEx(hKey, TEXT("GPSSerialPort"), 0, REG_SZ, (PBYTE)SerialPortGPS, (DWORD)((wcslen(SerialPortGPS)+1)*sizeof(TCHAR)));
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Get the GPS mean time delay before $GPRMC.
	swprintf(str10, TEXT("%.5f"), MeanTimeBeforeGPRMC);
   RegStatus=RegSetValueEx(hKey, TEXT("GPSMeanTimeBeforeGPRMC"), 0, REG_SZ, (PBYTE)str10, (DWORD)((wcslen(str10)+1)*sizeof(TCHAR)));
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Get status for automatic creation of S-file subdirs.
	RegData=(DWORD)AppendSeisanSubdirs;
   RegStatus=RegSetValueEx(hKey, TEXT("CreateSFileSubDirs"), 0, REG_DWORD, (PBYTE)&RegData, sizeof(RegData));
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Get status of GPS syncronization.
   RegData=(DWORD)StartGPSThread;
   RegStatus=RegSetValueEx(hKey, TEXT("GPSSyncronization"), 0, REG_DWORD, (PBYTE)&RegData, sizeof(RegData));
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Get AutoStart setting.
	RegData=(DWORD)AutoStart;
   RegStatus=RegSetValueEx(hKey, TEXT("AutoStart"), 0, REG_DWORD, (PBYTE)&RegData, sizeof(RegData));
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Get debug level.
	RegData=(DWORD)DebugLevel;
   RegStatus=RegSetValueEx(hKey, TEXT("DebugLevel"), 0, REG_DWORD, (PBYTE)&RegData, sizeof(RegData));
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Get trigger debug switch.
	RegData=(DWORD)TriggerDebug;
   RegStatus=RegSetValueEx(hKey, TEXT("TriggerDebug"), 0, REG_DWORD, (PBYTE)&RegData, sizeof(RegData));
	if (RegStatus!=ERROR_SUCCESS) return FALSE;

	// Close the Seislog registry keys.
	RegCloseKey(hKey); 

	return TRUE;
}

