
#if !defined(AFX_SEISLOG_H__2599BDEE_D74B_4ABD_9703_4ABD33911CF6__INCLUDED_)
#define AFX_SEISLOG_H__2599BDEE_D74B_4ABD_9703_4ABD33911CF6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "resource.h"

VOID EnableCommandBar(); 
VOID DisableCommandBar(); 

#define MENU_HEIGHT 52


// ***************************************************************************************
// Define program constants/limits.
// ***************************************************************************************
#define MAX_NUM_OF_DEVICES		    	16	  // The max number of devices the program can handle.
#define MAX_CHANNELS_PR_DEVICE			64    // The max number of channels a device can have.
#define MAX_NUM_OF_CHANNELS				64    // The total number of logical channels the system can handle. Max value is 255.
#define MAX_NUM_OF_TRIGGERSETS			5     // The max number of trigger sets the program can handle.



// ***************************************************************************************
// Declare program defined messages.
// ***************************************************************************************
#define WM_STARTUP							WM_USER+1	// 1025
#define TM_BUFFERUPDATED					WM_USER+50	// 1074
#define TM_DEVICEREADER_BUFFERUPDATEFAILED	WM_USER+51	// 1075
#define TM_DEVICEREADER_NODATAINPUT			WM_USER+52	// 1076
#define TM_DEVICEREADER_DATAINPUTOK			WM_USER+53	// 1077
#define TM_DUMMY							WM_USER+60	// 1084
#define TM_START							WM_USER+70	// 1094
#define TM_STOP								WM_USER+71	// 1095
#define TM_EXIT								WM_USER+72	// 1096
#define TM_CONFIGURE						WM_USER+73	// 1097
#define TM_GET_INTERFACE					WM_USER+74	// 1098
#define TM_GET_UNIQUE_DEVICE_NAME			WM_USER+75	// 1199
#define TM_GET_STATION						WM_USER+76	// 1100
#define TM_GET_COMPONENT					WM_USER+77	// 1101
#define TM_GET_PROC_NAME					WM_USER+78	// 1102
#define TM_GET_RBFILE						WM_USER+79	// 1103
#define TM_GET_CHNUMBER						WM_USER+80	// 1104
#define TM_GET_DEVMANAGER					WM_USER+81	// 1105
#define TM_GET_RESOURCE_STRING				WM_USER+82  // 1106
#define TM_SUBSCRIBE						WM_USER+83	// 1107
#define TM_UNSUBSCRIBE						WM_USER+84	// 1108
#define TM_DISK_WRITE						WM_USER+85	// 1109
#define TM_RB_FILECHANGE					WM_USER+86	// 1110
#define TM_OPERATION_HALTED					WM_USER+87	// 1111
#define TM_DEVICEREADER_BADBLOCK			WM_USER+88	// 1112
#define TM_INITIALIZE						WM_USER+90	// 1114
#define TM_REGISTER_PROCESS					WM_USER+91	// 1115
#define TM_UNREGISTER_PROCESS				WM_USER+92	// 1116
#define TM_SET_DEPENDENCY					WM_USER+93	// 1117
#define TM_GET_DEPENDENCIES					WM_USER+94	// 1118
#define TM_GET_DEVICEMANAGERS				WM_USER+95	// 1119
#define TM_GET_CHANNELS						WM_USER+96	// 1120
#define TM_GET_RINGBUFFERS					WM_USER+97	// 1121
#define TM_GET_EVENTDETECTIONS				WM_USER+98	// 1122
#define TM_GET_PROCESS_BY_NAME				WM_USER+99	// 1123
#define TM_GET_NUM_REGISTERED				WM_USER+100 // 1124
#define TM_DEPTHREADS_STOPPED				WM_USER+101 // 1125
#define TM_BUFFER_UPDATED					WM_USER+102	// 1126
#define TM_GET_BUFFER						WM_USER+103	// 1127
#define TM_GET_BUFFER_PROPERTIES            WM_USER+104	// 1128
#define TM_GET_RINGBUFFER					WM_USER+105	// 1129
#define TM_GET_BLOCKSIZE					WM_USER+106	// 1130
#define TM_GET_CURRENT_BLOCK				WM_USER+107	// 1131
#define TM_GET_BLOCKNR                      WM_USER+108	// 1132
#define TM_GET_BLOCK_RANGE                  WM_USER+109	// 1133
#define TM_GET_NUMOFBLOCKS					WM_USER+110	// 1134
#define TM_GET_CHANNEL_INFO				    WM_USER+111	// 1135
#define TM_GET_CHANNEL_STATUS				WM_USER+112	// 1136
#define TM_GET_LOG_CHNUMBER					WM_USER+113 // 1137
#define TM_TRIG_START                       WM_USER+114 // 1138
#define TM_TRIG_STOP                        WM_USER+115 // 1139
#define TM_GET_TRGSET_NUMBER                WM_USER+116 // 1140
#define TM_NETWORK_TRIG_START               WM_USER+117 // 1141
#define TM_NETWORK_TRIG_STOP                WM_USER+118 // 1142
#define TM_GET_EVENT_STATUS					WM_USER+119	// 1143
#define TM_TICKER                           WM_USER+120 // 1144
#define TM_TIMESYNC_STATUS                  WM_USER+121 // 1145
#define TM_GET_TIMESYNC_STATUS              WM_USER+122 // 1146
#define TM_DEVICEREADER_NOFIX               WM_USER+123 // 1147
#define TM_DEVICEREADER_FIXOK               WM_USER+124 // 1148
#define TM_WRITE_STATUSBAR                  WM_USER+125 // 1149
#define TM_SHOW_CONFIG						WM_USER+126 // 1150
#define TM_APPLY_CONFIGURATION              WM_USER+127 // 1151

#define TM_MONTIOR_PROPERITES               WM_USER+128 // 1152

#define WM_STEPPROGRESSBAR					WM_USER+200	// 1224
#define WM_CLOSEDIALOG						WM_USER+201	// 1225
#define WM_WRITE_LOG						WM_USER+202	// 1226
#define WM_PROGRESSBARWND_SETTEXTS			WM_USER+203	// 1227
#define WM_PROGRESSBAR_RECONFIG				WM_USER+204	// 1228
#define WM_MONIOR_PROPERTIES                WM_USER+205 // 1228

/*
#define SC_CLEAR_WINDOW      0xE000
#define SC_CLEAR_FILE        0xE001
#define SC_VIEW_FILE         0xE002
*/

// [PocketPC] These window message replace the system commands
// and is handled in the Event Log window procedure
#define WM_CLEAR_WINDOW                     WM_USER+210 //1234
#define WM_CLEAR_FILE                       WM_USER+211 //1235
#define WM_VIEW_FILE                        WM_USER+212 //1236


// *************************************************************************************** //
// Define structures.
// *************************************************************************************** //
struct BLOCK_HEADER {      // All data blocks comes with this header.
	DWORD	BlockID;          // Every block gets a unique id-number.
	SYSTEMTIME TimeTag;     // Start time of block. (Device Manager Thread)
   BYTE TimeQuality;       // 0=Time is unsynced. No sync possibilities exists.
                           // 1=Time is unsynced. Syncronisation is enabled, but device/system clock is not syncronised right now.
                           // 2=Time is synced. Syncronisation is enabled, and device/system clock is syncronised.
                           // 3=Time is unsynced. An error is occuring (disconnected or misconfigured GPS?).
	BOOL NullData;          // TRUE if this block contains only zero values. (Device Manager Thread)
	BOOL DataLost;          // TRUE if this is the first block after a loss of datainput. (Device Manager Thread)
	BOOL EventDetected;     // TRUE if this block is part of a detected event. (Channel Thread)
	WORD EventTime;			// If event start in this block, this value gives an offset (in ms) to start of event.
									// If this block is in the middle or end of event, this value is zero.
};


struct DEVICE_INFO {
	WORD DeviceID;
	TCHAR UniqueDeviceName[65];
	BYTE NumChannels;
};


struct CHANNEL_INFO {
	TCHAR ChannelName[10];
   BOOL UseTrigging;
	TCHAR DeviceName[65];
	BYTE DeviceChannel;
};


struct BUFF_PROP {
   PVOID pBuffer;             // Pointer to start of buffer.
   DWORD NumBlocksInBuffer;   // Number of blocks in buffer.
   WORD  BlocksizeInBytes;    // The size of each block measured in bytes.
   WORD  BlockSizeInMS;       // The size of each block measured in milliseconds.
   WORD  SamplesPrBlock;      // Number of samples in each block.
   WORD  SampleRate;          // The samplerate for the samples.
};



struct TRIGGERSET_INFO {
	TCHAR Name[65];
};


struct DEVMNGR_INTERF_STRUCT {                   // This structure is initialized and 
                                                 // exported from all device-manager threads.
	TCHAR		Manufacturer[64];                    // Manufacturer name.
	TCHAR		Model[64];                           // Model description.
	WORD		SampleRate;                          // Device samplerate.
	WORD     SamplesPrBlock;                      // Number of samples pr. block.
	WORD		NumChannels;                         // Number of physical channels.
	WORD		BlockSize;                           // The size of each block mesured in bytes.
	WORD		BlockSizeInMS;								 // The size of each block measured in ms.
	WORD		NumBlocksPrChannel;                  // Number of blocks in channel-ringbuffers.
	PVOID		ChannelData[MAX_CHANNELS_PR_DEVICE]; // Array of pointers that point to start of
                                                 // each channel's ringbuffer (data blocks).
};



struct STARTINFO_DEVMANAGER {   // This structure is used to pass startup 
                                // information to a device-manager thread.

	HINSTANCE hInstance;			  // Handle to program instance.
	DWORD ThreadID;				  // Thread-ID for parent thread.
	DWORD ProcKeeprThreadID;	  // Thread-ID for the process keeper thread.
	TCHAR DeviceDir[MAX_PATH+1];  // Device directory for this device instance.
	BOOL ConfigOnly;				  // TRUE if the thread is started for configuration only. 	
	HANDLE StartEvent;			  // Handle to an event object. The device manager
										  // must signal this event when properly started.	
};



struct MSG_PARAM {        // This structure can (or must) be passed to a device
                          // manager thread when sending a thread message to it. 
                          // A pointer to this structure should be given in the 
                          // 'lParam' parameter in the call to 'PostTreadMessage'.
                          // A handle to an event object can be given in the wParam 
                          // parameter. The calling thread should then wait for the 
                          // event to be signaled. The called thread will process 
                          // the message, set the status variables in this structure, 
                          // and then signal the event. The calling thread is released, 
                          // and can examine the return status variables.
                          //
                          // wStatus values:
                          //
                          // 0   - Unknown error or no error.
                          // 1   - 'CreateThread' failed.
                          // 2   - 'DialogBoxParam' failed.			
                          // 3   - 'GlobalAlloc' failed. 
                          // 100 - User canceled the operation.
                          // 150 - Ringbuffer creation failed.

	BOOL		bStatus;		  // TRUE if the message was processed sucessfully, else FALSE.
	WORD		wStatus;		  // Returns an error value, 0=no error.
	DWORD    dwStatus;     // Transfers a DWORD value.
	TCHAR		cStatus[256]; // Transfers a character string.
	LPVOID	vPointer;	  // Transfers a void pointer.
	DWORD    idThread;     // Transfers a Thread-ID.
};
// wStatus values:
//
// 0   - Unknown error or no error.
//	1   - 'CreateThread' failed.
// 2   - 'DialogBoxParam' failed.			
// 3   - 'GlobalAlloc' failed. 
// 100 - User canceled the operation.
// 150 - Ringbuffer creation failed.


struct SUBSCRIBE {   // This structure must be used when sending one of the SUBSCRIBE
                     // thread messages to a device manager thread. The structure must be 
                     // filled out and a pointer to it placed in the MSG_PARAM structure
                     // (which must accompany the SUBSCRIBE message).

	UINT	uiMessage;  // Which message to subscribe to.
	DWORD idThread;	// If the subscribing function is a thread, give it thread id.
	HWND hWnd;			// If the subscribing function is a window proc, give it window handle.
							// NOTE: One of the two last members must be NULL.
};


#endif // !defined(AFX_SEISLOG_H__2599BDEE_D74B_4ABD_9703_4ABD33911CF6__INCLUDED_)
