//
//
// Author: yvind Natvik 1999.
//
//
//
//
//

#include "stdafx.h"
#include <aygshell.h>

#define WINCE

//#define STRICT

#define NODATA  65535
#define NOEVENT 65534
#define PRE_ALLOWANCE 10   // The max number of seconds a digitizer's time can be ahead of the system time. 
#define POST_ALLOWANCE 10  // The max number of seconds a digitizer's time can be behind the system time. 
#define EventTab(row, column) (*(pTable+(row*NumCols)+column)) // Macro for accessing the 'EventTab' table elements.
#include <windows.h>
#include <stdio.h>
#include <prsht.h>
#include <Commctrl.h>
#include "resource.h"
#include "seislog.h"
#include "trigger.h"
#include "writeevent.h"
#include "library.h"
#include "msglist.h"
#include "process.h"
#include "eventlog.h"
#include "channel.h"

//
// Theese are global variables used
// by functions in this file.
//
extern HINSTANCE hInst;
extern DWORD ProcKeeperThreadID;
extern TCHAR TriggerDir[];
extern TCHAR EventFileDir[];
extern TCHAR SFileDir[];
extern TRIGGERSET_INFO Triggers[];
extern BYTE NumRegisteredTriggersets;
extern BYTE NumRegisteredChannels;
extern BYTE DebugLevel;
extern CHANNEL_INFO Channels[];
extern DWORD TickerThreadID;
extern BOOL TriggerDebug;
extern BOOL AppendSeisanSubdirs;

//
// Definitions of structures used 
// only by functions in this file.
//
struct CHINFO {
   BYTE LogicalChNr;
   DWORD ThreadID;
   BUFF_PROP BufProp;
   WORD TimeSpan;
   SYSTEMTIME TrigStartTime;
   SYSTEMTIME TrigStopTime;
   BOOL TrigStarted;
   BOOL TrigStopped;
   WORD EOEWatchCol;
};

//
// Prototype declerations
//
DWORD WINAPI WriteEventThrdProc(PVOID); 
BOOL CALLBACK AddTriggersetDlgProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK ModifyTriggersetDlgProc(HWND, UINT, WPARAM, LPARAM);
VOID MoveTablePointerUp(WORD*, WORD, WORD);
VOID MoveTablePointerDown(WORD*, WORD, WORD);
BOOL ExistTriggerset(PTCHAR);
VOID GetCurUTCTime(SYSTEMTIME*);
BYTE GetChannelRow(DWORD, CHINFO*, BYTE);
WORD GetPhysicalCol(WORD, WORD, WORD);
BOOL AddSeisanSudirs(PTCHAR, SYSTEMTIME); 
BOOL EventInRow(WORD, PWORD, WORD, WORD, WORD, WORD);
BOOL FindNetworkEventStartCol(PWORD, PWORD, WORD, WORD, WORD, WORD, WORD);
BOOL FindTrigColumns(WORD, PWORD, WORD, WORD, WORD, WORD, PWORD, PWORD);
WORD FindEventStopColWithinEventwindow(WORD, WORD, PWORD, WORD, WORD, WORD, WORD);
VOID GetColumnTime(WORD, SYSTEMTIME*, SYSTEMTIME, WORD);
INT CheckTriggersetChannels(TRIG_SET_CNF_FILE*);
VOID RemoveNonexistingChnlsFromTrigset(TRIG_SET_CNF_FILE*);

// [ PocketPC ]
BOOL CALLBACK AddTriggersetDlgProc1(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK AddTriggersetDlgProc2(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK AddTriggersetDlgProc3(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL AddTriggersetDialogBox(HINSTANCE hInst, HWND hWnd, LPARAM lParam);

HWND hAddTriggersetDlg;
// [ End PocketPC ]


/**************************************************************************/
/* System-event detection thread. Thread handles one triggerset.          */
/**************************************************************************/
DWORD WINAPI EventDetectionThrd(PVOID StartupInfo) 
{
   MSG msg;
   WORD CurTimeCol, EventwinFirstCol, EventwinLastCol, LogicalCol;
   WORD NumCols, column, LargestBlckSizeInSec, TimeDiffInWholeSecs;
   WORD NumColsCovered, ScrollOffset, NumEvents, EventLength, NumRows;
   WORD ChEventStartCol, EventEndCol, ColIndex, LastCol, EOEWatchCol;
   WORD *pTable, NetworkEventStartCol;
   DWORD CurrentThreadID, ChThreadIDs[MAX_NUM_OF_CHANNELS], ChThreadID;
   DWORD RunningChannels[MAX_NUM_OF_CHANNELS], BlockNr, ThreadID;
   DWORD BufferSizeInMS, MinChBufferSize;
   DOUBLE Seconds, MilliSeconds;
   HANDLE hEvent;
   MSG_PARAM RP, IP, MsgParam;
   SUBSCRIBE SubscrData;
   BYTE NumTrigChannels, NumDumpChannels, RowIndex;
   BYTE Index, NumRunningChannels, LogicalChNum, EventStatus;
   BYTE Index2, NumTriggedChannels;
   TCHAR ConfigFile[MAX_PATH+1], Message[500], CmpResult;
   TCHAR UniqueProcName[65], str2[3], str10[11], str20[21];
   TCHAR File[MAX_PATH+1];
   MsgList NotifyList;
   CHINFO *pChInfo;
   BUFF_PROP BuffProp;
   BLOCK_HEADER BlockHdr;
   SYSTEMTIME FirstColTime, LastColTime, CurTime, ColumnTime;
   SYSTEMTIME EventStartTime, EventStopTime, TrigTime;
   TRIG_SET_CNF_FILE TrgSetCnf;
   STARTINFO_EVENTDETECTION SI;
   STARTINFO_WRITEEVENT *SIWE;
   BOOL Running, StartupOK, EventDump, UndersizedBuffer, Warning;
   BOOL EventStarted, FirstTick, BlockTimeOutOfRange, *pBool;

   
   //
   // Initialize some variables.
   //
   Running=FALSE;
   StartupOK=TRUE;
   CurrentThreadID=GetCurrentThreadId();  // Get and save the Thread-ID for this thread.


   //
   // Copy thread's startup information to a local buffer (SI).
   //
   CopyMemory((PVOID)&SI, StartupInfo, sizeof(STARTINFO_EVENTDETECTION));


   //
   // Create a unique name for this instance of the event-detection process. 
   //
   wcscpy(UniqueProcName, TEXT("NetworkTrigger ("));
   wcscat(UniqueProcName, SI.Name);
   wcscat(UniqueProcName, TEXT(")"));


   //
   // Read triggerset configuration file.
   //
   AddPathAndFilename(ConfigFile, TriggerDir, SI.Name);
   wcscat(ConfigFile, TEXT(".trg"));
   if (!ReadFileToMemory(ConfigFile, (PVOID)&TrgSetCnf, (DWORD)sizeof(TRIG_SET_CNF_FILE))) {
      // Config file is missing or corrupt, thread cannot continue. Write message in the log.
      wcscpy(Message, UniqueProcName);
      wcscat(Message, TEXT(": Unable to read triggerset config file. Operation halted."));
      WriteSystemLog(Message, 3);
      StartupOK=FALSE;
      goto RegisterProcess;
   }


   //
   // Get and save the thread-id for all running channels.
   //
   // Get list of running channels. ThreadID's are returned.
   ZeroMemory((PVOID)RunningChannels, (DWORD)sizeof(RunningChannels));
   NumRunningChannels=GetRunningChannels(RunningChannels);
   if (!NumRunningChannels) {
      // No channels are running, opreation will be aborted.
      wcscpy(Message, UniqueProcName);
      wcscat(Message, TEXT(": No channels are running.  Operation halted."));
      WriteSystemLog(Message, 3);
      StartupOK=FALSE;
      goto RegisterProcess;
   }

   //
   // Register thread's in the 'ChThreadIDs' table.
   ZeroMemory((PVOID)&ChThreadIDs, (DWORD)sizeof(ChThreadIDs));
   hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
   for (Index=0;Index<NumRunningChannels;Index++) {
      // Get logical channelnumber by asking the running channel.
      PostThreadMessage(RunningChannels[Index], TM_GET_LOG_CHNUMBER, (WPARAM)hEvent, (LPARAM)&MsgParam); 
      WaitForSingleObject(hEvent, INFINITE);
      LogicalChNum=(BYTE)MsgParam.wStatus;

      // Register threadID in table.
      ChThreadIDs[LogicalChNum-1]=RunningChannels[Index];
   }
   CloseHandle(hEvent);   


 
   //
   // Check that all channels referred to in the 
   // configuration really exist and are running.
   // For all trig-channels, check that trigging 
   // is turned on.
   //
   for (Index=0;Index<NumRegisteredChannels;Index++) {
      // Ignore all channels that does not have trigging enabled, 
      // but is still marked as active in the triggerset configuration.
      if (TrgSetCnf.TrigChannels[Index] && !Channels[Index].UseTrigging) {
         // This channel do not have trigging enabled. Ignore this channel.
         TrgSetCnf.TrigChannels[Index]=FALSE;

         // Write warning in the system log.
         wcscpy(Message, UniqueProcName); wcscat(Message, TEXT(": Channel"));
         swprintf(str2, TEXT("%02u"), Index+1); wcscat(Message, str2);
         wcscat(Message, TEXT(" is selected in the triggerset, but does not have trigging enabled."));
         wcscat(Message, TEXT(" Channel will be ignored. Enable trigging for this channel, or remove it from the triggerset."));
         WriteSystemLog(Message, 2);
      }
      // Ignore all channels that is not running, but is
      // marked as active in the triggerset configuration.
      Warning=FALSE;
      if (TrgSetCnf.TrigChannels[Index] && !ChThreadIDs[Index]) { TrgSetCnf.TrigChannels[Index]=FALSE; Warning=TRUE; }
      if (TrgSetCnf.DumpChannels[Index] && !ChThreadIDs[Index]) { TrgSetCnf.DumpChannels[Index]=FALSE; Warning=TRUE; }
      if (Warning) {
         // Write warning in the system log.
         wcscpy(Message, UniqueProcName); wcscat(Message, TEXT(": Channel"));
         swprintf(str2, TEXT("%02u"), Index+1); wcscat(Message, str2);
         wcscat(Message, TEXT(" is selected in the triggerset, but is currently not running."));
         wcscat(Message, TEXT(" Channel will be ignored."));
         WriteSystemLog(Message, 2);
      }
   }
   for (Index=NumRegisteredChannels;Index<MAX_NUM_OF_CHANNELS;Index++) {
      // Ignore all channels that do no longer exist, but 
      // are still active in the triggerset configuration.
      if  (TrgSetCnf.TrigChannels[Index] || TrgSetCnf.DumpChannels[Index]) {
         // Turn off trigging for this channel.
         TrgSetCnf.TrigChannels[Index]=FALSE;

         // Turn off dumping for this channel.
         TrgSetCnf.DumpChannels[Index]=FALSE;

         // Write warning in the system log.
         wcscpy(Message, UniqueProcName); wcscat(Message, TEXT(": Channel"));
         swprintf(str2, TEXT("%02u"), Index+1); wcscat(Message, str2);
         wcscat(Message, TEXT(" is selected in the triggerset, but does not exist."));
         wcscat(Message, TEXT(" Channel will be ignored. Please remove this channel from the triggerset."));
         WriteSystemLog(Message, 2);
      }
   }


   //
   // Calculate number of trig-channels/dump-channels.
   //
   NumTrigChannels=NumDumpChannels=0;
   for (Index=0;Index<NumRegisteredChannels;Index++) {
      if (TrgSetCnf.TrigChannels[Index]) NumTrigChannels++;
      if (TrgSetCnf.DumpChannels[Index]) NumDumpChannels++;
   }
   // If either of theese are zero, then abort operation.
   if (!NumTrigChannels || !NumDumpChannels) {
      wcscpy(Message, UniqueProcName);
      wcscat(Message, TEXT(": "));
      if (!NumTrigChannels) wcscat(Message, TEXT("No valid channels selected for trigging."));
      if (!NumDumpChannels) wcscat(Message, TEXT("No running channels selected for dumping."));
      wcscat(Message, TEXT(" Operation halted."));
      WriteSystemLog(Message, 3);
      StartupOK=FALSE;
      goto RegisterProcess;
   }


   //
   // Check that enough trig channels are running
   // for an event to be able to be trigged.
   //
   if (NumTrigChannels< TrgSetCnf.NumTrigsInTimeWindow) {
      // To few trig channels are running. We fix this 
      // problem by reducing the required number of 
      // channels given in the triggerset configuration.
      TrgSetCnf.NumTrigsInTimeWindow=NumTrigChannels;
   }
   

   //
   // Check that the memory buffer for all channels selected for
   // dumping is large enough. All buffers should be equal to or
   // greater then the sum of the following variabls and constants: 
   //       PreEventTime, MaxEventDuration, PostEventTime, 60.
   //
   UndersizedBuffer=FALSE;
   MinChBufferSize=TrgSetCnf.PreEventTime+TrgSetCnf.MaxEventDuration+TrgSetCnf.PostEventTime+60;
   for (Index=0;Index<NumRegisteredChannels;Index++) {
      if (TrgSetCnf.DumpChannels[Index]) {
         // This channel has been selected for dumping.
         // Check the size of the memory buffer.
         MsgParam.vPointer=&BuffProp;
         hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
         PostThreadMessage(ChThreadIDs[Index], TM_GET_BUFFER_PROPERTIES, (WPARAM)hEvent, (LPARAM)&MsgParam);
         WaitForSingleObject(hEvent, INFINITE);
         CloseHandle(hEvent);
         BufferSizeInMS=BuffProp.NumBlocksInBuffer*BuffProp.BlockSizeInMS;
         if (BufferSizeInMS<MinChBufferSize*1000) UndersizedBuffer=TRUE;
      }
   }
   if (UndersizedBuffer) {
      // One or more of the channel buffers are to small.
      // Write error message and disable thread operation.
      wcscpy(Message, UniqueProcName);
      wcscat(Message, TEXT(": One or more channels included in triggerset have "));
      wcscat(Message, TEXT("too small memory buffers. Minimum required size is "));
      _itow(MinChBufferSize, str10, 10); wcscat(Message, str10);
      wcscat(Message, TEXT(" seconds. Operation halted."));
      WriteSystemLog(Message, 3);
      StartupOK=FALSE;
      goto RegisterProcess;
   }



   //
   // Allocate memory for, and initialize, the 'ChInfo' table.
   //
   pChInfo=(CHINFO*)LocalAlloc(LPTR, (UINT)(NumTrigChannels*sizeof(CHINFO)));
   if (pChInfo==NULL) {
      // Write error message in the program log.
      wcscpy(Message, UniqueProcName);
      wcscat(Message, TEXT(": Unable to allocate memory. Operation halted."));
      WriteSystemLog(Message, 3);
      StartupOK=FALSE;
      goto RegisterProcess;
   }
   // Initialize, the 'ChInfo' table.
   Index2=0;
   hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
   for (Index=0;Index<NumRegisteredChannels;Index++) {
      if (TrgSetCnf.TrigChannels[Index]) {
         // Save the logical channel nr.
         pChInfo[Index2].LogicalChNr=Index+1;
         // Save the channel's thread-id.
         pChInfo[Index2].ThreadID=ChThreadIDs[Index];
         // Get and save the channel's buffer properties.
         MsgParam.vPointer=&pChInfo[Index2].BufProp;
         PostThreadMessage(ChThreadIDs[Index], TM_GET_BUFFER_PROPERTIES, (WPARAM)hEvent, (LPARAM)&MsgParam);
         WaitForSingleObject(hEvent, INFINITE);
         // Calculate and save a block's time span measured in whole seconds.
         Seconds=(FLOAT)(pChInfo[Index2].BufProp.BlockSizeInMS/1000.0);
         pChInfo[Index2].TimeSpan=(WORD)Seconds;
         if (Seconds-(FLOAT)pChInfo[Index2].TimeSpan > 0.0) pChInfo[Index2].TimeSpan++;
         // Initialize the TrigStartTime and TrigStopTime member.
         ZeroMemory((PVOID)&pChInfo[Index2].TrigStartTime, (DWORD)sizeof(SYSTEMTIME));
         ZeroMemory((PVOID)&pChInfo[Index2].TrigStopTime, (DWORD)sizeof(SYSTEMTIME));
         // Initialize the TrigStarted member.
         pChInfo[Index2].TrigStarted=FALSE;
         // Initialize the TrigStopped member.
         pChInfo[Index2].TrigStopped=FALSE;
         // Initialize the EOEWatchCol member.
         pChInfo[Index2].EOEWatchCol=0;

         // Move down the index into the pChInfo table.
         Index2++;
      }
   }
   CloseHandle(hEvent);



   //
   // Search trough all channels selected for trigging,
   // and find the largest block size (measured in seconds).
   //
   LargestBlckSizeInSec=0;
   for (Index=0;Index<NumTrigChannels;Index++) {
      LargestBlckSizeInSec=max(pChInfo[Index].TimeSpan, LargestBlckSizeInSec);
   }



   //
   // Calculate number of rows and columns in the 'EventTab' table.
   //
   NumRows=NumTrigChannels;
   NumCols=PRE_ALLOWANCE+1+LargestBlckSizeInSec+1+POST_ALLOWANCE;
   NumCols=NumCols+TrgSetCnf.TimeWindowLength+TrgSetCnf.PreEventTime;



   //
   // Allocate memory for the 'EventTab' table.
   // Each table entry is a WORD (2 bytes).
   //
   pTable=(PWORD)LocalAlloc(LPTR, (UINT)(NumCols*NumRows*2));
   if (!pTable) {
      // Write error message in the program log.
      wcscpy(Message, UniqueProcName);
      wcscat(Message, TEXT(": Unable to allocate memory.  Operation halted."));
      WriteSystemLog(Message, 3);
      StartupOK=FALSE;
   }

   

   //
   // Register this process in the process database.
   //
   RegisterProcess: RegisterProcess(UniqueProcName, 7, CurrentThreadID);


   //
   // Register dependencies with the channel processes.
   //
   if (StartupOK) {
      for (Index=0;Index<NumRunningChannels;Index++) {
         if (TrgSetCnf.TrigChannels[Index] || TrgSetCnf.DumpChannels[Index]) {
            RegisterDependency(CurrentThreadID, ChThreadIDs[Index]);
         }
      }
   }


   //
   // If running in debug mode, write a startup message to the log.
   //
   if (DebugLevel) {
      wcscpy(Message, UniqueProcName);
      wcscat(Message, TEXT(": Thread started."));
      WriteSystemLog(Message, 1);
   }
   

   //
   // Signal to the parent process that thread has started.
   //
   SetEvent(SI.StartEvent);


   // 
   // Enter the thread message loop. The thread will now start to process messages.
   //
   while (GetMessage(&msg, (HWND)NULL, 0, 0)) {
      //
      // If debuglevel is 2 then log all messages recieved.
      //
      if (DebugLevel>1) {
         wcscpy(Message, UniqueProcName);
         wcscat(Message, TEXT(": Recieved message "));
         _itow(msg.message, str10, 10);
         wcscat(Message, str10);
         WriteSystemLog(Message, 1);
      }
      

      //
      // If this message is accompanied by a MSG_PARAM structure,
      // then copy this structure to a local buffer (IP). The message
      // is assumed to be accompanied by a structure if lParam is not 0.
      //
      if (msg.message!=TM_BUFFERUPDATED) {
         if (msg.lParam) IP=*((MSG_PARAM*)msg.lParam);
      }

      //
      // Initialize return structure parameters to default values.
      //
      ZeroMemory((PVOID)&RP, (DWORD)sizeof(MSG_PARAM));
      RP.idThread=CurrentThreadID;
      RP.bStatus=TRUE; 

      
      //
      // Process the incoming message.
      //
      switch (msg.message) {
         case TM_SUBSCRIBE:
         //
         // This message is sendt from a window or thread
         // who wants to be informed about an event.
         // This message must be accompanied by a MSG_PARAM structure.
         // The MSG_PARAM structure must have a pointer to a valid
         // SUBSCRIBE structure.
         //
         // Add window/thread to notify list.
         if (!NotifyList.Subscribe((SUBSCRIBE*)IP.vPointer)) {
            RP.bStatus=FALSE;
            RP.wStatus=3;
         }
         break;   


         case TM_UNSUBSCRIBE:
         //
         // This message is sendt from a window or thread who
         // wants to remove a notification from the notify list.
         // This message must be accompanied by a MSG_PARAM structure.
         // The MSG_PARAM structure must have a pointer to a valid
         // SUBSCRIBE structure.
         //
         // Remove notification subscribtion from list.
         NotifyList.UnSubscribe((SUBSCRIBE*)IP.vPointer);
         break;   


         case TM_BUFFERUPDATED:                 
         //
         // A channel thread indicates that a new block has
         // been processed and inserted into the channel's buffer.
         //
         if (Running) {
            //
            // Save the threadID for the channel, 
            // and the blocknr. for the new block.
            //
            ChThreadID=(DWORD)msg.wParam;
            BlockNr=(DWORD)msg.lParam;

            //
            // Find the row nr. for this channel in the 'ChInfo' table.
            // This row index also applies for the 'EventTab' table.
            //
            RowIndex=GetChannelRow(ChThreadID, pChInfo, NumTrigChannels);

            //
            // Get the block header for the new block.
            //
            GetChannelBlockHeader(BlockNr, &BlockHdr, &pChInfo[RowIndex].BufProp);

            // Find the START COLUMN into the 'EventTab' table for this new 
            // block. Also calculate the NUMBER OF COLUMNS THIS BLOCK COVERS. 
            // The number of columns a block will cover is dependant on the
            // block's time and length. A 0.9 sec. block will cover one column,
            // but it may cover 2 columns if its time starts later then 100ms 
            // after the start of the block's second.
            //
            //
            // Check that the block time is not out of range and
            // calculate the column number for the start column.
            BlockTimeOutOfRange=FALSE;
            CmpResult=TimeCmp(&BlockHdr.TimeTag, &CurTime); // Compare the block time to the current time.
            if (!CmpResult) LogicalCol=CurTimeCol; // Block time is equal to current time.
            if (CmpResult>0) {
               // Block time is later then current time.
               TimeDiffInWholeSecs=(WORD)TimeDiff(&CurTime, &BlockHdr.TimeTag);
               if (BlockHdr.TimeTag.wMilliseconds>0) TimeDiffInWholeSecs++;
               if (TimeDiffInWholeSecs <= PRE_ALLOWANCE) {
                  LogicalCol=CurTimeCol-TimeDiffInWholeSecs;
               } else {
                  // The block is to early to fit into the table.
                  BlockTimeOutOfRange=TRUE;
                  wcscpy(Message, UniqueProcName);
                  wcscat(Message, TEXT(": Block with bad time received! Digitizer-time probably out of sync with system time, block will be ignored."));
                  WriteSystemLog(Message, 2);
               }
               
            }
            if (CmpResult<0) {
               // Block time is earlier then current time.
               TimeDiffInWholeSecs=(WORD)TimeDiff(&CurTime, &BlockHdr.TimeTag);
               if (BlockHdr.TimeTag.wMilliseconds>0) TimeDiffInWholeSecs++;
               if (TimeDiffInWholeSecs <= LargestBlckSizeInSec+1+POST_ALLOWANCE) {
                  LogicalCol=CurTimeCol+TimeDiffInWholeSecs;
               } else {
                  // The block is to late to fit into the table.
                  BlockTimeOutOfRange=TRUE;
                  wcscpy(Message, UniqueProcName);
                  wcscat(Message, TEXT(": Block with bad time received! Digitizer-time probably out of sync with system time, block will be ignored."));
                  WriteSystemLog(Message, 2);
               }
            }
            //
            // Calculate the number of columns the block will span over.
            MilliSeconds=pChInfo[RowIndex].BufProp.BlockSizeInMS;
            MilliSeconds=MilliSeconds+BlockHdr.TimeTag.wMilliseconds;
            Seconds=MilliSeconds/1000.0;
            NumColsCovered=(WORD)Seconds;
            if (Seconds-(DOUBLE)NumColsCovered>0.0) NumColsCovered++;

            //
            // Check that the block span is not to large for the table.
            // If so the block span must be reduced to fit the table.
            //
            if (LogicalCol+NumColsCovered > NumCols) NumColsCovered=NumCols-LogicalCol;

            //
            // Insert the data for the new block into the 'EventTab' table.
            //
            if (!BlockTimeOutOfRange) {
               if (!BlockHdr.EventDetected) {
                  // This block is not marked as beeing trigged.
                  column=GetPhysicalCol(LogicalCol, ScrollOffset, NumCols);
                  for (Index=1;Index<=NumColsCovered;Index++) {
                     if (EventTab(RowIndex, column)==NODATA) EventTab(RowIndex, column)=NOEVENT;
                     MoveTablePointerDown(&column, 1, NumCols);
                  }
               } else {
                  // This block is marked as being trigged.
                  // Calculate the trig time.
                  TrigTime=BlockHdr.TimeTag;
                  AddToTime(&TrigTime, (DOUBLE)BlockHdr.EventTime/1000.0);
                  // Update table.
                  column=GetPhysicalCol(LogicalCol, ScrollOffset, NumCols);
                  for (Index=0;Index<NumColsCovered;Index++) {
                     if (EventTab(RowIndex, column)>=NOEVENT) {
                        // If this column represent the start of the event,
                        // then insert the number of milliseconds from start
                        // of column to start of event. Otherwise insert 0.
                        GetColumnTime(LogicalCol-Index, &ColumnTime, LastColTime, NumCols);
                        if (TrigTime.wSecond==ColumnTime.wSecond) {
                           // Event is accociated with this column.
                           // Insert time in ms from start of this
                           // column to trigger start.
                           EventTab(RowIndex, column)=TrigTime.wMilliseconds;
                        } else {
                           EventTab(RowIndex, column)=0;
                        }
                     }
                     MoveTablePointerDown(&column, 1, NumCols);
                  }
               }
            }
         }
         // Avoid returning of status values.
         msg.lParam=msg.wParam=NULL;
         break;


         case TM_TICKER:                  
         //
         // The ticker thread indicates the start of a new second.
         // This message must be sendt to this thread once every second.
         // When this message is received the table will be scrolled
         // one step to the right, and the network trigger status will
         // be evaluated.
         //
         if (Running) {
            if (FirstTick) {
               // This is the first TM_TICKER message since the start.
               // Calculate time for three columns in the table.
               FirstTick=FALSE;
               GetCurUTCTime(&CurTime);
               FirstColTime=LastColTime=CurTime;
               AddToTime(&FirstColTime, (DOUBLE)PRE_ALLOWANCE); 
               SubstractFromTime(&LastColTime, (DOUBLE)(NumCols-PRE_ALLOWANCE-1)); 
            } else {
               // Scroll the table logically down(right) one position.
               ScrollOffset++;
               if (ScrollOffset==NumCols) ScrollOffset=0;

               // Update the time for the three columns.
               GetCurUTCTime(&CurTime);
               FirstColTime=LastColTime=CurTime;
               AddToTime(&FirstColTime, (DOUBLE)PRE_ALLOWANCE); 
               SubstractFromTime(&LastColTime, (DOUBLE)(NumCols-PRE_ALLOWANCE-1)); 

               // Now that the table have been scrolled
               // one step to the right, the last column
               // has become the first column. The first
               // column must therefore now cleared for 
               // all old information.
               column=GetPhysicalCol(0, ScrollOffset, NumCols);
               for (RowIndex=0;RowIndex<NumRows;RowIndex++) EventTab(RowIndex,column)=NODATA;
            }

            //   
            // Count the number of trigged channels
            // inside the event window at this moment.
            //
            NumEvents=0;
            for (RowIndex=0;RowIndex<NumRows;RowIndex++) {
               if (EventInRow(RowIndex, pTable, EventwinFirstCol, 
                   EventwinLastCol, ScrollOffset, NumCols)) NumEvents++;
            }

            //
            // Handle event information found above.
            //
            if (!EventStarted) {
               // 
               // Currently there are no network event detected.
               //
               if (NumEvents>=TrgSetCnf.NumTrigsInTimeWindow) {
                  // This is a new event. Mark start of event.
                  EventStarted=TRUE;
                  EventLength=1;

                  // Find which column markes the start of the network event.
                  FindNetworkEventStartCol(&NetworkEventStartCol, pTable, EventwinFirstCol, EventwinLastCol, ScrollOffset, NumCols, NumRows);

                  // Find the time for the start of the network event.
                  GetColumnTime(NetworkEventStartCol, &EventStartTime, LastColTime, NumCols);

                  // At this point we know that at least SI.NumTrigsInTimeWindow
                  // channels are trigging inside the event window. We now need
                  // to find the start time for all theese channel events. This
                  // information is needed in the S-file. The information is 
                  // stored in the 'ChInfo' table.
                  for (RowIndex=0;RowIndex<NumRows;RowIndex++) {
                     // Check if there is an event in this row.
                     if (EventInRow(RowIndex, pTable, EventwinFirstCol, 
                               EventwinLastCol, ScrollOffset, NumCols)) {
                        // There is an event inside the event window
                        // for this channel. Find the column that markes
                        // the start of the event. Also find the column
                        // that will be monitored for the end of the event.
                        FindTrigColumns(RowIndex, pTable, EventwinFirstCol, EventwinLastCol, ScrollOffset, NumCols, &ChEventStartCol, &EOEWatchCol);
                        // Save the column to be monitored for the end of the event.
                        pChInfo[RowIndex].EOEWatchCol=EOEWatchCol;
                        // Get and save the time accosiated with the start of the event.
                        GetColumnTime(ChEventStartCol, &TrigTime, LastColTime, NumCols);
                        column=GetPhysicalCol(ChEventStartCol, ScrollOffset, NumCols);
                        AddToTime(&TrigTime, (DOUBLE)EventTab(RowIndex,column)/1000.0);
                        pChInfo[RowIndex].TrigStartTime=TrigTime;
                        // Set the start triggerflag for this channel.
                        pChInfo[RowIndex].TrigStarted=TRUE;      
                     }
                  }

                  // Inform other processes that might have subscribed to the 'TM_NETWORK_TRIG_START' message.
                  NotifyList.Notify((UINT)TM_NETWORK_TRIG_START, (WPARAM)CurrentThreadID, 0);

                  // Write message to the log.
                  wcscpy(Message, UniqueProcName);
                  wcscat(Message, TEXT(": Start of event detected."));
                  WriteSystemLog(Message, 1);
               }
            } else {
               // 
               // We are now in the middle of an event.
               //
               if (NumEvents) {
                  // Continue current event.
                  EventLength++;

                  // Check for new events for all channels that has
                  // not already trigged. Check for end of event for
                  // all channels that have already trigged.
                  for (RowIndex=0;RowIndex<NumRows;RowIndex++) {
                     if (!pChInfo[RowIndex].TrigStarted) {
                        // Check for new event for this channel.
                        if (EventInRow(RowIndex, pTable, EventwinFirstCol, 
                            EventwinLastCol, ScrollOffset, NumCols)) {
                           // There is an event inside the event window
                           // for this channel. Find the column that markes
                           // the start of the event. Also find the column
                           // that will be monitored for the end of the event.
                           FindTrigColumns(RowIndex, pTable, EventwinFirstCol, EventwinLastCol, ScrollOffset, NumCols, &ChEventStartCol, &EOEWatchCol);
                           // Save information about the event.
                           pChInfo[RowIndex].EOEWatchCol=EOEWatchCol;
                           GetColumnTime(ChEventStartCol, &TrigTime, LastColTime, NumCols);
                           column=GetPhysicalCol(ChEventStartCol, ScrollOffset, NumCols);
                           AddToTime(&TrigTime, (DOUBLE)EventTab(RowIndex,column)/1000.0);
                           pChInfo[RowIndex].TrigStartTime=TrigTime;
                           pChInfo[RowIndex].TrigStarted=TRUE;      
                        }
                     } else {
                        // We have already detected the start of an event
                        // in this channel. If the event has not already ended,
                        // then check for end of event.
                        if (!pChInfo[RowIndex].TrigStopped) {
                           EOEWatchCol=pChInfo[RowIndex].EOEWatchCol;
                           column=GetPhysicalCol(EOEWatchCol, ScrollOffset, NumCols);
                           if (EventTab(RowIndex, column)>=NOEVENT) {
                              // We have found the end of the channel event.
                              pChInfo[RowIndex].TrigStopped=TRUE;
                              GetColumnTime(EOEWatchCol, &pChInfo[RowIndex].TrigStopTime, LastColTime, NumCols);
                           }
                        }
                     }
                  }


                  // Check if event has endured longer
                  // than the maximum allowed event length.
                  if (EventLength>=TrgSetCnf.MaxEventDuration) {
                     // Event has reached the maximun allowed length.
                     //
                     // Calculate start and stop times for 
                     // the network event, and mark end of event.
                     EventStarted=FALSE;
                     EventStopTime=EventStartTime;
                     AddToTime(&EventStopTime, (DOUBLE)EventLength);
                     SubstractFromTime(&EventStartTime, (DOUBLE)TrgSetCnf.PreEventTime);
                     AddToTime(&EventStopTime, (DOUBLE)TrgSetCnf.PostEventTime);

                     // For all channel events that have been 
                     // started but not ended, end them and
                     // calculate stop times.
                     for (RowIndex=0;RowIndex<NumRows;RowIndex++) {
                        if (pChInfo[RowIndex].TrigStarted && !pChInfo[RowIndex].TrigStopped) {
                           // Mark end of channel-event.
                           pChInfo[RowIndex].TrigStopped=TRUE;
                           // Find channel-event end column.
                           EOEWatchCol=pChInfo[RowIndex].EOEWatchCol;
                           EventEndCol=FindEventStopColWithinEventwindow(RowIndex, EOEWatchCol, pTable, EventwinFirstCol, EventwinLastCol, ScrollOffset, NumCols);
                           // Save channel-event end time.
                           GetColumnTime(EventEndCol-1, &pChInfo[RowIndex].TrigStopTime, LastColTime, NumCols);
                        }
                     }

                     // Set the dump eventflag.
                     EventDump=TRUE;

                     // Inform other processes that might have subscribed to the 'TM_NETWORK_TRIG_STOP' message.
                     NotifyList.Notify((UINT)TM_NETWORK_TRIG_STOP, (WPARAM)CurrentThreadID, 0);

                     // Write message to the log.
                     wcscpy(Message, UniqueProcName);
                     wcscat(Message, TEXT(": Event has reached maximum length, dumping event to disk."));
                     WriteSystemLog(Message, 1);
                  }
               } else {
                  // Current event is finished. 
                  //
                  // Calculate start and stop times for the 
                  // network event and mark end of event.
                  EventStarted=FALSE;
                  EventStopTime=EventStartTime;
                  AddToTime(&EventStopTime, (DOUBLE)EventLength);
                  SubstractFromTime(&EventStartTime, (DOUBLE)TrgSetCnf.PreEventTime);
                  AddToTime(&EventStopTime, (DOUBLE)TrgSetCnf.PostEventTime);

                  // Set the dump eventflag.
                  EventDump=TRUE;

                  // Inform other processes that might have subscribed to the 'TM_NETWORK_TRIG_STOP' message.
                  NotifyList.Notify((UINT)TM_NETWORK_TRIG_STOP, (WPARAM)CurrentThreadID, 0);

                  // Write message to the log.
                  wcscpy(Message, UniqueProcName);
                  wcscat(Message, TEXT(": End of event detected."));
                  WriteSystemLog(Message, 1);
               }
            }
            
            
            //
            // Dump an event if requested by the 'EventDump' flag. 
            //
            if (EventDump) {
               // Allocate memory to the startup information structure for the
               // WriteEvent thread. WriteEvent will copy the startup structure
               // to an internal buffer, and free the memory, when it is started.
               SIWE=(STARTINFO_WRITEEVENT*)LocalAlloc(LPTR, sizeof(STARTINFO_WRITEEVENT));

               // If allocation succeeded go ahed and dump,
               // otherwise abort with an error message.
               if (SIWE==NULL) {
                  // Memory allocation failed.
                  // Write error message to log.
                  wcscpy(Message, UniqueProcName);
                  wcscat(Message, TEXT(": Unable to allocate memory. Cannot dump event."));
                  WriteSystemLog(Message, 3);

               } else {
                  // Memory allocation succeded, dump the event.
                  //
                  // Calculate number of trigged channels.
                  NumTriggedChannels=0;
                  for (RowIndex=0;RowIndex<NumRows;RowIndex++) {
                     if (pChInfo[RowIndex].TrigStopped) NumTriggedChannels++;
                  }

                  // Append Seisan subdirectories to S-file path
                  // if requested. The 'AddSeisanSudirs' function
                  // creates the directory if it do not already exist.
                  wcscpy(File, SFileDir);
                  if (AppendSeisanSubdirs) {
                     if (!AddSeisanSudirs(File, EventStartTime)) {
                        wcscpy(File, SFileDir);
                        wcscpy(Message, UniqueProcName);
                        wcscat(Message, TEXT(": Unable to create Seisan subdirectories for S-Files."));
                        WriteSystemLog(Message, 2);
                     }
                  }

                  // Initialize dump-thread startup information structure.
                  SIWE->TrgSetNumber=SI.TrgSetNumber;
                  wcscpy(SIWE->EFileDir, EventFileDir);
                  wcscpy(SIWE->SFileDir, File);
                  SIWE->NumOfDFileChannels=NumDumpChannels;
                  SIWE->NumOfSFileChannels=NumTriggedChannels;
                  SIWE->EventStartTime=EventStartTime;
                  SIWE->EventStopTime=EventStopTime;
                  SIWE->ManualTrig=FALSE;
                  SIWE->ReleaseMemory=TRUE;
                  // Initialize the 'DChData' member.
                  Index2=0;
                  for (Index=0;Index<NumRegisteredChannels;Index++) {
                     if (TrgSetCnf.DumpChannels[Index]) {
                        SIWE->DumpChannels[Index2]=ChThreadIDs[Index];
                        Index2++;
                     }
                  }
                  // Initialize the 'SChData' member.
                  Index2=0;
                  for (RowIndex=0;RowIndex<NumRows;RowIndex++) {
                     if (pChInfo[RowIndex].TrigStopped) {
                        SIWE->SChData[Index2].ThreadID=pChInfo[RowIndex].ThreadID;
                        SIWE->SChData[Index2].ChEventStartTime=pChInfo[RowIndex].TrigStartTime;
                        SIWE->SChData[Index2].ChEventStopTime=pChInfo[RowIndex].TrigStopTime;
                        Index2++;
                     }
                  }


                  // Dump the event by starting the WriteEvent thread.
                  CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)WriteEventThrdProc, (PVOID)SIWE, 0, &ThreadID);

                  // Reset the 'EventDump' flag.
                  EventDump=FALSE;

                  // Clear all the fields in the ChInfo table 
                  // that are accosiated with channel trigging.
                  for (RowIndex=0;RowIndex<NumRows;RowIndex++) {
                     ZeroMemory((PVOID)&pChInfo[RowIndex].TrigStartTime, (DWORD)sizeof(SYSTEMTIME));
                     ZeroMemory((PVOID)&pChInfo[RowIndex].TrigStopTime, (DWORD)sizeof(SYSTEMTIME));
                     pChInfo[RowIndex].TrigStarted=FALSE;
                     pChInfo[RowIndex].TrigStopped=FALSE;
                     pChInfo[RowIndex].EOEWatchCol=0;
                  }
               }
            }


            //
            // Write debug information to log file if we are running in debug mode.
            // This code will write the contentz of the EventTab table to the log
            // every second. Each TTCHARacter column seen in the log corresponds to
            // one column in the table. The '|' TTCHARacter seen in the log output
            // mark the start of the event window section in the table. The time
            // printed in the end of each line, is the time accosiated with the 
            // last column in the table (the last event window column).
            //
            if (TriggerDebug) {
               for (RowIndex=0;RowIndex<NumRows;RowIndex++) {
                  wcscpy(Message, UniqueProcName);
                  wcscat(Message, TEXT(": "));
                  // Write columns 0 - EventwinFirstCol-1.
                  column=GetPhysicalCol(0, ScrollOffset, NumCols);
                  for (ColIndex=0;ColIndex<EventwinFirstCol;ColIndex++) {
                     if (EventTab(RowIndex, column)==NODATA) wcscat(Message, TEXT("0"));
                     if (EventTab(RowIndex, column)==NOEVENT) wcscat(Message, TEXT("1"));
                     if (EventTab(RowIndex, column)<NOEVENT) wcscat(Message, TEXT("2"));
                     MoveTablePointerUp(&column, 1, NumCols);
                  }
                  // Mark the start of the event window.
                  wcscat(Message, TEXT("|")); 
                  // Write columns EventwinFirstCol-EventwinLastCol.
                  column=GetPhysicalCol(EventwinFirstCol, ScrollOffset, NumCols);
                  for (ColIndex=EventwinFirstCol;ColIndex<=EventwinLastCol;ColIndex++) {
                     if (EventTab(RowIndex, column)==NODATA) wcscat(Message, TEXT("0"));
                     if (EventTab(RowIndex, column)==NOEVENT) wcscat(Message, TEXT("1"));
                     if (EventTab(RowIndex, column)<NOEVENT) wcscat(Message, TEXT("2"));
                     MoveTablePointerUp(&column, 1, NumCols);
                  }
                  // Mark the end of the event window.
                  wcscat(Message, TEXT("|")); 
                  // Write columns EventwinLastCol+1 - LastCol.
                  column=GetPhysicalCol(EventwinLastCol+1, ScrollOffset, NumCols);
                  for (ColIndex=EventwinLastCol+1;ColIndex<=LastCol;ColIndex++) {
                     if (EventTab(RowIndex, column)==NODATA) wcscat(Message, TEXT("0"));
                     if (EventTab(RowIndex, column)==NOEVENT) wcscat(Message, TEXT("1"));
                     if (EventTab(RowIndex, column)<NOEVENT) wcscat(Message, TEXT("2"));
                     MoveTablePointerUp(&column, 1, NumCols);
                  }

                  // Write the time accosiated with the last column.
                  if (RowIndex==0) {
                     CreateTimeString(&LastColTime, str20);
                     wcscat(Message, TEXT(" LastColTime:")); wcscat(Message, str20);
                  }
                  // Write line to the log.
                  WriteSystemLog(Message, 1);
               }
            }
         }
         break;


         case TM_START:                
         //
         // This is a request for the thread to start its operation.
         //
         if (StartupOK && !Running) {
            // Initialize some variables.
            FirstTick=TRUE;
            EventStarted=EventDump=FALSE;
            CurTimeCol=PRE_ALLOWANCE;
            LastCol=NumCols-1;
            EventwinLastCol=LastCol-TrgSetCnf.PreEventTime;  
            EventwinFirstCol=EventwinLastCol-TrgSetCnf.TimeWindowLength+1;
            ScrollOffset=EventStatus=0;

            // Clear the EventTab table.
            for (ColIndex=0;ColIndex<NumCols;ColIndex++) {
               for (RowIndex=0;RowIndex<NumRows;RowIndex++) EventTab(RowIndex,ColIndex)=NODATA;
            }

            // Subscribe to the one-second TM_TICKER message.
            PostThreadMessage(TickerThreadID, TM_SUBSCRIBE, 0, CurrentThreadID);

            // Wait one second before subscribing to the TM_BUFFERUPDATED 
            // message just to be sure that the ticker message comes first.
            Sleep(1000);

            // Subscribe to the TM_BUFFERUPDATED message.
            hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
            for (Index=0;Index<NumTrigChannels;Index++) {
               SubscrData.uiMessage=TM_BUFFERUPDATED;
               SubscrData.idThread=CurrentThreadID;
               SubscrData.hWnd=0;
               MsgParam.vPointer=(PVOID)&SubscrData;
               PostThreadMessage(pChInfo[Index].ThreadID, TM_SUBSCRIBE, (WPARAM)hEvent, (LPARAM)&MsgParam);
               WaitForSingleObject(hEvent, INFINITE);
            }
            CloseHandle(hEvent);

            // Update run-status flag.
            Running=TRUE;
         }
         break;


         case TM_STOP:                 
         //
         // This is a request for the thread to stop its operation.
         //
         if (Running) {
            // Unsubscribe to the one-second TM_TICKER message.
            PostThreadMessage(TickerThreadID, TM_UNSUBSCRIBE, 0, CurrentThreadID); 

            // Unubscribe to the TM_BUFFERUPDATED message.
            hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
            for (Index=0;Index<NumTrigChannels;Index++) {
               SubscrData.uiMessage=TM_BUFFERUPDATED;
               SubscrData.idThread=CurrentThreadID;
               SubscrData.hWnd=0;
               MsgParam.vPointer=(PVOID)&SubscrData;
               PostThreadMessage(pChInfo[Index].ThreadID, TM_UNSUBSCRIBE, (WPARAM)hEvent, (LPARAM)&MsgParam);
               WaitForSingleObject(hEvent, INFINITE);
            }
            CloseHandle(hEvent);

            // Update run-status flag.
            Running=FALSE;
         }
         break;


         case TM_GET_CHANNELS:
         //
         // This message is used to get a list of all the trig-channels
         // included in this triggerset. A pointer to an array of BOOL's
         // (of size MAX_NUM_OF_CHANNELS) must be supplied through the
         // IP.vPointer member. This array will then be initialized with
         // a value of TRUE for each channel included. The first index
         // in the array correspond to logical channel01, the second
         // correspond to channel02 and so on. The array must have been
         // cleard before the TM_GET_CHANNELS was sendt.   
         //
         if (Running) {
            pBool=(BOOL*)IP.vPointer;
            for (Index=0;Index<NumTrigChannels;Index++) {
               pBool[pChInfo[Index].LogicalChNr-1]=TRUE;
            }
         } else {
            RP.bStatus=FALSE;
         }
         break;


         case TM_GET_TRGSET_NUMBER:
         //
         // This message is used to get the triggerset number of this triggerset.
         //
         RP.dwStatus=(BYTE)SI.TrgSetNumber;
         break;


         case TM_GET_EVENT_STATUS:
         //
         // This message is used to get the event status this triggerset.
         //
         RP.bStatus=EventStarted;
         break;


         case TM_EXIT:                 
         //
         // This is a request for the thread to end.
         // Close down all processes that are depandent on this thread.
         // The 'StopDependantThreads' function will return immediatly,
         // and will send a 'TM_DEPTHREADS_STOPPED' message back when
         // all dependant threads have been stopped.
         if (Running) {
            // Post TM_STOP message to stop the channel before exiting.
            PostThreadMessage(CurrentThreadID, TM_STOP, 0, 0); 

            // Repost the TM_EXIT message so that this 
            // thread will receive a new TM_EXIT message 
            // after having processed TM_STOP message.
            PostThreadMessage(CurrentThreadID, TM_EXIT, 0, 0); 
         } else {
            // Stop all threads dependant on this thread.
            StopDependantThreads();
         }
         break;


         
         case TM_DEPTHREADS_STOPPED:
         //
         // This message indicates that all dependent threads have been stopped.
         // The thread will cleanup and exit when this message is recieved.         
         //

         // Unregister this process from the process database.
         UnregisterProcess(CurrentThreadID);

         // Free allocated memory.
         if (pChInfo!=NULL) LocalFree((HLOCAL)(PVOID)pChInfo);
         if (pTable!=NULL) LocalFree((HLOCAL)(PVOID)pTable);

         // End the message loop.
         ClearMessageQueue();  // Delete all messages in message queue.
         PostQuitMessage(0);   // Post WM_QUIT message.
         break;
      }
      
      // Return status values, and release calling process.
      if (((MSG_PARAM*)msg.lParam)!=NULL && msg.wParam!=NULL) {
         *(MSG_PARAM*)msg.lParam=RP;
         SetEvent((HANDLE)msg.wParam);
      }
   } 


   // If running in debug mode, write a message to the log.
   if (DebugLevel) {
      wcscpy(Message, UniqueProcName);
      wcscat(Message, TEXT(": Thread stopped."));
      WriteSystemLog(Message, 1);
   }

   // Thread dies here.
   ExitThread(0);
   return 0L;
   
}






#ifndef WINCE

/************************************************************************************************/
/* Dialog box procedure for the 'Add Triggerset' dialog.                                           */
/************************************************************************************************/
BOOL CALLBACK AddTriggersetDlgProc(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
   TCHAR MessageText[200], str3[4], str4[5], str15[16];
   BYTE Index, NumChSelected;
   HWND hWndDlgItem;
   DWORD dwIndex;
   TRIG_SET_CNF_FILE *TrgParams;
   BOOL ChannelSelected;

   switch(message)  {
      case WM_INITDIALOG:
      // Save pointer to return structure.
      SetWindowLong(hWndDlg, GWL_USERDATA, (LONG)lParam);

      // Create a pointer to the configuration structure.
      TrgParams=(TRIG_SET_CNF_FILE*)lParam;

      // If this is a modification of an existing triggerset,
      // do some modifications and special initializations.
      if (TrgParams->bModify) {
         SetWindowText(hWndDlg, TEXT("Modify Triggerset"));          // Change name of dialog boc.
         SetDlgItemText(hWndDlg, IDC_EDIT1, TrgParams->Name);  // Insert name of triggerset in first edit field.
         EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT1), FALSE);  // Disable input to first edit field.
      }
      
      //
      // Initialize the first combo box.
      // Fill in numbers from 1 to NumberOfRegisteredChannels.
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_COMBO1);
      for (Index=1;Index<=NumRegisteredChannels;Index++) {
         dwIndex=SendMessage(hWndDlgItem, CB_ADDSTRING, 0, (LPARAM)_itow((INT)Index, str3, 10));
         SendMessage(hWndDlgItem, CB_SETITEMDATA, (LPARAM)dwIndex, (WPARAM)(DWORD)Index);
         if (TrgParams->NumTrigsInTimeWindow==Index) SendMessage(hWndDlgItem, CB_SETCURSEL, dwIndex, 0);
      }

      //
      // Initialize second combo box.
      //
      // Fill in numbers from 1 to 120.
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_COMBO2);
      for (Index=1;Index<=120;Index++) {
         dwIndex=SendMessage(hWndDlgItem, CB_ADDSTRING, 0, (LPARAM)_itow((INT)Index, str4, 10));
         SendMessage(hWndDlgItem, CB_SETITEMDATA, (LPARAM)dwIndex, (WPARAM)(DWORD)Index);
         if (TrgParams->TimeWindowLength==Index) SendMessage(hWndDlgItem, CB_SETCURSEL, dwIndex, 0);
      }

      //
      // Initialize 'Max duration of event' edit field.
      //

      SetDlgItemText(hWndDlg, IDC_EDIT2, _itow((INT)TrgParams->MaxEventDuration, str15, 10));

      //
      // Initialize 'Pre-event time' edit field.
      //
      SetDlgItemText(hWndDlg, IDC_EDIT3, _itow((INT)TrgParams->PreEventTime, str15, 10));

      //
      // Initialize 'Post-event time' edit field.
      //
      SetDlgItemText(hWndDlg, IDC_EDIT4, _itow((INT)TrgParams->PostEventTime, str15, 10));

      //
      // Initialize the 'Trig channels' list box.
      //
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_LIST1);
      for (Index=1;Index<=NumRegisteredChannels;Index++) {
         if (Channels[Index-1].UseTrigging) {
            wcscpy(str15, Channels[Index-1].ChannelName);
            if (TrgParams->TrigChannels[Index-1]) wcscat(str15, TEXT(" *"));
            dwIndex=SendMessage(hWndDlgItem, LB_ADDSTRING, 0, (LPARAM)str15);
            SendMessage(hWndDlgItem, LB_SETITEMDATA, (WPARAM)dwIndex, (LPARAM)(DWORD)Index);
         } else {
            TrgParams->TrigChannels[Index-1]=FALSE;
         }
      }

      //
      // Initialize the 'Dump channels' list box. All configured channels must be inserted.
      //
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_LIST2);
      for (Index=1;Index<=NumRegisteredChannels;Index++) {
         wcscpy(str15, TEXT("Channel"));
         swprintf(str3, TEXT("%02u"), Index);
         wcscat(str15, str3);   
         if (TrgParams->DumpChannels[Index-1]) wcscat(str15, TEXT(" *"));
         dwIndex=SendMessage(hWndDlgItem, LB_ADDSTRING, 0, (LPARAM)str15);
         SendMessage(hWndDlgItem, LB_SETITEMDATA, (WPARAM)dwIndex, (LPARAM)(DWORD)Index);
      }

      // Set the input focus to the 'Enter name of trigger set' edit box.
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_EDIT1);
      SetFocus(hWndDlgItem);
      return FALSE; 


      case WM_COMMAND:
      switch(LOWORD(wParam)) {
         case IDC_LIST1:
         switch (HIWORD(wParam)) { 
            case LBN_DBLCLK:
            //
            // The user has double clicked a line in the trig channel list box. Change
            // the status of this channel from unselected to selected or the other way.            
            //
            // Get saved pointer to returndata structure.
            //
            TrgParams=(TRIG_SET_CNF_FILE*)GetWindowLong(hWndDlg, GWL_USERDATA);

            // Change the channel selection status and update listbox.           
            hWndDlgItem=GetDlgItem(hWndDlg, IDC_LIST1);
            dwIndex=SendMessage(hWndDlgItem,LB_GETCURSEL,0,0);
            Index=(BYTE)SendMessage(hWndDlgItem, LB_GETITEMDATA, (WPARAM)dwIndex, 0);
            TrgParams->TrigChannels[Index-1]=!TrgParams->TrigChannels[Index-1];
            wcscpy(str15, TEXT("Channel")); swprintf(str3, TEXT("%02u"), Index); wcscat(str15, str3);   
            if (TrgParams->TrigChannels[Index-1]) wcscat(str15, TEXT(" *"));
            SendMessage(hWndDlgItem, LB_DELETESTRING, (WPARAM)dwIndex, 0);
            SendMessage(hWndDlgItem, LB_INSERTSTRING, (WPARAM)dwIndex, (LPARAM)str15);
            SendMessage(hWndDlgItem, LB_SETITEMDATA, (WPARAM)dwIndex, (LPARAM)(DWORD)Index);
            SendMessage(hWndDlgItem, LB_SETCURSEL, (WPARAM)dwIndex, 0);
            SendMessage(hWndDlgItem, LB_SETCARETINDEX, (WPARAM)dwIndex, MAKELPARAM(FALSE, 0));
            break;
         }
         break;

         case IDC_LIST2:
         switch (HIWORD(wParam)) { 
            case LBN_DBLCLK:
            //
            // The user has double clicked a line in the dump channel list box. Change
            // the status of this channel from unselected to selected or the other way.            
            //
            // Get saved pointer to returndata structure.
            //
            TrgParams=(TRIG_SET_CNF_FILE*)GetWindowLong(hWndDlg, GWL_USERDATA);

            // Change the channel selection status and update listbox.           
            hWndDlgItem=GetDlgItem(hWndDlg, IDC_LIST2);
            dwIndex=SendMessage(hWndDlgItem,LB_GETCURSEL,0,0);
            Index=(BYTE)SendMessage(hWndDlgItem, LB_GETITEMDATA, (WPARAM)dwIndex, 0);
            TrgParams->DumpChannels[Index-1]=!TrgParams->DumpChannels[Index-1];
            wcscpy(str15, TEXT("Channel")); swprintf(str3, TEXT("%02u"), Index); wcscat(str15, str3);   
            if (TrgParams->DumpChannels[Index-1]) wcscat(str15, TEXT(" *"));
            SendMessage(hWndDlgItem, LB_DELETESTRING, (WPARAM)dwIndex, 0);
            SendMessage(hWndDlgItem, LB_INSERTSTRING, (WPARAM)dwIndex, (LPARAM)str15);
            SendMessage(hWndDlgItem, LB_SETITEMDATA, (WPARAM)dwIndex, (LPARAM)(DWORD)Index);
            SendMessage(hWndDlgItem, LB_SETCURSEL, (WPARAM)dwIndex, 0);
            SendMessage(hWndDlgItem, LB_SETCARETINDEX, (WPARAM)dwIndex, MAKELPARAM(FALSE, 0));
            break;
         }
         break;


         case IDOK:
         // 
         // This is the 'OK' button.
         //

         //
         // Get saved pointer to returndata structure.
         //
         TrgParams=(TRIG_SET_CNF_FILE*)GetWindowLong(hWndDlg, GWL_USERDATA);

         //
         // Read and check chosen triggerset name.
         //
         if (!TrgParams->bModify) {
            GetDlgItemText(hWndDlg, IDC_EDIT1, TrgParams->Name, 65);
            // Check that user has entered a name.
            if (wcslen(TrgParams->Name)==0) {
               // The user has not given any triggerset name.
               wcscpy(MessageText, TEXT("You must enter a name for the triggerset!\n"));
               MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

               // Move the input focus to this field.
               SetFocus(GetDlgItem(hWndDlg, IDC_EDIT1));

               break;
            }
            // Check that name is not already in use.
            if (ExistTriggerset(TrgParams->Name)) {
               // The name is used by another triggerset.
               wcscpy(MessageText, TEXT("A triggerset with this name already exist.\n"));
               wcscat(MessageText, TEXT("Please type a name that is not in use."));
               MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

               // Move the input focus to this field.
               SetFocus(GetDlgItem(hWndDlg, IDC_EDIT1));

               break;
            }
            // Check that the name is a valid filename.
            if (!IsValidFileName(TrgParams->Name)) {
               // The name is invalid.
               wcscpy(MessageText, TEXT("An invalid name is given for the triggerset.\n"));
               wcscat(MessageText, TEXT("Do not use theese TTCHARacters: \\/:*?\"<>| "));
               MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

               // Move the input focus to this field.
               SetFocus(GetDlgItem(hWndDlg, IDC_EDIT1));

               break;
            }
         }

         //
         // Read the first combo box.
         //
         hWndDlgItem=GetDlgItem(hWndDlg, IDC_COMBO1);
         dwIndex=SendMessage(hWndDlgItem, CB_GETCURSEL, 0, 0);
         TrgParams->NumTrigsInTimeWindow=(WORD)SendMessage(hWndDlgItem, CB_GETITEMDATA, dwIndex, 0);

         //
         // Read the second combo box.
         //
         hWndDlgItem=GetDlgItem(hWndDlg, IDC_COMBO2);
         dwIndex=SendMessage(hWndDlgItem, CB_GETCURSEL, 0, 0);
         TrgParams->TimeWindowLength=(WORD)SendMessage(hWndDlgItem, CB_GETITEMDATA, dwIndex, 0);

         //
         // Read the 'Max duration of event' edit field.
         //
         GetDlgItemText(hWndDlg, IDC_EDIT2, str15 ,15);
         TrgParams->MaxEventDuration=(WORD)_wtoi(str15);

         //
         // Read the 'Pre-event time' edit field.
         //
         GetDlgItemText(hWndDlg, IDC_EDIT3, str15 ,15);
         TrgParams->PreEventTime=(WORD)_wtoi(str15);

         //
         // Read the 'Post-event time' edit field.
         //
         GetDlgItemText(hWndDlg, IDC_EDIT4, str15 ,15);
         TrgParams->PostEventTime=(WORD)_wtoi(str15);

         //
         // Check that at least one trig channel is selected.
         // 
         ChannelSelected=FALSE;
         for (Index=1;Index<=NumRegisteredChannels;Index++) {
            if (TrgParams->TrigChannels[Index-1]) ChannelSelected=TRUE;
         }
         if (!ChannelSelected) {
            // The user has not selected any channels.
            wcscpy(MessageText, TEXT("You must select at least one trig channel!\n"));
            MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

            // Move the input focus to the listbox.
            SetFocus(GetDlgItem(hWndDlg, IDC_LIST1));

            break;
         }
            
         //
         // Check that at least one dump channel is selected.
         // 
         ChannelSelected=FALSE;
         for (Index=1;Index<=NumRegisteredChannels;Index++) {
            if (TrgParams->DumpChannels[Index-1]) ChannelSelected=TRUE;
         }
         if (!ChannelSelected) {
            // The user has not selected any channels.
            wcscpy(MessageText, TEXT("You must select at least one dump channel!\n"));
            MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

            // Move the input focus to the listbox.
            SetFocus(GetDlgItem(hWndDlg, IDC_LIST2));

            break;
         }

         //
         // Check that the number of trig channels selected is
         // equal or greater to the NumTrigsInTimeWindow value.
         //
         NumChSelected=0;
         for (Index=1;Index<=NumRegisteredChannels;Index++) {
            if (TrgParams->TrigChannels[Index-1]) NumChSelected++;
         }
         if (NumChSelected<TrgParams->NumTrigsInTimeWindow) {
            // The user has not selected any channels.
            wcscpy(MessageText, TEXT("Value out of range!\n"));
            wcscat(MessageText, TEXT("Value cannot ecceed the number of selected trig channels.\n"));
            MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

            // Move the input focus to the first combo box.
            SetFocus(GetDlgItem(hWndDlg, IDC_COMBO1));

            break;
         }

         // Close the dialog box ,return the channel nr, and exit.
         EndDialog(hWndDlg , 1);
         break;
         
         case IDCANCEL:
         // This is the 'Cancel' button.
         // User wants to cancel the operation. Close the dialog box and exit.
         

			EndDialog(hWndDlg , 0);
         break;
      }
      return FALSE;
   }
   return FALSE;
}
#endif

#ifdef WINCE

/************************************************************************************************/
/* Dialog box procedure for the 'Add Triggerset' dialog.                                           */
/************************************************************************************************/
BOOL CALLBACK AddTriggersetDlgProc1(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	
   TCHAR MessageText[200], str15[16]; // unused in PocketPC version str3[4], str4[5],
	//BYTE NumChSelected, Index; Unused i PocketPC version
   HWND hWndDlgItem;
	//DWORD dwIndex; Unused in PocketPC version
   TRIG_SET_CNF_FILE *TrgParams;
	//BOOL ChannelSelected; Unused in PocketPC version

   switch(message)  {
      case WM_INITDIALOG:
	   // Save pointer to return structure.
      SetWindowLong(hWndDlg, GWL_USERDATA, (LONG)((LPPROPSHEETPAGE)lParam)->lParam);

      // Create a pointer to the configuration structure.
      TrgParams=(TRIG_SET_CNF_FILE*)((LPPROPSHEETPAGE)lParam)->lParam;

      // If this is a modification of an existing triggerset,
      // do some modifications and special initializations.
      if (TrgParams->bModify) {
			SHSetNavBarText(hWndDlg, TEXT("Modify Triggerset"));
         
			//SetWindowText(hWndDlg, TEXT("Modify Triggerset"));    // Change name of dialog boc.
         SetDlgItemText(hWndDlg, IDC_EDIT1, TrgParams->Name);  // Insert name of triggerset in first edit field.
         EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT1), FALSE);  // Disable input to first edit field.
      }

      //
      // Initialize 'Max duration of event' edit field.
      //

      SetDlgItemText(hWndDlg, IDC_EDIT2, _itow((INT)TrgParams->MaxEventDuration, str15, 10));

      //
      // Initialize 'Pre-event time' edit field.
      //
      SetDlgItemText(hWndDlg, IDC_EDIT3, _itow((INT)TrgParams->PreEventTime, str15, 10));

      //
      // Initialize 'Post-event time' edit field.
      //
      SetDlgItemText(hWndDlg, IDC_EDIT4, _itow((INT)TrgParams->PostEventTime, str15, 10));


      // Set the input focus to the 'Enter name of trigger set' edit box.
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_EDIT1);
      SetFocus(hWndDlgItem);
      return FALSE; 


      case WM_COMMAND:
      switch(LOWORD(wParam)) {
			case IDCANCEL:
				// This is the 'Cancel' button.
				// User wants to cancel the operation. Close the dialog box and exit.

				PropSheet_PressButton(hAddTriggersetDlg, PSBTN_CANCEL);

				return TRUE;
		}
		return FALSE;

		case WM_NOTIFY:
		switch  (((NMHDR *)lParam)->code){
			case PSN_QUERYCANCEL:
				return TRUE;	
					
			case PSN_APPLY:
				// 
				// This is the 'OK' button.
				//

			   //
				// Get saved pointer to returndata structure.
				//
				TrgParams=(TRIG_SET_CNF_FILE*)GetWindowLong(hWndDlg, GWL_USERDATA);

				//
				// Read and check chosen triggerset name.
				//
				if (!TrgParams->bModify) {
					GetDlgItemText(hWndDlg, IDC_EDIT1, TrgParams->Name, 65);
					// Check that user has entered a name.
					if (wcslen(TrgParams->Name)==0) {
						// The user has not given any triggerset name.
						wcscpy(MessageText, TEXT("You must enter a name for the triggerset!\n"));
						MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

						// Move the input focus to this field.
						SetFocus(GetDlgItem(hWndDlg, IDC_EDIT1));
						PropSheet_SetCurSel(hAddTriggersetDlg, hWndDlg, 0);
						
						SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
						return TRUE;
         
					}
					// Check that name is not already in use.
					if (ExistTriggerset(TrgParams->Name)) {
						// The name is used by another triggerset.
						wcscpy(MessageText, TEXT("A triggerset with this name already exist.\n"));
						wcscat(MessageText, TEXT("Please type a name that is not in use."));
						MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

						// Move the input focus to this field.
						SetFocus(GetDlgItem(hWndDlg, IDC_EDIT1));
						PropSheet_SetCurSel(hAddTriggersetDlg, hWndDlg, 0);

						SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
						return TRUE;
						
					}
					// Check that the name is a valid filename.
					if (!IsValidFileName(TrgParams->Name)) {
						// The name is invalid.
						wcscpy(MessageText, TEXT("An invalid name is given for the triggerset.\n"));
						wcscat(MessageText, TEXT("Do not use these Characters: \\/:*?\"<>| "));
						MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

						// Move the input focus to this field.
						SetFocus(GetDlgItem(hWndDlg, IDC_EDIT1));
						PropSheet_SetCurSel(hAddTriggersetDlg, hWndDlg, 0);

						SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
						return TRUE;
						
					}
				}

				//
				// Read the 'Max duration of event' edit field.
				//
				GetDlgItemText(hWndDlg, IDC_EDIT2, str15 ,15);
				TrgParams->MaxEventDuration=(WORD)_wtoi(str15);

				//
				// Read the 'Pre-event time' edit field.
				//
				GetDlgItemText(hWndDlg, IDC_EDIT3, str15 ,15);
				TrgParams->PreEventTime=(WORD)_wtoi(str15);

				//
				// Read the 'Post-event time' edit field.
				//
				GetDlgItemText(hWndDlg, IDC_EDIT4, str15 ,15);
				TrgParams->PostEventTime=(WORD)_wtoi(str15);

			
				// Close the dialog box ,return the channel nr, and exit.
				// [PocketPC] OK to close the dialog box
				SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_NOERROR);
				return TRUE;
	
		}//end switch i WM_NOTIFY
		return FALSE;
	}//end of switch of messages
	return FALSE;
}//end of method.

/************************************************************************************************/
/* Dialog box procedure for the 'Add Triggerset' dialog.                                           */
/************************************************************************************************/
BOOL CALLBACK AddTriggersetDlgProc2(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
   
   TCHAR str4[5], str3[4]; //unused in PocketPC version str15[16], 
   BYTE Index;
   HWND hWndDlgItem;
   DWORD dwIndex;
   TRIG_SET_CNF_FILE *TrgParams;

   switch(message)  {
      case WM_INITDIALOG:
	
		// Save pointer to return structure.
      SetWindowLong(hWndDlg, GWL_USERDATA, (LONG)((LPPROPSHEETPAGE)lParam)->lParam);

      // Create a pointer to the configuration structure.
      TrgParams=(TRIG_SET_CNF_FILE*)((LPPROPSHEETPAGE)lParam)->lParam;

      // If this is a modification of an existing triggerset,
      // do some modifications and special initializations.
      if (TrgParams->bModify) {
         SetWindowText(hWndDlg, TEXT("Modify Triggerset"));          // Change name of dialog boc.
         SetDlgItemText(hWndDlg, IDC_EDIT1, TrgParams->Name);  // Insert name of triggerset in first edit field.
         EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT1), FALSE);  // Disable input to first edit field.
      }
      
      //
      // Initialize the first combo box.
      // Fill in numbers from 1 to NumberOfRegisteredChannels.
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_COMBO1);
      for (Index=1;Index<=NumRegisteredChannels;Index++) {
         dwIndex=SendMessage(hWndDlgItem, CB_ADDSTRING, 0, (LPARAM)_itow((INT)Index, str3, 10));
         SendMessage(hWndDlgItem, CB_SETITEMDATA, (LPARAM)dwIndex, (WPARAM)(DWORD)Index);
         if (TrgParams->NumTrigsInTimeWindow==Index) SendMessage(hWndDlgItem, CB_SETCURSEL, dwIndex, 0);
      }

      //
      // Initialize second combo box.
      //
      // Fill in numbers from 1 to 120.
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_COMBO2);
      for (Index=1;Index<=120;Index++) {
         dwIndex=SendMessage(hWndDlgItem, CB_ADDSTRING, 0, (LPARAM)_itow((INT)Index, str4, 10));
         SendMessage(hWndDlgItem, CB_SETITEMDATA, (LPARAM)dwIndex, (WPARAM)(DWORD)Index);
         if (TrgParams->TimeWindowLength==Index) SendMessage(hWndDlgItem, CB_SETCURSEL, dwIndex, 0);
      }

		return FALSE; 


      case WM_COMMAND:
      switch(LOWORD(wParam)) {
         
			case IDCANCEL:
				// This is the 'Cancel' button.
				// User wants to cancel the operation. Close the dialog box and exit.

				PropSheet_PressButton(hAddTriggersetDlg, PSBTN_CANCEL);

				return TRUE;
		}
		return FALSE;

		case WM_NOTIFY:
		switch  (((NMHDR *)lParam)->code){
			case PSN_QUERYCANCEL:
				// This is the 'Cancel' button.
				// User wants to cancel the operation. Close the dialog box and exit.
				return TRUE;
			case PSN_APPLY:
				// 
				// This is the 'OK' button.
				//

				//
				// Get saved pointer to returndata structure.
				//
				TrgParams=(TRIG_SET_CNF_FILE*)GetWindowLong(hWndDlg, GWL_USERDATA);

				//
				// Read the first combo box.
				//
				hWndDlgItem=GetDlgItem(hWndDlg, IDC_COMBO1);
				dwIndex=SendMessage(hWndDlgItem, CB_GETCURSEL, 0, 0);
				TrgParams->NumTrigsInTimeWindow=(WORD)SendMessage(hWndDlgItem, CB_GETITEMDATA, dwIndex, 0);

				//
				// Read the second combo box.
				//
				hWndDlgItem=GetDlgItem(hWndDlg, IDC_COMBO2);
				dwIndex=SendMessage(hWndDlgItem, CB_GETCURSEL, 0, 0);
				TrgParams->TimeWindowLength=(WORD)SendMessage(hWndDlgItem, CB_GETITEMDATA, dwIndex, 0);


				// [PocketPC] OK to close the dialog box
				SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_NOERROR);
				return TRUE;

			}// WM_NOTIFY
      return FALSE;
   }//msg
   return FALSE;
}

/************************************************************************************************/
/* Dialog box procedure for the 'Add Triggerset' dialog.                                        */
/************************************************************************************************/
BOOL CALLBACK AddTriggersetDlgProc3(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

   TCHAR MessageText[200], str3[4],str15[16];	//unused in PocketPC version  str4[5]
   BYTE Index, NumChSelected;
   HWND hWndDlgItem;
   DWORD dwIndex;
   TRIG_SET_CNF_FILE *TrgParams;
   BOOL ChannelSelected;
	
   switch(message)  {
      case WM_INITDIALOG:
		  

			// Save pointer to return structure.
			SetWindowLong(hWndDlg, GWL_USERDATA, (LONG)((LPPROPSHEETPAGE)lParam)->lParam);//(LONG)lParam);

			// Create a pointer to the configuration structure.
			TrgParams=(TRIG_SET_CNF_FILE*)((LPPROPSHEETPAGE)lParam)->lParam;
  
			//
			// Initialize the 'Trig channels' list box.
			//
			hWndDlgItem=GetDlgItem(hWndDlg, IDC_LIST1);
			for (Index=1;Index<=NumRegisteredChannels;Index++) {
				if (Channels[Index-1].UseTrigging) {
					wcscpy(str15, Channels[Index-1].ChannelName);
					if (TrgParams->TrigChannels[Index-1]) wcscat(str15, TEXT(" *"));
					dwIndex=SendMessage(hWndDlgItem, LB_ADDSTRING, 0, (LPARAM)str15);
					SendMessage(hWndDlgItem, LB_SETITEMDATA, (WPARAM)dwIndex, (LPARAM)(DWORD)Index);
				} else {
					TrgParams->TrigChannels[Index-1]=FALSE;
				}
			}

			//
			// Initialize the 'Dump channels' list box. All configured channels must be inserted.
			//
			hWndDlgItem=GetDlgItem(hWndDlg, IDC_LIST2);
			for (Index=1;Index<=NumRegisteredChannels;Index++) {
				wcscpy(str15, TEXT("Channel"));
				swprintf(str3, TEXT("%02u"), Index);
				wcscat(str15, str3);   
				if (TrgParams->DumpChannels[Index-1]) wcscat(str15, TEXT(" *"));
				dwIndex=SendMessage(hWndDlgItem, LB_ADDSTRING, 0, (LPARAM)str15);
				SendMessage(hWndDlgItem, LB_SETITEMDATA, (WPARAM)dwIndex, (LPARAM)(DWORD)Index);
			}
	/*
			// Set the input focus to the 'Enter name of trigger set' edit box.
			hWndDlgItem=GetDlgItem(hWndDlg, IDC_EDIT1);
			SetFocus(hWndDlgItem);
	*/
			return FALSE; 


      case WM_COMMAND:
		switch(LOWORD(wParam)) {

			case IDC_LIST1:
         switch (HIWORD(wParam)) { 
            case LBN_DBLCLK:
            //
            // The user has double clicked a line in the trig channel list box. Change
            // the status of this channel from unselected to selected or the other way.            
            //
            // Get saved pointer to returndata structure.
            //
            TrgParams=(TRIG_SET_CNF_FILE*)GetWindowLong(hWndDlg, GWL_USERDATA);

            // Change the channel selection status and update listbox.           
            hWndDlgItem=GetDlgItem(hWndDlg, IDC_LIST1);
            dwIndex=SendMessage(hWndDlgItem,LB_GETCURSEL,0,0);
            Index=(BYTE)SendMessage(hWndDlgItem, LB_GETITEMDATA, (WPARAM)dwIndex, 0);
            TrgParams->TrigChannels[Index-1]=!TrgParams->TrigChannels[Index-1];
            wcscpy(str15, TEXT("Channel")); swprintf(str3, TEXT("%02u"), Index); wcscat(str15, str3);   
            if (TrgParams->TrigChannels[Index-1]) wcscat(str15, TEXT(" *"));
            SendMessage(hWndDlgItem, LB_DELETESTRING, (WPARAM)dwIndex, 0);
            SendMessage(hWndDlgItem, LB_INSERTSTRING, (WPARAM)dwIndex, (LPARAM)str15);
            SendMessage(hWndDlgItem, LB_SETITEMDATA, (WPARAM)dwIndex, (LPARAM)(DWORD)Index);
            SendMessage(hWndDlgItem, LB_SETCURSEL, (WPARAM)dwIndex, 0);
            SendMessage(hWndDlgItem, LB_SETCARETINDEX, (WPARAM)dwIndex, MAKELPARAM(FALSE, 0));
            
				SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
				return TRUE;
            
         }//end of switch in IDC_LIST1
			SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
			return TRUE;
         
         case IDC_LIST2:
         switch (HIWORD(wParam)) { 
            case LBN_DBLCLK:
            //
            // The user has double clicked a line in the dump channel list box. Change
            // the status of this channel from unselected to selected or the other way.            
            //
            // Get saved pointer to returndata structure.
            //
            TrgParams=(TRIG_SET_CNF_FILE*)GetWindowLong(hWndDlg, GWL_USERDATA);

            // Change the channel selection status and update listbox.           
            hWndDlgItem=GetDlgItem(hWndDlg, IDC_LIST2);
            dwIndex=SendMessage(hWndDlgItem,LB_GETCURSEL,0,0);
            Index=(BYTE)SendMessage(hWndDlgItem, LB_GETITEMDATA, (WPARAM)dwIndex, 0);
            TrgParams->DumpChannels[Index-1]=!TrgParams->DumpChannels[Index-1];
            wcscpy(str15, TEXT("Channel")); swprintf(str3, TEXT("%02u"), Index); wcscat(str15, str3);   
            if (TrgParams->DumpChannels[Index-1]) wcscat(str15, TEXT(" *"));
            SendMessage(hWndDlgItem, LB_DELETESTRING, (WPARAM)dwIndex, 0);
            SendMessage(hWndDlgItem, LB_INSERTSTRING, (WPARAM)dwIndex, (LPARAM)str15);
            SendMessage(hWndDlgItem, LB_SETITEMDATA, (WPARAM)dwIndex, (LPARAM)(DWORD)Index);
            SendMessage(hWndDlgItem, LB_SETCURSEL, (WPARAM)dwIndex, 0);
            SendMessage(hWndDlgItem, LB_SETCARETINDEX, (WPARAM)dwIndex, MAKELPARAM(FALSE, 0));
            
				SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
				return TRUE;
            
         }//end of switch in IDC_LIST2
			SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
			return TRUE;
            
		case IDCANCEL:
			// This is the 'Cancel' button.
			// User wants to cancel the operation. Close the dialog box and exit.
			PropSheet_PressButton(hAddTriggersetDlg, PSBTN_CANCEL);
			return TRUE;
		}
		return FALSE;
		case WM_NOTIFY:
		switch  (((NMHDR *)lParam)->code){
			
			case PSN_QUERYCANCEL:
				// This is the 'Cancel' button.
				// User wants to cancel the operation. Close the dialog box and exit.
				return TRUE;
				
			case PSN_APPLY:
				// 
				// This is the 'OK' button.
				//

				//
				// Get saved pointer to returndata structure.
				//
				TrgParams=(TRIG_SET_CNF_FILE*)GetWindowLong(hWndDlg, GWL_USERDATA);

				//
				// Check that at least one trig channel is selected.
				// 
				ChannelSelected=FALSE;
				for (Index=1;Index<=NumRegisteredChannels;Index++) {
					if (TrgParams->TrigChannels[Index-1]) ChannelSelected=TRUE;
				}
				if (!ChannelSelected) {
					// The user has not selected any channels.
					wcscpy(MessageText, TEXT("You must select at least one trig channel!\n"));
					MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

					// Move the input focus to the listbox.
					SetFocus(GetDlgItem(hWndDlg, IDC_LIST1));
					
					SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
					return TRUE;
         
				}
         
				//
				// Check that at least one dump channel is selected.
				// 
				ChannelSelected=FALSE;
				for (Index=1;Index<=NumRegisteredChannels;Index++) {
					if (TrgParams->DumpChannels[Index-1]) ChannelSelected=TRUE;
				}
				if (!ChannelSelected) {
					// The user has not selected any channels.
					wcscpy(MessageText, TEXT("You must select at least one dump channel!\n"));
					MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

					// Move the input focus to the listbox.
					SetFocus(GetDlgItem(hWndDlg, IDC_LIST2));

					SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
					return TRUE;
         
				}

				//
				// Check that the number of trig channels selected is
				// equal or greater to the NumTrigsInTimeWindow value.
				//
				NumChSelected=0;
				for (Index=1;Index<=NumRegisteredChannels;Index++) {
					if (TrgParams->TrigChannels[Index-1]) NumChSelected++;
				}
				if (NumChSelected<TrgParams->NumTrigsInTimeWindow) {
					// The user has not selected any channels.
					wcscpy(MessageText, TEXT("Value out of range!\n"));
					wcscat(MessageText, TEXT("Value cannot ecceed the number of selected trig channels.\n"));
					MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

					// Move the input focus to the first combo box.
					//	SetFocus(GetDlgItem(hWndDlg, IDC_COMBO1));
					PropSheet_SetCurSel(hAddTriggersetDlg, hWndDlg, 1);

					SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_INVALID_NOCHANGEPAGE);
					return TRUE;
         
				}
				//end of switch in WM_NOTIFY
				// [PocketPC] OK to close the dialog box
				SetWindowLong (hWndDlg, DWL_MSGRESULT, PSNRET_NOERROR);
				return TRUE;

      }//end of switch in WM_COMMAND
      return FALSE;
   }//end if switch of messages
   return FALSE;
}//end of method

/*******************************************************************/
/*  Callback for the 'Program settings' property sheet.            */
/*  This procedure is called when the property sheet               */
/*  is being created and initialized.                              */
/*******************************************************************/

BOOL CALLBACK AddTriggersetPropSheetProc(HWND hwndDlg, UINT uMsg, LPARAM lParam )
{
	
	SHINITDLGINFO shidi;

	switch (uMsg)
	{
		
	case PSCB_INITIALIZED: // Note: This may be the wrong message to do this!
		 
		// Initialize handle to the Property Sheet
		hAddTriggersetDlg = hwndDlg;
	
		// Create a Done button and size it.  
		shidi.dwMask = SHIDIM_FLAGS;
		shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
		shidi.hDlg = hwndDlg;
		SHInitDialog(&shidi);
		
		return TRUE;

	}
	return TRUE;
}

BOOL AddTriggersetDialogBox(HINSTANCE hInst, HWND hWnd, LPARAM lParam)
{
	  //[PocketPC]
	PROPSHEETHEADER psh;    // The entire Property Sheet
	PROPSHEETPAGE   psp[3]; // The property pages
	INT i;

	  		// Init page structures with generic information.
		memset (&psp, 0, sizeof (psp));      // Zero out all unused values.
		for (i = 0; i < 3; i++) {
			psp[i].dwSize = sizeof (PROPSHEETPAGE);
			psp[i].dwFlags = PSP_DEFAULT | PSP_PREMATURE;
			psp[i].hInstance = hInst;         // Instance handle where the
														 // dialog templates are located
			psp[i].lParam = lParam;
		
		
		}                                     
		// Now do the page specific stuff.
		psp[0].pszTemplate = MAKEINTRESOURCE(IDD_ADD_TRIGGERSET_1); // Name of dialog resource for page 1
		psp[0].pfnDlgProc = AddTriggersetDlgProc1;    // Pointer to dialog proc for page 1

		psp[1].pszTemplate = MAKEINTRESOURCE(IDD_ADD_TRIGGERSET_2); // Name of dialog resource for page 2
		psp[1].pfnDlgProc = AddTriggersetDlgProc2;    // Pointer to dialog proc for page 2

		psp[2].pszTemplate = MAKEINTRESOURCE(IDD_ADD_TRIGGERSET_3); // Name of dialog resource for page 3
		psp[2].pfnDlgProc = AddTriggersetDlgProc3;    // Pointer to dialog proc for page 3


		// Init property sheet header structure.
		psh.dwSize = sizeof (PROPSHEETHEADER);
		psh.dwFlags = PSH_PROPSHEETPAGE | PSH_USECALLBACK;    // We are using templates not handles.
		psh.hwndParent = hWnd;              // Handle of the owner window
		psh.hInstance = hInst;              // Instance handle of the application
		psh.pszCaption = TEXT ("Add Triggerset");
		psh.nPages = 3;                    // Number of pages
		psh.nStartPage = 0;                  // Index of page to be shown first
		psh.ppsp = psp;                     // Pointer to page structures
		psh.pfnCallback = AddTriggersetPropSheetProc;   

		// Create property sheet.  This returns when the user dismisses the sheet
		// by tapping OK or the Close button.

		return PropertySheet (&psh);


}
#endif

/**********************************************************************/
/*   Dialog box procedure for the 'Configure trigger sets' dialog.    */
/**********************************************************************/
BOOL CALLBACK AdministerTriggerSetsDlgProc(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
#ifdef WINCE 
   SHINITDLGINFO shidi; // New in PocketPC version
#endif
   HWND hWndDlgItem;
   BYTE Index;
   INT Status;
   DWORD dwIndex;
   TCHAR TriggerSetName[68], MessageText[256], FileSpec[MAX_PATH+1]; 
   TRIG_SET_CNF_FILE TrigSetConf;

   switch(message)  {
      case WM_INITDIALOG:
#ifdef WINCE
	  // Create a Done button and size it. New in PocketPC version.
	  shidi.dwMask = SHIDIM_FLAGS;
	  shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
	  shidi.hDlg = hWndDlg;
	  SHInitDialog(&shidi);
#endif
      // Load the trigger sets from disk.
      RegisterTriggerSets();   

      // Initialize the ' Configured trigger sets' list box.
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_LIST1);
      for (Index=0;Index<NumRegisteredTriggersets;Index++) {
         _itow(Index+1, TriggerSetName, 10);
         wcscat(TriggerSetName, TEXT(". "));
         wcscat(TriggerSetName, Triggers[Index].Name);
         dwIndex=SendMessage(hWndDlgItem, LB_ADDSTRING, 0, (LPARAM)TriggerSetName);
         if (Index==0) SendMessage(hWndDlgItem, LB_SETCURSEL, dwIndex, 0);
      }

      // Disable buttons as needed.
      if (!NumRegisteredTriggersets) {
         // No triggers are defined. Disable all buttons accept the 'Add' button. 
         EnableWindow(GetDlgItem(hWndDlg, IDC_BUTTON2), FALSE); 
         EnableWindow(GetDlgItem(hWndDlg, IDC_BUTTON3), FALSE); 
      }
      if (NumRegisteredTriggersets==MAX_NUM_OF_TRIGGERSETS) {
         // No room for any more sets. Disable the 'Add' button. 
         EnableWindow(GetDlgItem(hWndDlg, IDC_BUTTON1), FALSE); 
      }   
      return TRUE; 

      
      case WM_COMMAND:
      switch(LOWORD(wParam)) {
         case IDC_BUTTON1:
         //
         // This is the 'Add' button. The user wants to add a new triggerset.
         //
         // Check that there are a least one channel configured.
         //
         if (NumRegisteredChannels==0) {
            wcscpy(MessageText, TEXT("There are no configured channels.\n"));
            MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONHAND);
            return FALSE;
         }

         //
         // Transfer control to the 'Add channel' dialog box.
         // Here the user will enter the parameters for the channel. 
         // The information is returned in the 'ChannelConf' structure.
         // The logical channel nr. for the new channel is returned
         // as the status value from the call to 'DialogBoxParam'.
         //
         ZeroMemory((PVOID)&TrigSetConf, (DWORD)sizeof(TRIG_SET_CNF_FILE));  // Clear the return structure.

         // Set default values.
         TrigSetConf.PreEventTime=10;
         TrigSetConf.MaxEventDuration=60;
         TrigSetConf.PostEventTime=10;
         TrigSetConf.NumTrigsInTimeWindow=1;
         TrigSetConf.TimeWindowLength=2;

         // Bring up the dialog box.
#ifdef WINCE
         Status=AddTriggersetDialogBox(hInst, hWndDlg, (LPARAM)(TRIG_SET_CNF_FILE*)&TrigSetConf);
#else
		 Status=DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_ADD_TRIGGERSET), hWndDlg, (DLGPROC)AddTriggersetDlgProc, (LPARAM)(TRIG_SET_CNF_FILE*)&TrigSetConf);
#endif

         // End here if user aborted.
         if (!Status) break;
         
         //
         // Save the configuration to disk.
			//
         
			// Create the filespecification for the file.
         AddPathAndFilename(FileSpec, TriggerDir, TrigSetConf.Name);
         wcscat(FileSpec, TEXT(".trg"));
         //
         // Write configuration to disk.
         if (!WriteFileFromMemory(FileSpec, &TrigSetConf, sizeof(TRIG_SET_CNF_FILE))) {
            // Write to config file failed.
            wcscpy(MessageText, TEXT("An error occured while writing the triggerset\n"));
            wcscat(MessageText, TEXT("config file! Triggerset has NOT been saved."));
            MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
         }

         //
         // Update the Trigger table.
         //
         RegisterTriggerSets();   

         //
         // Update the list box.
         //
         hWndDlgItem=GetDlgItem(hWndDlg, IDC_LIST1);
         SendMessage(hWndDlgItem, LB_RESETCONTENT, 0, 0);
         for (Index=0;Index<NumRegisteredTriggersets;Index++) {
            _itow(Index+1, TriggerSetName, 10);
            wcscat(TriggerSetName, TEXT(". "));
            wcscat(TriggerSetName, Triggers[Index].Name);
            dwIndex=SendMessage(hWndDlgItem, LB_ADDSTRING, 0, (LPARAM)TriggerSetName);
            if (Index==0) SendMessage(hWndDlgItem, LB_SETCURSEL, dwIndex, 0);
         }


         // Operation succeeded, inform user.
         wcscpy(MessageText, TEXT("Triggerset was sucessfully configured!"));
         if (IsSystemRunning()) wcscat(MessageText, TEXT("\nYou must restart the system for changes to take effect."));
         MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONINFORMATION);



         // Enable buttons as needed.
         if (NumRegisteredTriggersets) {
            if (NumRegisteredTriggersets==MAX_NUM_OF_TRIGGERSETS) EnableWindow(GetDlgItem(hWndDlg, IDC_BUTTON1), FALSE);
            EnableWindow(GetDlgItem(hWndDlg, IDC_BUTTON2), TRUE); 
            EnableWindow(GetDlgItem(hWndDlg, IDC_BUTTON3), TRUE);
         }
         break;
      


         case IDC_BUTTON2:
         //
         // This is the 'Remove' button. The user wants to remove a triggerset.
         //

         // Check that there are any sets to remove.
         if (!NumRegisteredTriggersets) {
            MessageBeep(MB_ICONHAND);
            return FALSE;
         }

         // Get selection from list box. (Get the triggerset name).
         hWndDlgItem=GetDlgItem(hWndDlg, IDC_LIST1);
         dwIndex=SendMessage(hWndDlgItem, LB_GETCURSEL, 0, 0);
         SendMessage(hWndDlgItem, LB_GETTEXT, (WPARAM)dwIndex, (LPARAM)(LPCTSTR)TriggerSetName);
         StrDelete(TriggerSetName, 0); // Remove the triggerset number from the string.
         StrDelete(TriggerSetName, 0); 
         StrDelete(TriggerSetName, 0);

         // Force user to confirm removal of triggerset.
         wcscpy(MessageText, TEXT("Are you sure you want to remove "));
         wcscat(MessageText, TriggerSetName);
         wcscat(MessageText, TEXT(" ?"));
         Status=MessageBox(hWndDlg, MessageText, TEXT("Seislog"), MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2);
         if (Status==IDYES) { 
            // Try deleting the trigger set file.
            AddPathAndFilename(FileSpec, TriggerDir, TriggerSetName);
            wcscat(FileSpec, TEXT(".trg"));
            if (!DeleteFile(FileSpec)) {
               // Unable to delete the triggerset config file.
               //
               // Inform user.
               wcscpy(MessageText, TEXT("Unable to remove trigger set file: "));
               wcscat(MessageText, FileSpec);
               wcscat(MessageText, TEXT(".\nCheck the file's properties. File may have the 'Read-only' attribute set."));
               MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
            } else {
               // File was succesfully deleted.
               //
               // Update the Trigger table.
               RegisterTriggerSets();   

               // Update the list box.
               hWndDlgItem=GetDlgItem(hWndDlg, IDC_LIST1);
               SendMessage(hWndDlgItem, LB_RESETCONTENT, 0, 0);
               for (Index=0;Index<NumRegisteredTriggersets;Index++) {
                  _itow(Index+1, TriggerSetName, 10);
                  wcscat(TriggerSetName, TEXT(". "));
                  wcscat(TriggerSetName, Triggers[Index].Name);
                  dwIndex=SendMessage(hWndDlgItem, LB_ADDSTRING, 0, (LPARAM)TriggerSetName);
                  if (Index==0) SendMessage(hWndDlgItem, LB_SETCURSEL, dwIndex, 0);
               }

               // Operation succeeded, inform user.
               wcscpy(MessageText, TEXT("Triggerset was sucessfully removed!"));
               if (IsSystemRunning()) wcscat(MessageText, TEXT("\nYou must restart the system for changes to take effect."));
               MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONINFORMATION);
           
               // Disable buttons if needed.
               if (!NumRegisteredTriggersets) {
                  EnableWindow(GetDlgItem(hWndDlg, IDC_BUTTON1), TRUE);    
                  EnableWindow(GetDlgItem(hWndDlg, IDC_BUTTON2), FALSE); 
                  EnableWindow(GetDlgItem(hWndDlg, IDC_BUTTON3), FALSE); 
               }
            }
         }
         break;


         
         
         case IDC_BUTTON3:
         //
         // This is the 'Modify' button.
         // Let user change the parameters for the selected triggerset.
         //

         // Get selection from list box. (Get the triggerset name).
         hWndDlgItem=GetDlgItem(hWndDlg, IDC_LIST1);
         dwIndex=SendMessage(hWndDlgItem, LB_GETCURSEL, 0, 0);
         SendMessage(hWndDlgItem, LB_GETTEXT, (WPARAM)dwIndex, (LPARAM)(LPCTSTR)TriggerSetName);
         StrDelete(TriggerSetName, 0); // Remove the triggerset number from the string.
         StrDelete(TriggerSetName, 0); 
         StrDelete(TriggerSetName, 0);


         //
         // Read configuration from disk.
         //
         // Create the filespcification to the file.
         AddPathAndFilename(FileSpec, TriggerDir, TriggerSetName);
         wcscat(FileSpec, TEXT(".trg"));
         //
         // Read configuration from disk.
         if (!ReadFileToMemory(FileSpec, &TrigSetConf, sizeof(TRIG_SET_CNF_FILE))) {
            // Read config file failed.
            wcscpy(MessageText, TEXT("An error occured while reading the triggerset config file!\n"));
            wcscat(MessageText, TEXT("The file may be corrupt or missing."));
            MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

            break;
         }


         //
         // Check if triggerset refers to any nonexisting channels.
         //
         Status=CheckTriggersetChannels(&TrigSetConf);
         if (Status) {
            wcscpy(MessageText, TEXT("This triggerset refers to one or more nonexisting channels."));
            wcscat(MessageText, TEXT("  Should theese channels be removed from the triggerset?  "));
            Status=MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_YESNO|MB_ICONERROR);
            if (Status==IDYES) RemoveNonexistingChnlsFromTrigset(&TrigSetConf);
         }


         //
         // Bring up the 'add triggerset' dialog box.
         //
         TrigSetConf.bModify=TRUE; // This is a modification only.

#ifdef WINCE
		 Status=AddTriggersetDialogBox(hInst, hWndDlg, (LPARAM)(TRIG_SET_CNF_FILE*)&TrigSetConf);
#else
         Status=DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_ADD_TRIGGERSET), hWndDlg, (DLGPROC)AddTriggersetDlgProc, (LPARAM)(TRIG_SET_CNF_FILE*)&TrigSetConf);
#endif
			

         // End here if user aborted.
         if (!Status) break;

         
         //
         // Write new configuration to disk.
         //
         if (!WriteFileFromMemory(FileSpec, &TrigSetConf, sizeof(TRIG_SET_CNF_FILE))) {
            // Write to config file failed.
            wcscpy(MessageText, TEXT("An error occured while writing the triggerset config file!\n"));
            wcscpy(MessageText, TEXT("Modified triggerset has NOT been saved."));
            MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONERROR);
         } else {
            // Inform user that system must be restarted.
            if (IsSystemRunning()) {
               wcscpy(MessageText, TEXT("You must restart the system for changes to take effect."));
               MessageBox(hWndDlg, MessageText, TEXT("Seislog message"), MB_OK|MB_ICONINFORMATION);
            }
         }
         break;


	     case IDOK: 
			// Changed in PocketPC version. ID is IDC_CLOSE in Win9X version.         
         // This is the 'Close' button.
         // Close the dialog box
         EndDialog(hWndDlg , 0);
         break;

      }
      return FALSE;
   }
   return FALSE;
}


/*******************************************************************/
/*   Dialog box procedure for the 'Simulate event' dialog.         */
/*******************************************************************/
BOOL CALLBACK SimulateEventDlgProc(HWND hWndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

   SHINITDLGINFO shidi; // New in PocketPC version
   HWND hWndDlgItem;
   TCHAR Message[150];
   BYTE Index;
   DWORD ThreadID; 
   HANDLE hThread;
   SYSTEMTIME CurrentTime;
   static STARTINFO_WRITEEVENT SIWE;
   static DWORD Channels[MAX_NUM_OF_CHANNELS];
   static BOOL EventStarted;
   static BOOL OnDelay = FALSE;

   const UINT IDTimer = 1;


   switch(message)
   {
      case WM_INITDIALOG:

	  // Create a Done button and size it. New in PocketPC version.
	  shidi.dwMask = SHIDIM_FLAGS;
	  shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
	  shidi.hDlg = hWndDlg;
	  SHInitDialog(&shidi);

	  //++

	  // Set range and position of spin controls

	  hWndDlgItem = GetDlgItem(hWndDlg, IDC_SPIN_DEL_M);
	  SendMessage(hWndDlgItem, UDM_SETRANGE, 0, (LPARAM)MAKELONG((short)15, (short)1));
	  SendMessage(hWndDlgItem, UDM_SETPOS, 0, (LPARAM)MAKELONG((short)1, 0));

	  hWndDlgItem = GetDlgItem(hWndDlg, IDC_SPIN_REC_H);
	  SendMessage(hWndDlgItem, UDM_SETRANGE, 0, (LPARAM)MAKELONG((short)2, (short)0));
	  SendMessage(hWndDlgItem, UDM_SETPOS, 0, (LPARAM)MAKELONG((short)0, 0));

  	  hWndDlgItem = GetDlgItem(hWndDlg, IDC_SPIN_REC_M);
	  SendMessage(hWndDlgItem, UDM_SETRANGE, 0, (LPARAM)MAKELONG((short)59, (short)0));
	  SendMessage(hWndDlgItem, UDM_SETPOS, 0, (LPARAM)MAKELONG((short)1, 0));
	  //--

	  // Initialize variables.
      EventStarted=FALSE;
      ZeroMemory((PVOID)&SIWE, (DWORD)sizeof(SIWE));
      wcscpy(SIWE.EFileDir, EventFileDir);
      wcscpy(SIWE.SFileDir, SFileDir);
      SIWE.ManualTrig=TRUE;
      SIWE.ReleaseMemory=FALSE;

      // Initialize the 'Event directory' edit box.
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_EDIT1);
      SetDlgItemText(hWndDlg, IDC_EDIT1, EventFileDir);

      // Initialize the 'S-file directory' edit box.
      hWndDlgItem=GetDlgItem(hWndDlg, IDC_EDIT2);
      SetDlgItemText(hWndDlg, IDC_EDIT2, SFileDir);

      // Get a list of all running channels.
      SIWE.NumOfDFileChannels=SIWE.NumOfSFileChannels=GetRunningChannels(Channels);

      // Copy threadID's over to the StartInfo structure.
      for (Index=0;Index<SIWE.NumOfDFileChannels;Index++)
	  {
         SIWE.DumpChannels[Index]=Channels[Index];
         SIWE.SChData[Index].ThreadID=Channels[Index];
      }
      return TRUE;

	  //++

	  case WM_TIMER:
	  {
		  // Kill any pending timer
		 KillTimer(hWndDlg, IDTimer);

		 //MessageBox(hWndDlg, TEXT("TIMER"), TEXT("TIMER"), MB_OK);
		 
		 if (TRUE == OnDelay)
		 {
			 
			 // Delay period has finished - start recording

			 OnDelay = FALSE;

			 hWndDlgItem = GetDlgItem(hWndDlg, IDC_SPIN_REC_M);
 			 UINT minutes = LOWORD(SendMessage(hWndDlgItem, UDM_GETPOS, 0, 0));
			 
			 hWndDlgItem = GetDlgItem(hWndDlg, IDC_SPIN_REC_H);
			 UINT hours   = LOWORD(SendMessage(hWndDlgItem, UDM_GETPOS, 0, 0));

			 UINT milliseconds = 1000 * 60 * (minutes + (hours * 60));

			
			 // Set status info
			 TCHAR recordString[] = TEXT("Recording...");
			 SetDlgItemText(hWndDlg, IDC_STATUS, recordString);

			 // Start delayed recording

			 // Get and save the current time in the startup structure.
			 // This time will mark the start of the event.
			 GetSystemTime(&CurrentTime);
			 for (Index=0;Index<SIWE.NumOfSFileChannels;Index++)
			 {
			  	SIWE.EventStartTime=CurrentTime;
			 	SIWE.SChData[Index].ChEventStartTime=CurrentTime;
			 }

			 // Create timer to stop recording

			 if (IsDlgButtonChecked(hWndDlg, IDC_CHECK_REC))
			 {
				SetTimer(hWndDlg, IDTimer, milliseconds, NULL);
			 }


		 }
		 else
		 {

			// Stop recordning
			TCHAR finishString[] = TEXT("");
			SetDlgItemText(hWndDlg, IDC_STATUS, finishString);

			// Send message to finish

			SendMessage(hWndDlg, WM_COMMAND, MAKEWPARAM(ID_START, 0), 0);


		 }
		 return TRUE;
	  }

      //--


      case WM_COMMAND:
      switch(LOWORD(wParam))
	  {
         case ID_START:
         //
         // This is the 'Start/Stop' button.
         //


		 // Kill timer
		 KillTimer(hWndDlg, IDTimer);


	     if (IsDlgButtonChecked(hWndDlg, IDC_CHECK_REC))
		 {
			hWndDlgItem = GetDlgItem(hWndDlg, IDC_SPIN_REC_M);
 			UINT minutes = LOWORD(SendMessage(hWndDlgItem, UDM_GETPOS, 0, 0));
			 
			hWndDlgItem = GetDlgItem(hWndDlg, IDC_SPIN_REC_H);
			UINT hours   = LOWORD(SendMessage(hWndDlgItem, UDM_GETPOS, 0, 0));
			
			if (0 == minutes && 0 == hours)
			{
				MessageBox(hWndDlg, TEXT("Recording time must be greater than 0!"),
					                TEXT("Invalid recording time"), MB_OK);
				return true;

			}
		 }
				 

         // Handle button-press.
         if (EventStarted)
		 {
            //++

			TCHAR finishString[] = TEXT("");
			SetDlgItemText(hWndDlg, IDC_STATUS, finishString);

			//--

            // Stop button is pressed.
            //
            // Change button text from 'Stop' to 'Start'.
            EventStarted=FALSE;   
            SetDlgItemText(hWndDlg, ID_START, TEXT("START"));

            // Get and save the current time in the startup structure.
            // This time will mark the end of the event.
            GetSystemTime(&CurrentTime);
            for (Index=0;Index<SIWE.NumOfSFileChannels;Index++)
			{
               SIWE.EventStopTime=CurrentTime;
               SIWE.SChData[Index].ChEventStopTime=CurrentTime;
            }

            // Get directories.
            GetDlgItemText(hWndDlg, IDC_EDIT1, SIWE.EFileDir, MAX_PATH);
            GetDlgItemText(hWndDlg, IDC_EDIT2, SIWE.SFileDir, MAX_PATH);

            // Start the 'WriteEvent' thread.
            SetCursor(LoadCursor(NULL, IDC_WAIT));  // Show the 'hourglass' cursor.
            hThread=CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)WriteEventThrdProc, (PVOID)&SIWE, 0, &ThreadID);
            WaitForSingleObject(hThread, INFINITE); // Wait for the thread to finish.
            SetCursor(LoadCursor(NULL, IDC_ARROW)); // Show the normal 'arrow' cursor.

            // Enable the edit boxes.
            EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT1), TRUE);
            EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT2), TRUE);

			//++

			// Enable the timer boxes

			EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT_REC_M), TRUE);
			EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT_REC_H), TRUE);
			EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT_DEL_M), TRUE);
			EnableWindow(GetDlgItem(hWndDlg, IDC_SPIN_REC_M), TRUE);
			EnableWindow(GetDlgItem(hWndDlg, IDC_SPIN_REC_H), TRUE);
			EnableWindow(GetDlgItem(hWndDlg, IDC_SPIN_DEL_M), TRUE);
			EnableWindow(GetDlgItem(hWndDlg, IDC_CHECK_DEL), TRUE);
			EnableWindow(GetDlgItem(hWndDlg, IDC_CHECK_REC), TRUE);


			//++ Disable the pending timer
			
			//--

         }
		 else
		 {
            // Start button is pressed.
            //
            // Get directories from dialog box.
            GetDlgItemText(hWndDlg, IDC_EDIT1, SIWE.EFileDir, MAX_PATH);
            GetDlgItemText(hWndDlg, IDC_EDIT2, SIWE.SFileDir, MAX_PATH);

            // Start if directories exist.
            if (ExistDirectory(SIWE.EFileDir) && ExistDirectory(SIWE.SFileDir))
			{
               // Change button text from 'Start' to 'Stop'.
               EventStarted=TRUE;   
               SetDlgItemText(hWndDlg, ID_START, TEXT("STOP"));

			   //++

			   if (IsDlgButtonChecked(hWndDlg, IDC_CHECK_DEL))
			   {
				   // In delay periode
				   OnDelay = TRUE;

				   // Set status message

				   TCHAR delayString[] = TEXT("Waiting...");
				   SetDlgItemText(hWndDlg, IDC_STATUS, delayString);
	   				   

				   //Get delay and post the delay timer message

				   hWndDlgItem = GetDlgItem(hWndDlg, IDC_SPIN_DEL_M);
				   UINT minutes = LOWORD(SendMessage(hWndDlgItem, UDM_GETPOS, 0, 0));

				   SetTimer(hWndDlg, IDTimer, minutes * 60 * 1000, NULL);

			   }
			   else
			   {
				   //-- Start immediatly

				   hWndDlgItem = GetDlgItem(hWndDlg, IDC_SPIN_REC_M);
 				   UINT minutes = LOWORD(SendMessage(hWndDlgItem, UDM_GETPOS, 0, 0));
				 
				   hWndDlgItem = GetDlgItem(hWndDlg, IDC_SPIN_REC_H);
				   UINT hours   = LOWORD(SendMessage(hWndDlgItem, UDM_GETPOS, 0, 0));

				   UINT milliseconds = 1000 * 60 * (minutes + (hours * 60));

					 // Create timer to stop recording

				   if (IsDlgButtonChecked(hWndDlg, IDC_CHECK_REC))
				   {
						SetTimer(hWndDlg, IDTimer, milliseconds, NULL);
				   }

				  
				   // Set status info
				   TCHAR recordString[] = TEXT("Recording...");
				   SetDlgItemText(hWndDlg, IDC_STATUS, recordString);			   

				   // Get and save the current time in the startup structure.
				   // This time will mark the start of the event.
				   GetSystemTime(&CurrentTime);
				   for (Index=0;Index<SIWE.NumOfSFileChannels;Index++)
				   {
					  SIWE.EventStartTime=CurrentTime;
					  SIWE.SChData[Index].ChEventStartTime=CurrentTime;
				   }

			   //++
			   }


			   EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT_REC_M), FALSE);
			   EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT_REC_H), FALSE);
			   EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT_DEL_M), FALSE);
			   EnableWindow(GetDlgItem(hWndDlg, IDC_SPIN_REC_M), FALSE);
			   EnableWindow(GetDlgItem(hWndDlg, IDC_SPIN_REC_H), FALSE);
			   EnableWindow(GetDlgItem(hWndDlg, IDC_SPIN_DEL_M), FALSE);
			   EnableWindow(GetDlgItem(hWndDlg, IDC_CHECK_DEL), FALSE);
			   EnableWindow(GetDlgItem(hWndDlg, IDC_CHECK_REC), FALSE);

			   //---

               // Disable the edit boxes.
               EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT1), FALSE);
               EnableWindow(GetDlgItem(hWndDlg, IDC_EDIT2), FALSE);
            }
			else
			{
               // Directories are invalid or does not exist.
               wcscpy(Message, TEXT("Directories given are invalid or nonexisting.\n"));
               wcscat(Message, TEXT("Check your spelling and make sure both directories exist."));
               MessageBox(hWndDlg, Message, TEXT("Seislog message"), MB_OK|MB_ICONERROR);

               // Move the input focus to the first edit box field.
               SetFocus(GetDlgItem(hWndDlg, IDC_EDIT1));
            }
         }
         break;
         

         case IDOK: //Changed in PocketPC version. ID is ID_CLOSE in Win9X version.
         //
         // This is the 'Close' button.
         //
         // Close the dialog box
         EndDialog(hWndDlg , 0);
         break;

      }
      return FALSE;
   }
   return FALSE;
}




/*******************************************************************************/
/* Reads and load information from disk about all configured trigger sets.     */
/* Save number of sets found in the global variable NumRegisteredTriggersets.  */
/*******************************************************************************/
VOID RegisterTriggerSets(VOID)
{
   // Browse through the 'Triggersets' directory.
   // Register all files that has a 'trg' extension as trigger sets.

   TCHAR TrigSetName[65], FileSpec[MAX_PATH+1];
   TCHAR FileName[MAX_PATH+1];
   BYTE Index;
   HANDLE SearchHndl;
   WIN32_FIND_DATA FileData;

   //
   // Clear/initialize the 'Triggers' array.
   //
   for (Index=0;Index<MAX_NUM_OF_TRIGGERSETS;Index++) wcscpy(Triggers[Index].Name, TEXT(""));
   NumRegisteredTriggersets=0;


   //
   // Register trigger sets.
   //
   //
   // Build file-search-specification string.
   AddPathAndFilename(FileSpec, TriggerDir, TEXT("*.trg"));

   //
   // Find and handle the first file.
   //
   SearchHndl=FindFirstFile(FileSpec, &FileData);
   if (SearchHndl==INVALID_HANDLE_VALUE) return;
   if (!(FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
      // We have found a .trg file.
      // Find the name of the file (excluding the extension).
      // This name will be used as the trigger set name.
      wcscpy(FileName, FileData.cFileName);
      StrDelete(FileName, wcslen(FileName)-1);
      StrDelete(FileName, wcslen(FileName)-1);
      StrDelete(FileName, wcslen(FileName)-1);
      StrDelete(FileName, wcslen(FileName)-1);
      wcsncpy(TrigSetName, FileName, 64); TrigSetName[64]=0;

      // Register trigger set name into the 'Triggers' table.
      wcscpy(Triggers[NumRegisteredTriggersets].Name, TrigSetName);         
   
      // Increase trigger set counter.
      NumRegisteredTriggersets++;
   }


   //
   // Find and process the rest of the files.
   //
   while (FindNextFile(SearchHndl, &FileData)) {
      if (!(FileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
         // We have found a .trg file.
         // Find the name of the file (excluding the extension).
         // This name will be used as the trigger set name.
         wcscpy(FileName, FileData.cFileName);
         StrDelete(FileName, wcslen(FileName)-1);
         StrDelete(FileName, wcslen(FileName)-1);
         StrDelete(FileName, wcslen(FileName)-1);
         StrDelete(FileName, wcslen(FileName)-1);
         wcsncpy(TrigSetName, FileName, 64); TrigSetName[64]=0;

         // Register trigger set name into the 'Triggers' table.
         if (NumRegisteredTriggersets<MAX_NUM_OF_TRIGGERSETS) {
            wcscpy(Triggers[NumRegisteredTriggersets].Name, TrigSetName);         
            NumRegisteredTriggersets++;
         }
      }
   }

   // Close the handle.
   FindClose(SearchHndl);

   return;  
}





/*******************************************************************************/
/* Start all trigger threads registered in the Triggers table.                 */
/* The trigger threads are not sendt the TM_START message.                     */
/*******************************************************************************/
VOID LoadTriggers(VOID)
{
   BYTE Index;
   HANDLE hThread;
   DWORD ThreadID;
   STARTINFO_EVENTDETECTION SITT;

   //
   // Go trough the 'Triggers' table.
   //
   for (Index=0;Index<NumRegisteredTriggersets;Index++) {
      //
      // Start event detection thread for this triggerset.
      //

      // Initialize the thread's startup structure.
      wcscpy(SITT.Name, Triggers[Index].Name);
      SITT.TrgSetNumber=Index+1;
      SITT.StartEvent=CreateEvent(NULL, FALSE, FALSE, NULL);

      // Create the thread.
      hThread=CreateThread(NULL, 0, EventDetectionThrd, (PVOID)&SITT, CREATE_SUSPENDED, &ThreadID);

      // Set the thread's priority.
      SetThreadPriority(hThread, THREAD_PRIORITY_NORMAL);

      // Resume thread. The thread will now start running.
      ResumeThread(hThread);

      // Wait for the thread to start.
      WaitForSingleObject(SITT.StartEvent, INFINITE);

      // Delete the event object.
      CloseHandle(SITT.StartEvent);
   }
}





/************************************************************************************************/
/* Start opreation of all running event detection threads by sending them the TM_START message. */
/************************************************************************************************/
VOID StartTriggers(VOID)
{
   BYTE NumEventDetections, Index;
   HANDLE hEvent;
   MSG_PARAM MsgParam;
   DWORD EventDetections[MAX_NUM_OF_TRIGGERSETS];

   // Get a list of all event detection threads runing.
   MsgParam.vPointer=(PVOID)&EventDetections;
   hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
   PostThreadMessage(ProcKeeperThreadID, TM_GET_EVENTDETECTIONS, (WPARAM)hEvent, (LPARAM)&MsgParam); 
   WaitForSingleObject(hEvent, INFINITE);
   NumEventDetections=(BYTE)MsgParam.dwStatus;
   CloseHandle(hEvent);

   // Send TM_START message to all event detection threads.
   for (Index=0;Index<NumEventDetections;Index++) PostThreadMessage(EventDetections[Index], TM_START, 0, 0); 

}






/*******************************************************************************/
/* Scans trough the 'Triggers' table and searches for a triggerset.            */
/* with a name equal to that given by 'TriggersetName' Returns TRUE if found.  */
/*******************************************************************************/
BOOL ExistTriggerset(PTCHAR TriggersetName)
{
   BYTE Index;
   for (Index=0;Index<NumRegisteredTriggersets;Index++) {
      if (!_wcsicmp(Triggers[Index].Name, TriggersetName)) return TRUE;
   }

   return FALSE;
}




/*************************************************************/
/* Return the current UTC time. Milliseconds are zeroed.     */
/*************************************************************/
VOID GetCurUTCTime(SYSTEMTIME* Time)
{

   GetSystemTime(Time);
   Time->wMilliseconds=0;

}




/**********************************************************************/
/* Moves a index-pointer into a table 'NumSteps' steps up (Right).    */
/* If the pointer points to the end of the table,                     */
/* the pointer is moved to the start of the table and upwards.        */
/**********************************************************************/
VOID MoveTablePointerUp(WORD *Pointer, WORD NumSteps, WORD TableSize)
{
   WORD counter;

   for (counter=1;counter<=NumSteps;counter++) {
      *Pointer=*Pointer+1;
      if (*Pointer==TableSize) *Pointer=0;
   }
}




/**********************************************************************/
/* Moves a index-pointer into a table 'NumSteps' steps down (Left).   */
/* If the pointer points to the start of the table,                   */
/* the pointer is moved to the end of the table and down.             */
/**********************************************************************/
VOID MoveTablePointerDown(WORD *Pointer, WORD NumSteps, WORD TableSize)
{
   WORD counter;

   for (counter=1;counter<=NumSteps;counter++) {
      if (*Pointer==0) {
         *Pointer=TableSize-1;
      } else {
         *Pointer=*Pointer-1;
      }
   }
}





/********************************************************************/
/* Returns the row into the ChInfo table where the information for  */
/* the channel-thread identified by 'ChTreadID', can be found.      */ 
/********************************************************************/
BYTE GetChannelRow(DWORD ChThreadID, CHINFO* pTable, BYTE TableSize)
{
   BYTE Index;
   for (Index=0;Index<TableSize;Index++) {
      if (pTable[Index].ThreadID==ChThreadID) return Index;
   }

   return 255;
}



/*********************************************************************/
/* Converts a logical column-pointer to a physical column-pointer    */
/* ,used to accsess elements in the 'EventTab' table. The conversion */
/* is based on the number of columns the table is currently scrolled.*/
/* The 'LogicalCol' varable starts at 0 (zerobased).                 */
/*********************************************************************/
WORD GetPhysicalCol(WORD LogicalCol, WORD ScrollOffset, WORD TableSize)
{
   WORD PhysicalCol;

   if (ScrollOffset==0) return LogicalCol;

   PhysicalCol=LogicalCol;
   MoveTablePointerDown(&PhysicalCol, ScrollOffset, TableSize);
   return PhysicalCol;

}




/**************************************************************/
/* Adds a year and a month subfolder to the path given in the */
/* SFileDir variable based on the time in the 'Time' variable */
/* Example C:\SEISAN\  --> C:\SEISAN\1998\05 .                */
/* The year and month directoies are created if needed.       */
/**************************************************************/
BOOL AddSeisanSudirs(PTCHAR SFileDir, SYSTEMTIME Time) 
{
   TCHAR str4[5];

   // Check if directory given in 'SFileDir' exist.
   if (!ExistDirectory(SFileDir)) return FALSE;

   // Add Year directory.
   StripBackslashFromPath(SFileDir);
   wcscat(SFileDir, TEXT("\\"));
   swprintf(str4, TEXT("%4d"), Time.wYear);  
   wcscat(SFileDir, str4);

   // Create Year directory if it does not exist.
   if (!ExistDirectory(SFileDir)) CreateDirectory(SFileDir, NULL);

   // Add Month directory.
   wcscat(SFileDir, TEXT("\\"));
   swprintf(str4, TEXT("%02d"), Time.wMonth);  
   wcscat(SFileDir, str4);

   // Create Month directory if it does not exist.
   if (!ExistDirectory(SFileDir)) CreateDirectory(SFileDir, NULL);

   // Return status.   
   return ExistDirectory(SFileDir);
}




/**********************************************************************************/
/* Determins if there is a event in the event window for a certain channel (row). */
/**********************************************************************************/
BOOL EventInRow(WORD RowIndex, PWORD pTable, WORD EventwinFirstCol, 
                WORD EventwinLastCol, WORD ScrollOffset, WORD NumCols)
{
   WORD ColIndex, column;
   BOOL EventFound=FALSE;

   ColIndex=EventwinFirstCol;
   while (!EventFound && ColIndex<=EventwinLastCol) {
      column=GetPhysicalCol(ColIndex, ScrollOffset, NumCols);
      if (EventTab(RowIndex, column)<NOEVENT) EventFound=TRUE;
      ColIndex++;
   }

   return EventFound;
}




/**********************************************************************************/
/* Finds the last column in the event window that has an event. All channels are  */
/* checked. This column will mark the start of the network event.                 */
/**********************************************************************************/
BOOL FindNetworkEventStartCol(WORD *StartCol, PWORD pTable, WORD EventwinFirstCol, 
                              WORD EventwinLastCol, WORD ScrollOffset, WORD NumCols, 
                              WORD NumRows)
{
   WORD ColIndex, RowIndex, column;
   BOOL EventFound;

   EventFound=FALSE;
   ColIndex=EventwinLastCol;
   while (ColIndex>=EventwinFirstCol && !EventFound) {
      RowIndex=0;
      column=GetPhysicalCol(ColIndex, ScrollOffset, NumCols);
      while (RowIndex<NumRows && !EventFound) {
         if (EventTab(RowIndex, column)<NOEVENT) {
            EventFound=TRUE;
            *StartCol=ColIndex;
         }
         RowIndex++;
      }
      ColIndex--;
   }

   return EventFound;
}




/**************************************************************************************/
/* This procedure is called to find two indexes(columns) into the 'EventTab' table,   */
/* given a certain row number. It is assumed that there are already detected an event */
/* inside of the event window for this row. This procedure will return the row number */
/* for the last column in the TABLE belonging to the event (EventStartCol). This      */
/* column number can then be used to find the start time for the event. The next row  */
/* number that will be returned (EOECheckCol), points to the last column in the       */
/* EVENT-WINDOW that belong the the event. This column will then be monitored by the  */
/* trigger thread to detect the end of the event. If there are more then one event    */
/* inside the event window, then the last event (the first in time) will be targeted. */
/*                                                                                    */
/*                  EOECC  ESC(EventStartColumn)                                      */
/*                  *      *                                                          */
/* .....111|112221122|2222221111111111111...  An assumed row in the EventTab table.   */
/*                                                                                    */ 
/*       EOECC=ESC                                                                    */ 
/*          *                                                                         */
/* .....111|211111111|1111111111111111111...  Another assumed row.                    */
/*                                                                                    */
/* 1 = NO EVENT                                                                       */
/* 2 = EVENT                                                                          */
/*                                                                                    */
/* The column numbers for the two column marked with an '*' will be returned.         */
/* The event window part of the table is enclosed between the '|' TTCHARacters.         */
/*                                                                                    */
/**************************************************************************************/
BOOL FindTrigColumns(WORD RowIndex, PWORD pTable, WORD EventwinFirstCol, WORD EventwinLastCol,
                     WORD ScrollOffset, WORD NumCols, PWORD EventStartCol, PWORD EOECheckCol)
{
   WORD ColIndex, column;
   BOOL Found;

   // Start from the end of the event window and search downwards
   // for a column that is marked as having an event. We are trying
   // to find the last column in the event window that have an event.
   // This column will then be monitored by this trigger thread to 
   // detect the end of the event. We need to know the time of the end 
   // of the event for the S-file.
   Found=FALSE;   
   ColIndex=EventwinLastCol;
   while (!Found && ColIndex>=EventwinFirstCol) {
      // Get the physical table-column.
      column=GetPhysicalCol(ColIndex, ScrollOffset, NumCols);
      // Is there an event in this column.
      if (EventTab(RowIndex, column)<NOEVENT) {
         // We have found the column
         Found=TRUE;
         *EOECheckCol=ColIndex;
      }
      // Move down one column
      ColIndex--;
   }
   // If nothing was found then exit. This should not happen
   if (!Found) return FALSE;

   
   // The column we have found above is a part of an event.
   // It may represent the start, the end or the middle of
   // the event. We need to find the start, so we must
   // search rightwards in the table until we find a column
   // with no event, or we reach the end of the eventtab table. 
   // The column before this one, will then be the start column
   // for the event.
   Found=FALSE;   
   ColIndex=*EOECheckCol;
   while (!Found && ColIndex<NumCols) {
      // Get the physical table-column.
      column=GetPhysicalCol(ColIndex, ScrollOffset, NumCols);
      // Is there an event in this column.
      if (EventTab(RowIndex, column)>=NOEVENT) {
         // We have found the column
         Found=TRUE;
         *EventStartCol=ColIndex-1;
      }
      // Move up one column
      ColIndex++;
   }
   // If the start of the event was not found inside
   // the table range, then we must declare the start
   // of the event to be in the last table column (The 
   // oldest column in the table).
   if (!Found) *EventStartCol=NumCols-1;

   return TRUE;

}




/***************************************************************************************/
/* Given a row number, and a pointer to a column(EventCol) that is a part of an event, */
/* this procedure finds the first column inside the event window that is a part of the */
/* event. The pointer given must point to a column inside the event-window.            */
/*                                                                                     */
/*                 * (EventCol)                                                        */
/* .....111|112222222|2222221111111111111...  An assumed row in the EventTab table.    */
/*            * (Returned column)                                                      */
/*                                                                                     */
/* The column numbers for the two column marked with an '*' will be returned.          */
/* The event window part of the table is enclosed between the '|' TTCHARacters.          */
/*                                                                                     */
/***************************************************************************************/
WORD FindEventStopColWithinEventwindow(WORD RowIndex, WORD EventCol, PWORD pTable, 
                                       WORD EventwinFirstCol, WORD EventwinLastCol, 
                                       WORD ScrollOffset, WORD NumCols)
{
   WORD ColIndex, column;

   ColIndex=EventCol;
   while (ColIndex>=EventwinFirstCol) {
      // Get the physical table-column.
      column=GetPhysicalCol(ColIndex, ScrollOffset, NumCols);
      // Is there an event in this column.
      if (EventTab(RowIndex, column)>=NOEVENT) return ColIndex+1;
      // Move left one column
      ColIndex--;
   }
   
   return EventwinFirstCol;
}




/*****************************************************************************/
/* Returnes the time accosiated with a certain column in the EventTab table. */
/*****************************************************************************/
VOID GetColumnTime(WORD Column, SYSTEMTIME *Time, SYSTEMTIME LastColTime, WORD NumCols)
{
   *Time=LastColTime;
   AddToTime(Time, (DOUBLE)NumCols-1-Column); 
}





/*****************************************************************************/
/* Checks if a triggerset refers to any nonexistent channels.                */
/*****************************************************************************/
INT CheckTriggersetChannels(TRIG_SET_CNF_FILE *TrigSetConf)
{
   BYTE Index;
   for (Index=NumRegisteredChannels;Index<MAX_NUM_OF_CHANNELS;Index++) {
      if (TrigSetConf->TrigChannels[Index]) return 1;
      if (TrigSetConf->DumpChannels[Index]) return 1;
   }

   return 0;
}




/*****************************************************************************/
/* Removes nonexisting channels from a triggerset.                           */
/*****************************************************************************/
VOID RemoveNonexistingChnlsFromTrigset(TRIG_SET_CNF_FILE *TrigSetConf) 
{
   BYTE Index;
   for (Index=NumRegisteredChannels;Index<MAX_NUM_OF_CHANNELS;Index++) {
      TrigSetConf->TrigChannels[Index]=FALSE;
      TrigSetConf->DumpChannels[Index]=FALSE;
   }
}

